// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/AccelerationControl.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ACCELERATION_CONTROL__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ACCELERATION_CONTROL__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/acceleration_control__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const AccelerationControl & msg,
  std::ostream & out)
{
  out << "{";
  // member: value
  {
    if (msg.value.size() == 0) {
      out << "value: []";
    } else {
      out << "value: [";
      size_t pending_items = msg.value.size();
      for (auto item : msg.value) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: bits_unused
  {
    out << "bits_unused: ";
    rosidl_generator_traits::value_to_yaml(msg.bits_unused, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const AccelerationControl & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: value
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.value.size() == 0) {
      out << "value: []\n";
    } else {
      out << "value:\n";
      for (auto item : msg.value) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: bits_unused
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "bits_unused: ";
    rosidl_generator_traits::value_to_yaml(msg.bits_unused, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const AccelerationControl & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::AccelerationControl & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::AccelerationControl & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::AccelerationControl>()
{
  return "etsi_its_cam_ts_msgs::msg::AccelerationControl";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::AccelerationControl>()
{
  return "etsi_its_cam_ts_msgs/msg/AccelerationControl";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::AccelerationControl>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::AccelerationControl>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::AccelerationControl>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ACCELERATION_CONTROL__TRAITS_HPP_
