// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/AdverseWeatherConditionExtremeWeatherConditionSubCauseCode.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ADVERSE_WEATHER_CONDITION_EXTREME_WEATHER_CONDITION_SUB_CAUSE_CODE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ADVERSE_WEATHER_CONDITION_EXTREME_WEATHER_CONDITION_SUB_CAUSE_CODE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__AdverseWeatherConditionExtremeWeatherConditionSubCauseCode__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__AdverseWeatherConditionExtremeWeatherConditionSubCauseCode__MAX = 255
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__AdverseWeatherConditionExtremeWeatherConditionSubCauseCode__UNAVAILABLE = 0
};

/// Constant 'STRONG_WINDS'.
enum
{
  etsi_its_cam_ts_msgs__msg__AdverseWeatherConditionExtremeWeatherConditionSubCauseCode__STRONG_WINDS = 1
};

/// Constant 'DAMAGING_HAIL'.
enum
{
  etsi_its_cam_ts_msgs__msg__AdverseWeatherConditionExtremeWeatherConditionSubCauseCode__DAMAGING_HAIL = 2
};

/// Constant 'HURRICANE'.
enum
{
  etsi_its_cam_ts_msgs__msg__AdverseWeatherConditionExtremeWeatherConditionSubCauseCode__HURRICANE = 3
};

/// Constant 'THUNDERSTORM'.
enum
{
  etsi_its_cam_ts_msgs__msg__AdverseWeatherConditionExtremeWeatherConditionSubCauseCode__THUNDERSTORM = 4
};

/// Constant 'TORNADO'.
enum
{
  etsi_its_cam_ts_msgs__msg__AdverseWeatherConditionExtremeWeatherConditionSubCauseCode__TORNADO = 5
};

/// Constant 'BLIZZARD'.
enum
{
  etsi_its_cam_ts_msgs__msg__AdverseWeatherConditionExtremeWeatherConditionSubCauseCode__BLIZZARD = 6
};

/// Struct defined in msg/AdverseWeatherConditionExtremeWeatherConditionSubCauseCode in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__AdverseWeatherConditionExtremeWeatherConditionSubCauseCode
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents the value of the sub cause codes of the @ref CauseCode `adverseWeatherCondition-ExtremeWeatherCondition`.
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 - `unavailable` - in case information on the type of extreme weather condition is unavailable,
  ///  * - 1 - `strongWinds` - in case the type of extreme weather condition is strong wind,
  ///  * - 2 - `damagingHail`- in case the type of extreme weather condition is damaging hail,
  ///  * - 3 - `hurricane`   - in case the type of extreme weather condition is hurricane,
  ///  * - 4 - `thunderstorm`- in case the type of extreme weather condition is thunderstorm,
  ///  * - 5 - `tornado`     - in case the type of extreme weather condition is tornado,
  ///  * - 6 - `blizzard`    - in case the type of extreme weather condition is blizzard.
  ///  * - 7-255             - are reserved for future usage.
  ///  *
  ///  * @category: Traffic information
  ///  * @revision: V1.3.1
  ///  */
  /// AdverseWeatherCondition-ExtremeWeatherConditionSubCauseCode ::= INTEGER {
  ///     unavailable  (0),
  ///     strongWinds  (1),
  ///     damagingHail (2),
  ///     hurricane    (3),
  ///     thunderstorm (4),
  ///     tornado      (5),
  ///     blizzard     (6)
  /// } (0..255)
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__AdverseWeatherConditionExtremeWeatherConditionSubCauseCode;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__AdverseWeatherConditionExtremeWeatherConditionSubCauseCode.
typedef struct etsi_its_cam_ts_msgs__msg__AdverseWeatherConditionExtremeWeatherConditionSubCauseCode__Sequence
{
  etsi_its_cam_ts_msgs__msg__AdverseWeatherConditionExtremeWeatherConditionSubCauseCode * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__AdverseWeatherConditionExtremeWeatherConditionSubCauseCode__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ADVERSE_WEATHER_CONDITION_EXTREME_WEATHER_CONDITION_SUB_CAUSE_CODE__STRUCT_H_
