// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cam_ts_msgs:msg/BasicContainer.idl
// generated code does not contain a copyright notice
#include "etsi_its_cam_ts_msgs/msg/detail/basic_container__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `station_type`
#include "etsi_its_cam_ts_msgs/msg/detail/traffic_participant_type__functions.h"
// Member `reference_position`
#include "etsi_its_cam_ts_msgs/msg/detail/reference_position_with_confidence__functions.h"

bool
etsi_its_cam_ts_msgs__msg__BasicContainer__init(etsi_its_cam_ts_msgs__msg__BasicContainer * msg)
{
  if (!msg) {
    return false;
  }
  // station_type
  if (!etsi_its_cam_ts_msgs__msg__TrafficParticipantType__init(&msg->station_type)) {
    etsi_its_cam_ts_msgs__msg__BasicContainer__fini(msg);
    return false;
  }
  // reference_position
  if (!etsi_its_cam_ts_msgs__msg__ReferencePositionWithConfidence__init(&msg->reference_position)) {
    etsi_its_cam_ts_msgs__msg__BasicContainer__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_cam_ts_msgs__msg__BasicContainer__fini(etsi_its_cam_ts_msgs__msg__BasicContainer * msg)
{
  if (!msg) {
    return;
  }
  // station_type
  etsi_its_cam_ts_msgs__msg__TrafficParticipantType__fini(&msg->station_type);
  // reference_position
  etsi_its_cam_ts_msgs__msg__ReferencePositionWithConfidence__fini(&msg->reference_position);
}

bool
etsi_its_cam_ts_msgs__msg__BasicContainer__are_equal(const etsi_its_cam_ts_msgs__msg__BasicContainer * lhs, const etsi_its_cam_ts_msgs__msg__BasicContainer * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // station_type
  if (!etsi_its_cam_ts_msgs__msg__TrafficParticipantType__are_equal(
      &(lhs->station_type), &(rhs->station_type)))
  {
    return false;
  }
  // reference_position
  if (!etsi_its_cam_ts_msgs__msg__ReferencePositionWithConfidence__are_equal(
      &(lhs->reference_position), &(rhs->reference_position)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__BasicContainer__copy(
  const etsi_its_cam_ts_msgs__msg__BasicContainer * input,
  etsi_its_cam_ts_msgs__msg__BasicContainer * output)
{
  if (!input || !output) {
    return false;
  }
  // station_type
  if (!etsi_its_cam_ts_msgs__msg__TrafficParticipantType__copy(
      &(input->station_type), &(output->station_type)))
  {
    return false;
  }
  // reference_position
  if (!etsi_its_cam_ts_msgs__msg__ReferencePositionWithConfidence__copy(
      &(input->reference_position), &(output->reference_position)))
  {
    return false;
  }
  return true;
}

etsi_its_cam_ts_msgs__msg__BasicContainer *
etsi_its_cam_ts_msgs__msg__BasicContainer__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__BasicContainer * msg = (etsi_its_cam_ts_msgs__msg__BasicContainer *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__BasicContainer), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cam_ts_msgs__msg__BasicContainer));
  bool success = etsi_its_cam_ts_msgs__msg__BasicContainer__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cam_ts_msgs__msg__BasicContainer__destroy(etsi_its_cam_ts_msgs__msg__BasicContainer * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cam_ts_msgs__msg__BasicContainer__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cam_ts_msgs__msg__BasicContainer__Sequence__init(etsi_its_cam_ts_msgs__msg__BasicContainer__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__BasicContainer * data = NULL;

  if (size) {
    data = (etsi_its_cam_ts_msgs__msg__BasicContainer *)allocator.zero_allocate(size, sizeof(etsi_its_cam_ts_msgs__msg__BasicContainer), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cam_ts_msgs__msg__BasicContainer__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cam_ts_msgs__msg__BasicContainer__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cam_ts_msgs__msg__BasicContainer__Sequence__fini(etsi_its_cam_ts_msgs__msg__BasicContainer__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cam_ts_msgs__msg__BasicContainer__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cam_ts_msgs__msg__BasicContainer__Sequence *
etsi_its_cam_ts_msgs__msg__BasicContainer__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__BasicContainer__Sequence * array = (etsi_its_cam_ts_msgs__msg__BasicContainer__Sequence *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__BasicContainer__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cam_ts_msgs__msg__BasicContainer__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cam_ts_msgs__msg__BasicContainer__Sequence__destroy(etsi_its_cam_ts_msgs__msg__BasicContainer__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cam_ts_msgs__msg__BasicContainer__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cam_ts_msgs__msg__BasicContainer__Sequence__are_equal(const etsi_its_cam_ts_msgs__msg__BasicContainer__Sequence * lhs, const etsi_its_cam_ts_msgs__msg__BasicContainer__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__BasicContainer__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__BasicContainer__Sequence__copy(
  const etsi_its_cam_ts_msgs__msg__BasicContainer__Sequence * input,
  etsi_its_cam_ts_msgs__msg__BasicContainer__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cam_ts_msgs__msg__BasicContainer);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cam_ts_msgs__msg__BasicContainer * data =
      (etsi_its_cam_ts_msgs__msg__BasicContainer *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cam_ts_msgs__msg__BasicContainer__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cam_ts_msgs__msg__BasicContainer__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__BasicContainer__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
