// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/BasicVehicleContainerHighFrequency.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__BASIC_VEHICLE_CONTAINER_HIGH_FREQUENCY__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__BASIC_VEHICLE_CONTAINER_HIGH_FREQUENCY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'heading'
#include "etsi_its_cam_ts_msgs/msg/detail/heading__struct.hpp"
// Member 'speed'
#include "etsi_its_cam_ts_msgs/msg/detail/speed__struct.hpp"
// Member 'drive_direction'
#include "etsi_its_cam_ts_msgs/msg/detail/drive_direction__struct.hpp"
// Member 'vehicle_length'
#include "etsi_its_cam_ts_msgs/msg/detail/vehicle_length__struct.hpp"
// Member 'vehicle_width'
#include "etsi_its_cam_ts_msgs/msg/detail/vehicle_width__struct.hpp"
// Member 'longitudinal_acceleration'
// Member 'lateral_acceleration'
// Member 'vertical_acceleration'
#include "etsi_its_cam_ts_msgs/msg/detail/acceleration_component__struct.hpp"
// Member 'curvature'
#include "etsi_its_cam_ts_msgs/msg/detail/curvature__struct.hpp"
// Member 'curvature_calculation_mode'
#include "etsi_its_cam_ts_msgs/msg/detail/curvature_calculation_mode__struct.hpp"
// Member 'yaw_rate'
#include "etsi_its_cam_ts_msgs/msg/detail/yaw_rate__struct.hpp"
// Member 'acceleration_control'
#include "etsi_its_cam_ts_msgs/msg/detail/acceleration_control__struct.hpp"
// Member 'lane_position'
#include "etsi_its_cam_ts_msgs/msg/detail/lane_position__struct.hpp"
// Member 'steering_wheel_angle'
#include "etsi_its_cam_ts_msgs/msg/detail/steering_wheel_angle__struct.hpp"
// Member 'performance_class'
#include "etsi_its_cam_ts_msgs/msg/detail/performance_class__struct.hpp"
// Member 'cen_dsrc_tolling_zone'
#include "etsi_its_cam_ts_msgs/msg/detail/cen_dsrc_tolling_zone__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__BasicVehicleContainerHighFrequency __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__BasicVehicleContainerHighFrequency __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct BasicVehicleContainerHighFrequency_
{
  using Type = BasicVehicleContainerHighFrequency_<ContainerAllocator>;

  explicit BasicVehicleContainerHighFrequency_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : heading(_init),
    speed(_init),
    drive_direction(_init),
    vehicle_length(_init),
    vehicle_width(_init),
    longitudinal_acceleration(_init),
    curvature(_init),
    curvature_calculation_mode(_init),
    yaw_rate(_init),
    acceleration_control(_init),
    lane_position(_init),
    steering_wheel_angle(_init),
    lateral_acceleration(_init),
    vertical_acceleration(_init),
    performance_class(_init),
    cen_dsrc_tolling_zone(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->acceleration_control_is_present = false;
      this->lane_position_is_present = false;
      this->steering_wheel_angle_is_present = false;
      this->lateral_acceleration_is_present = false;
      this->vertical_acceleration_is_present = false;
      this->performance_class_is_present = false;
      this->cen_dsrc_tolling_zone_is_present = false;
    }
  }

  explicit BasicVehicleContainerHighFrequency_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : heading(_alloc, _init),
    speed(_alloc, _init),
    drive_direction(_alloc, _init),
    vehicle_length(_alloc, _init),
    vehicle_width(_alloc, _init),
    longitudinal_acceleration(_alloc, _init),
    curvature(_alloc, _init),
    curvature_calculation_mode(_alloc, _init),
    yaw_rate(_alloc, _init),
    acceleration_control(_alloc, _init),
    lane_position(_alloc, _init),
    steering_wheel_angle(_alloc, _init),
    lateral_acceleration(_alloc, _init),
    vertical_acceleration(_alloc, _init),
    performance_class(_alloc, _init),
    cen_dsrc_tolling_zone(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->acceleration_control_is_present = false;
      this->lane_position_is_present = false;
      this->steering_wheel_angle_is_present = false;
      this->lateral_acceleration_is_present = false;
      this->vertical_acceleration_is_present = false;
      this->performance_class_is_present = false;
      this->cen_dsrc_tolling_zone_is_present = false;
    }
  }

  // field types and members
  using _heading_type =
    etsi_its_cam_ts_msgs::msg::Heading_<ContainerAllocator>;
  _heading_type heading;
  using _speed_type =
    etsi_its_cam_ts_msgs::msg::Speed_<ContainerAllocator>;
  _speed_type speed;
  using _drive_direction_type =
    etsi_its_cam_ts_msgs::msg::DriveDirection_<ContainerAllocator>;
  _drive_direction_type drive_direction;
  using _vehicle_length_type =
    etsi_its_cam_ts_msgs::msg::VehicleLength_<ContainerAllocator>;
  _vehicle_length_type vehicle_length;
  using _vehicle_width_type =
    etsi_its_cam_ts_msgs::msg::VehicleWidth_<ContainerAllocator>;
  _vehicle_width_type vehicle_width;
  using _longitudinal_acceleration_type =
    etsi_its_cam_ts_msgs::msg::AccelerationComponent_<ContainerAllocator>;
  _longitudinal_acceleration_type longitudinal_acceleration;
  using _curvature_type =
    etsi_its_cam_ts_msgs::msg::Curvature_<ContainerAllocator>;
  _curvature_type curvature;
  using _curvature_calculation_mode_type =
    etsi_its_cam_ts_msgs::msg::CurvatureCalculationMode_<ContainerAllocator>;
  _curvature_calculation_mode_type curvature_calculation_mode;
  using _yaw_rate_type =
    etsi_its_cam_ts_msgs::msg::YawRate_<ContainerAllocator>;
  _yaw_rate_type yaw_rate;
  using _acceleration_control_type =
    etsi_its_cam_ts_msgs::msg::AccelerationControl_<ContainerAllocator>;
  _acceleration_control_type acceleration_control;
  using _acceleration_control_is_present_type =
    bool;
  _acceleration_control_is_present_type acceleration_control_is_present;
  using _lane_position_type =
    etsi_its_cam_ts_msgs::msg::LanePosition_<ContainerAllocator>;
  _lane_position_type lane_position;
  using _lane_position_is_present_type =
    bool;
  _lane_position_is_present_type lane_position_is_present;
  using _steering_wheel_angle_type =
    etsi_its_cam_ts_msgs::msg::SteeringWheelAngle_<ContainerAllocator>;
  _steering_wheel_angle_type steering_wheel_angle;
  using _steering_wheel_angle_is_present_type =
    bool;
  _steering_wheel_angle_is_present_type steering_wheel_angle_is_present;
  using _lateral_acceleration_type =
    etsi_its_cam_ts_msgs::msg::AccelerationComponent_<ContainerAllocator>;
  _lateral_acceleration_type lateral_acceleration;
  using _lateral_acceleration_is_present_type =
    bool;
  _lateral_acceleration_is_present_type lateral_acceleration_is_present;
  using _vertical_acceleration_type =
    etsi_its_cam_ts_msgs::msg::AccelerationComponent_<ContainerAllocator>;
  _vertical_acceleration_type vertical_acceleration;
  using _vertical_acceleration_is_present_type =
    bool;
  _vertical_acceleration_is_present_type vertical_acceleration_is_present;
  using _performance_class_type =
    etsi_its_cam_ts_msgs::msg::PerformanceClass_<ContainerAllocator>;
  _performance_class_type performance_class;
  using _performance_class_is_present_type =
    bool;
  _performance_class_is_present_type performance_class_is_present;
  using _cen_dsrc_tolling_zone_type =
    etsi_its_cam_ts_msgs::msg::CenDsrcTollingZone_<ContainerAllocator>;
  _cen_dsrc_tolling_zone_type cen_dsrc_tolling_zone;
  using _cen_dsrc_tolling_zone_is_present_type =
    bool;
  _cen_dsrc_tolling_zone_is_present_type cen_dsrc_tolling_zone_is_present;

  // setters for named parameter idiom
  Type & set__heading(
    const etsi_its_cam_ts_msgs::msg::Heading_<ContainerAllocator> & _arg)
  {
    this->heading = _arg;
    return *this;
  }
  Type & set__speed(
    const etsi_its_cam_ts_msgs::msg::Speed_<ContainerAllocator> & _arg)
  {
    this->speed = _arg;
    return *this;
  }
  Type & set__drive_direction(
    const etsi_its_cam_ts_msgs::msg::DriveDirection_<ContainerAllocator> & _arg)
  {
    this->drive_direction = _arg;
    return *this;
  }
  Type & set__vehicle_length(
    const etsi_its_cam_ts_msgs::msg::VehicleLength_<ContainerAllocator> & _arg)
  {
    this->vehicle_length = _arg;
    return *this;
  }
  Type & set__vehicle_width(
    const etsi_its_cam_ts_msgs::msg::VehicleWidth_<ContainerAllocator> & _arg)
  {
    this->vehicle_width = _arg;
    return *this;
  }
  Type & set__longitudinal_acceleration(
    const etsi_its_cam_ts_msgs::msg::AccelerationComponent_<ContainerAllocator> & _arg)
  {
    this->longitudinal_acceleration = _arg;
    return *this;
  }
  Type & set__curvature(
    const etsi_its_cam_ts_msgs::msg::Curvature_<ContainerAllocator> & _arg)
  {
    this->curvature = _arg;
    return *this;
  }
  Type & set__curvature_calculation_mode(
    const etsi_its_cam_ts_msgs::msg::CurvatureCalculationMode_<ContainerAllocator> & _arg)
  {
    this->curvature_calculation_mode = _arg;
    return *this;
  }
  Type & set__yaw_rate(
    const etsi_its_cam_ts_msgs::msg::YawRate_<ContainerAllocator> & _arg)
  {
    this->yaw_rate = _arg;
    return *this;
  }
  Type & set__acceleration_control(
    const etsi_its_cam_ts_msgs::msg::AccelerationControl_<ContainerAllocator> & _arg)
  {
    this->acceleration_control = _arg;
    return *this;
  }
  Type & set__acceleration_control_is_present(
    const bool & _arg)
  {
    this->acceleration_control_is_present = _arg;
    return *this;
  }
  Type & set__lane_position(
    const etsi_its_cam_ts_msgs::msg::LanePosition_<ContainerAllocator> & _arg)
  {
    this->lane_position = _arg;
    return *this;
  }
  Type & set__lane_position_is_present(
    const bool & _arg)
  {
    this->lane_position_is_present = _arg;
    return *this;
  }
  Type & set__steering_wheel_angle(
    const etsi_its_cam_ts_msgs::msg::SteeringWheelAngle_<ContainerAllocator> & _arg)
  {
    this->steering_wheel_angle = _arg;
    return *this;
  }
  Type & set__steering_wheel_angle_is_present(
    const bool & _arg)
  {
    this->steering_wheel_angle_is_present = _arg;
    return *this;
  }
  Type & set__lateral_acceleration(
    const etsi_its_cam_ts_msgs::msg::AccelerationComponent_<ContainerAllocator> & _arg)
  {
    this->lateral_acceleration = _arg;
    return *this;
  }
  Type & set__lateral_acceleration_is_present(
    const bool & _arg)
  {
    this->lateral_acceleration_is_present = _arg;
    return *this;
  }
  Type & set__vertical_acceleration(
    const etsi_its_cam_ts_msgs::msg::AccelerationComponent_<ContainerAllocator> & _arg)
  {
    this->vertical_acceleration = _arg;
    return *this;
  }
  Type & set__vertical_acceleration_is_present(
    const bool & _arg)
  {
    this->vertical_acceleration_is_present = _arg;
    return *this;
  }
  Type & set__performance_class(
    const etsi_its_cam_ts_msgs::msg::PerformanceClass_<ContainerAllocator> & _arg)
  {
    this->performance_class = _arg;
    return *this;
  }
  Type & set__performance_class_is_present(
    const bool & _arg)
  {
    this->performance_class_is_present = _arg;
    return *this;
  }
  Type & set__cen_dsrc_tolling_zone(
    const etsi_its_cam_ts_msgs::msg::CenDsrcTollingZone_<ContainerAllocator> & _arg)
  {
    this->cen_dsrc_tolling_zone = _arg;
    return *this;
  }
  Type & set__cen_dsrc_tolling_zone_is_present(
    const bool & _arg)
  {
    this->cen_dsrc_tolling_zone_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::BasicVehicleContainerHighFrequency_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::BasicVehicleContainerHighFrequency_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::BasicVehicleContainerHighFrequency_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::BasicVehicleContainerHighFrequency_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::BasicVehicleContainerHighFrequency_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::BasicVehicleContainerHighFrequency_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::BasicVehicleContainerHighFrequency_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::BasicVehicleContainerHighFrequency_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::BasicVehicleContainerHighFrequency_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::BasicVehicleContainerHighFrequency_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__BasicVehicleContainerHighFrequency
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::BasicVehicleContainerHighFrequency_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__BasicVehicleContainerHighFrequency
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::BasicVehicleContainerHighFrequency_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const BasicVehicleContainerHighFrequency_ & other) const
  {
    if (this->heading != other.heading) {
      return false;
    }
    if (this->speed != other.speed) {
      return false;
    }
    if (this->drive_direction != other.drive_direction) {
      return false;
    }
    if (this->vehicle_length != other.vehicle_length) {
      return false;
    }
    if (this->vehicle_width != other.vehicle_width) {
      return false;
    }
    if (this->longitudinal_acceleration != other.longitudinal_acceleration) {
      return false;
    }
    if (this->curvature != other.curvature) {
      return false;
    }
    if (this->curvature_calculation_mode != other.curvature_calculation_mode) {
      return false;
    }
    if (this->yaw_rate != other.yaw_rate) {
      return false;
    }
    if (this->acceleration_control != other.acceleration_control) {
      return false;
    }
    if (this->acceleration_control_is_present != other.acceleration_control_is_present) {
      return false;
    }
    if (this->lane_position != other.lane_position) {
      return false;
    }
    if (this->lane_position_is_present != other.lane_position_is_present) {
      return false;
    }
    if (this->steering_wheel_angle != other.steering_wheel_angle) {
      return false;
    }
    if (this->steering_wheel_angle_is_present != other.steering_wheel_angle_is_present) {
      return false;
    }
    if (this->lateral_acceleration != other.lateral_acceleration) {
      return false;
    }
    if (this->lateral_acceleration_is_present != other.lateral_acceleration_is_present) {
      return false;
    }
    if (this->vertical_acceleration != other.vertical_acceleration) {
      return false;
    }
    if (this->vertical_acceleration_is_present != other.vertical_acceleration_is_present) {
      return false;
    }
    if (this->performance_class != other.performance_class) {
      return false;
    }
    if (this->performance_class_is_present != other.performance_class_is_present) {
      return false;
    }
    if (this->cen_dsrc_tolling_zone != other.cen_dsrc_tolling_zone) {
      return false;
    }
    if (this->cen_dsrc_tolling_zone_is_present != other.cen_dsrc_tolling_zone_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const BasicVehicleContainerHighFrequency_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct BasicVehicleContainerHighFrequency_

// alias to use template instance with default allocator
using BasicVehicleContainerHighFrequency =
  etsi_its_cam_ts_msgs::msg::BasicVehicleContainerHighFrequency_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__BASIC_VEHICLE_CONTAINER_HIGH_FREQUENCY__STRUCT_HPP_
