// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/BasicVehicleContainerLowFrequency.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__BASIC_VEHICLE_CONTAINER_LOW_FREQUENCY__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__BASIC_VEHICLE_CONTAINER_LOW_FREQUENCY__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/basic_vehicle_container_low_frequency__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'vehicle_role'
#include "etsi_its_cam_ts_msgs/msg/detail/vehicle_role__traits.hpp"
// Member 'exterior_lights'
#include "etsi_its_cam_ts_msgs/msg/detail/exterior_lights__traits.hpp"
// Member 'path_history'
#include "etsi_its_cam_ts_msgs/msg/detail/path__traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const BasicVehicleContainerLowFrequency & msg,
  std::ostream & out)
{
  out << "{";
  // member: vehicle_role
  {
    out << "vehicle_role: ";
    to_flow_style_yaml(msg.vehicle_role, out);
    out << ", ";
  }

  // member: exterior_lights
  {
    out << "exterior_lights: ";
    to_flow_style_yaml(msg.exterior_lights, out);
    out << ", ";
  }

  // member: path_history
  {
    out << "path_history: ";
    to_flow_style_yaml(msg.path_history, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const BasicVehicleContainerLowFrequency & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: vehicle_role
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vehicle_role:\n";
    to_block_style_yaml(msg.vehicle_role, out, indentation + 2);
  }

  // member: exterior_lights
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "exterior_lights:\n";
    to_block_style_yaml(msg.exterior_lights, out, indentation + 2);
  }

  // member: path_history
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "path_history:\n";
    to_block_style_yaml(msg.path_history, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const BasicVehicleContainerLowFrequency & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::BasicVehicleContainerLowFrequency & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::BasicVehicleContainerLowFrequency & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::BasicVehicleContainerLowFrequency>()
{
  return "etsi_its_cam_ts_msgs::msg::BasicVehicleContainerLowFrequency";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::BasicVehicleContainerLowFrequency>()
{
  return "etsi_its_cam_ts_msgs/msg/BasicVehicleContainerLowFrequency";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::BasicVehicleContainerLowFrequency>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_ts_msgs::msg::ExteriorLights>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::Path>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::VehicleRole>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::BasicVehicleContainerLowFrequency>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_ts_msgs::msg::ExteriorLights>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::Path>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::VehicleRole>::value> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::BasicVehicleContainerLowFrequency>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__BASIC_VEHICLE_CONTAINER_LOW_FREQUENCY__TRAITS_HPP_
