// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/CAM.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CAM__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CAM__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "etsi_its_cam_ts_msgs/msg/detail/its_pdu_header__struct.hpp"
// Member 'cam'
#include "etsi_its_cam_ts_msgs/msg/detail/cam_payload__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__CAM __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__CAM __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct CAM_
{
  using Type = CAM_<ContainerAllocator>;

  explicit CAM_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    cam(_init)
  {
    (void)_init;
  }

  explicit CAM_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    cam(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    etsi_its_cam_ts_msgs::msg::ItsPduHeader_<ContainerAllocator>;
  _header_type header;
  using _cam_type =
    etsi_its_cam_ts_msgs::msg::CamPayload_<ContainerAllocator>;
  _cam_type cam;

  // setters for named parameter idiom
  Type & set__header(
    const etsi_its_cam_ts_msgs::msg::ItsPduHeader_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__cam(
    const etsi_its_cam_ts_msgs::msg::CamPayload_<ContainerAllocator> & _arg)
  {
    this->cam = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::CAM_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::CAM_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::CAM_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::CAM_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::CAM_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::CAM_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::CAM_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::CAM_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::CAM_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::CAM_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__CAM
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::CAM_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__CAM
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::CAM_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CAM_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->cam != other.cam) {
      return false;
    }
    return true;
  }
  bool operator!=(const CAM_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CAM_

// alias to use template instance with default allocator
using CAM =
  etsi_its_cam_ts_msgs::msg::CAM_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CAM__STRUCT_HPP_
