// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/CamParameters.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CAM_PARAMETERS__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CAM_PARAMETERS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'basic_container'
#include "etsi_its_cam_ts_msgs/msg/detail/basic_container__struct.h"
// Member 'high_frequency_container'
#include "etsi_its_cam_ts_msgs/msg/detail/high_frequency_container__struct.h"
// Member 'low_frequency_container'
#include "etsi_its_cam_ts_msgs/msg/detail/low_frequency_container__struct.h"
// Member 'special_vehicle_container'
#include "etsi_its_cam_ts_msgs/msg/detail/special_vehicle_container__struct.h"

/// Struct defined in msg/CamParameters in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__CamParameters
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  /// * @field basicContainer: the mandatory basic container of the CAM.
  /// *
  /// * @field highFrequencyContainer: the mandatory container represents the high frequency of the CAM.
  /// *
  /// * @field lowFrequencyContainer: the optional conatainer represents the low frequency of the CAM.
  /// *
  /// * @field specialVehicleContainer: The special container of the CAM shall be present as defined in clause 6.1.2.
  /// * The content of the container shall be set according to the value of the vehicleRole component as specified in Table 5.
  /// */
  /// CamParameters ::= SEQUENCE {
  ///  basicContainer           BasicContainer,
  ///  highFrequencyContainer   HighFrequencyContainer,
  ///  lowFrequencyContainer    LowFrequencyContainer OPTIONAL,
  ///  specialVehicleContainer  SpecialVehicleContainer OPTIONAL,
  ///  ...
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cam_ts_msgs__msg__BasicContainer basic_container;
  etsi_its_cam_ts_msgs__msg__HighFrequencyContainer high_frequency_container;
  etsi_its_cam_ts_msgs__msg__LowFrequencyContainer low_frequency_container;
  bool low_frequency_container_is_present;
  etsi_its_cam_ts_msgs__msg__SpecialVehicleContainer special_vehicle_container;
  bool special_vehicle_container_is_present;
} etsi_its_cam_ts_msgs__msg__CamParameters;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__CamParameters.
typedef struct etsi_its_cam_ts_msgs__msg__CamParameters__Sequence
{
  etsi_its_cam_ts_msgs__msg__CamParameters * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__CamParameters__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CAM_PARAMETERS__STRUCT_H_
