// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from etsi_its_cam_ts_msgs:msg/CauseCodeV2.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CAUSE_CODE_V2__FUNCTIONS_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CAUSE_CODE_V2__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "etsi_its_cam_ts_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "etsi_its_cam_ts_msgs/msg/detail/cause_code_v2__struct.h"

/// Initialize msg/CauseCodeV2 message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * etsi_its_cam_ts_msgs__msg__CauseCodeV2
 * )) before or use
 * etsi_its_cam_ts_msgs__msg__CauseCodeV2__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
bool
etsi_its_cam_ts_msgs__msg__CauseCodeV2__init(etsi_its_cam_ts_msgs__msg__CauseCodeV2 * msg);

/// Finalize msg/CauseCodeV2 message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
void
etsi_its_cam_ts_msgs__msg__CauseCodeV2__fini(etsi_its_cam_ts_msgs__msg__CauseCodeV2 * msg);

/// Create msg/CauseCodeV2 message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * etsi_its_cam_ts_msgs__msg__CauseCodeV2__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
etsi_its_cam_ts_msgs__msg__CauseCodeV2 *
etsi_its_cam_ts_msgs__msg__CauseCodeV2__create();

/// Destroy msg/CauseCodeV2 message.
/**
 * It calls
 * etsi_its_cam_ts_msgs__msg__CauseCodeV2__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
void
etsi_its_cam_ts_msgs__msg__CauseCodeV2__destroy(etsi_its_cam_ts_msgs__msg__CauseCodeV2 * msg);

/// Check for msg/CauseCodeV2 message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
bool
etsi_its_cam_ts_msgs__msg__CauseCodeV2__are_equal(const etsi_its_cam_ts_msgs__msg__CauseCodeV2 * lhs, const etsi_its_cam_ts_msgs__msg__CauseCodeV2 * rhs);

/// Copy a msg/CauseCodeV2 message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
bool
etsi_its_cam_ts_msgs__msg__CauseCodeV2__copy(
  const etsi_its_cam_ts_msgs__msg__CauseCodeV2 * input,
  etsi_its_cam_ts_msgs__msg__CauseCodeV2 * output);

/// Initialize array of msg/CauseCodeV2 messages.
/**
 * It allocates the memory for the number of elements and calls
 * etsi_its_cam_ts_msgs__msg__CauseCodeV2__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
bool
etsi_its_cam_ts_msgs__msg__CauseCodeV2__Sequence__init(etsi_its_cam_ts_msgs__msg__CauseCodeV2__Sequence * array, size_t size);

/// Finalize array of msg/CauseCodeV2 messages.
/**
 * It calls
 * etsi_its_cam_ts_msgs__msg__CauseCodeV2__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
void
etsi_its_cam_ts_msgs__msg__CauseCodeV2__Sequence__fini(etsi_its_cam_ts_msgs__msg__CauseCodeV2__Sequence * array);

/// Create array of msg/CauseCodeV2 messages.
/**
 * It allocates the memory for the array and calls
 * etsi_its_cam_ts_msgs__msg__CauseCodeV2__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
etsi_its_cam_ts_msgs__msg__CauseCodeV2__Sequence *
etsi_its_cam_ts_msgs__msg__CauseCodeV2__Sequence__create(size_t size);

/// Destroy array of msg/CauseCodeV2 messages.
/**
 * It calls
 * etsi_its_cam_ts_msgs__msg__CauseCodeV2__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
void
etsi_its_cam_ts_msgs__msg__CauseCodeV2__Sequence__destroy(etsi_its_cam_ts_msgs__msg__CauseCodeV2__Sequence * array);

/// Check for msg/CauseCodeV2 message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
bool
etsi_its_cam_ts_msgs__msg__CauseCodeV2__Sequence__are_equal(const etsi_its_cam_ts_msgs__msg__CauseCodeV2__Sequence * lhs, const etsi_its_cam_ts_msgs__msg__CauseCodeV2__Sequence * rhs);

/// Copy an array of msg/CauseCodeV2 messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
bool
etsi_its_cam_ts_msgs__msg__CauseCodeV2__Sequence__copy(
  const etsi_its_cam_ts_msgs__msg__CauseCodeV2__Sequence * input,
  etsi_its_cam_ts_msgs__msg__CauseCodeV2__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CAUSE_CODE_V2__FUNCTIONS_H_
