// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cam_ts_msgs:msg/ClosedLanes.idl
// generated code does not contain a copyright notice
#include "etsi_its_cam_ts_msgs/msg/detail/closed_lanes__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `innerhard_shoulder_status`
// Member `outerhard_shoulder_status`
#include "etsi_its_cam_ts_msgs/msg/detail/hard_shoulder_status__functions.h"
// Member `driving_lane_status`
#include "etsi_its_cam_ts_msgs/msg/detail/driving_lane_status__functions.h"

bool
etsi_its_cam_ts_msgs__msg__ClosedLanes__init(etsi_its_cam_ts_msgs__msg__ClosedLanes * msg)
{
  if (!msg) {
    return false;
  }
  // innerhard_shoulder_status
  if (!etsi_its_cam_ts_msgs__msg__HardShoulderStatus__init(&msg->innerhard_shoulder_status)) {
    etsi_its_cam_ts_msgs__msg__ClosedLanes__fini(msg);
    return false;
  }
  // innerhard_shoulder_status_is_present
  // outerhard_shoulder_status
  if (!etsi_its_cam_ts_msgs__msg__HardShoulderStatus__init(&msg->outerhard_shoulder_status)) {
    etsi_its_cam_ts_msgs__msg__ClosedLanes__fini(msg);
    return false;
  }
  // outerhard_shoulder_status_is_present
  // driving_lane_status
  if (!etsi_its_cam_ts_msgs__msg__DrivingLaneStatus__init(&msg->driving_lane_status)) {
    etsi_its_cam_ts_msgs__msg__ClosedLanes__fini(msg);
    return false;
  }
  // driving_lane_status_is_present
  return true;
}

void
etsi_its_cam_ts_msgs__msg__ClosedLanes__fini(etsi_its_cam_ts_msgs__msg__ClosedLanes * msg)
{
  if (!msg) {
    return;
  }
  // innerhard_shoulder_status
  etsi_its_cam_ts_msgs__msg__HardShoulderStatus__fini(&msg->innerhard_shoulder_status);
  // innerhard_shoulder_status_is_present
  // outerhard_shoulder_status
  etsi_its_cam_ts_msgs__msg__HardShoulderStatus__fini(&msg->outerhard_shoulder_status);
  // outerhard_shoulder_status_is_present
  // driving_lane_status
  etsi_its_cam_ts_msgs__msg__DrivingLaneStatus__fini(&msg->driving_lane_status);
  // driving_lane_status_is_present
}

bool
etsi_its_cam_ts_msgs__msg__ClosedLanes__are_equal(const etsi_its_cam_ts_msgs__msg__ClosedLanes * lhs, const etsi_its_cam_ts_msgs__msg__ClosedLanes * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // innerhard_shoulder_status
  if (!etsi_its_cam_ts_msgs__msg__HardShoulderStatus__are_equal(
      &(lhs->innerhard_shoulder_status), &(rhs->innerhard_shoulder_status)))
  {
    return false;
  }
  // innerhard_shoulder_status_is_present
  if (lhs->innerhard_shoulder_status_is_present != rhs->innerhard_shoulder_status_is_present) {
    return false;
  }
  // outerhard_shoulder_status
  if (!etsi_its_cam_ts_msgs__msg__HardShoulderStatus__are_equal(
      &(lhs->outerhard_shoulder_status), &(rhs->outerhard_shoulder_status)))
  {
    return false;
  }
  // outerhard_shoulder_status_is_present
  if (lhs->outerhard_shoulder_status_is_present != rhs->outerhard_shoulder_status_is_present) {
    return false;
  }
  // driving_lane_status
  if (!etsi_its_cam_ts_msgs__msg__DrivingLaneStatus__are_equal(
      &(lhs->driving_lane_status), &(rhs->driving_lane_status)))
  {
    return false;
  }
  // driving_lane_status_is_present
  if (lhs->driving_lane_status_is_present != rhs->driving_lane_status_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__ClosedLanes__copy(
  const etsi_its_cam_ts_msgs__msg__ClosedLanes * input,
  etsi_its_cam_ts_msgs__msg__ClosedLanes * output)
{
  if (!input || !output) {
    return false;
  }
  // innerhard_shoulder_status
  if (!etsi_its_cam_ts_msgs__msg__HardShoulderStatus__copy(
      &(input->innerhard_shoulder_status), &(output->innerhard_shoulder_status)))
  {
    return false;
  }
  // innerhard_shoulder_status_is_present
  output->innerhard_shoulder_status_is_present = input->innerhard_shoulder_status_is_present;
  // outerhard_shoulder_status
  if (!etsi_its_cam_ts_msgs__msg__HardShoulderStatus__copy(
      &(input->outerhard_shoulder_status), &(output->outerhard_shoulder_status)))
  {
    return false;
  }
  // outerhard_shoulder_status_is_present
  output->outerhard_shoulder_status_is_present = input->outerhard_shoulder_status_is_present;
  // driving_lane_status
  if (!etsi_its_cam_ts_msgs__msg__DrivingLaneStatus__copy(
      &(input->driving_lane_status), &(output->driving_lane_status)))
  {
    return false;
  }
  // driving_lane_status_is_present
  output->driving_lane_status_is_present = input->driving_lane_status_is_present;
  return true;
}

etsi_its_cam_ts_msgs__msg__ClosedLanes *
etsi_its_cam_ts_msgs__msg__ClosedLanes__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__ClosedLanes * msg = (etsi_its_cam_ts_msgs__msg__ClosedLanes *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__ClosedLanes), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cam_ts_msgs__msg__ClosedLanes));
  bool success = etsi_its_cam_ts_msgs__msg__ClosedLanes__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cam_ts_msgs__msg__ClosedLanes__destroy(etsi_its_cam_ts_msgs__msg__ClosedLanes * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cam_ts_msgs__msg__ClosedLanes__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cam_ts_msgs__msg__ClosedLanes__Sequence__init(etsi_its_cam_ts_msgs__msg__ClosedLanes__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__ClosedLanes * data = NULL;

  if (size) {
    data = (etsi_its_cam_ts_msgs__msg__ClosedLanes *)allocator.zero_allocate(size, sizeof(etsi_its_cam_ts_msgs__msg__ClosedLanes), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cam_ts_msgs__msg__ClosedLanes__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cam_ts_msgs__msg__ClosedLanes__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cam_ts_msgs__msg__ClosedLanes__Sequence__fini(etsi_its_cam_ts_msgs__msg__ClosedLanes__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cam_ts_msgs__msg__ClosedLanes__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cam_ts_msgs__msg__ClosedLanes__Sequence *
etsi_its_cam_ts_msgs__msg__ClosedLanes__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__ClosedLanes__Sequence * array = (etsi_its_cam_ts_msgs__msg__ClosedLanes__Sequence *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__ClosedLanes__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cam_ts_msgs__msg__ClosedLanes__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cam_ts_msgs__msg__ClosedLanes__Sequence__destroy(etsi_its_cam_ts_msgs__msg__ClosedLanes__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cam_ts_msgs__msg__ClosedLanes__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cam_ts_msgs__msg__ClosedLanes__Sequence__are_equal(const etsi_its_cam_ts_msgs__msg__ClosedLanes__Sequence * lhs, const etsi_its_cam_ts_msgs__msg__ClosedLanes__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__ClosedLanes__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__ClosedLanes__Sequence__copy(
  const etsi_its_cam_ts_msgs__msg__ClosedLanes__Sequence * input,
  etsi_its_cam_ts_msgs__msg__ClosedLanes__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cam_ts_msgs__msg__ClosedLanes);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cam_ts_msgs__msg__ClosedLanes * data =
      (etsi_its_cam_ts_msgs__msg__ClosedLanes *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cam_ts_msgs__msg__ClosedLanes__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cam_ts_msgs__msg__ClosedLanes__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__ClosedLanes__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
