// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/CollisionRiskSubCauseCode.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__COLLISION_RISK_SUB_CAUSE_CODE__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__COLLISION_RISK_SUB_CAUSE_CODE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__CollisionRiskSubCauseCode __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__CollisionRiskSubCauseCode __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct CollisionRiskSubCauseCode_
{
  using Type = CollisionRiskSubCauseCode_<ContainerAllocator>;

  explicit CollisionRiskSubCauseCode_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  explicit CollisionRiskSubCauseCode_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  // field types and members
  using _value_type =
    uint8_t;
  _value_type value;

  // setters for named parameter idiom
  Type & set__value(
    const uint8_t & _arg)
  {
    this->value = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t MIN =
    0u;
  static constexpr uint8_t MAX =
    255u;
  static constexpr uint8_t UNAVAILABLE =
    0u;
  static constexpr uint8_t LONGITUDINAL_COLLISION_RISK =
    1u;
  static constexpr uint8_t CROSSING_COLLISION_RISK =
    2u;
  static constexpr uint8_t LATERAL_COLLISION_RISK =
    3u;
  static constexpr uint8_t VULNERABLE_ROAD_USER =
    4u;
  static constexpr uint8_t COLLISION_RISK_WITH_PEDESTRIAN =
    5u;
  static constexpr uint8_t COLLISION_RISK_WITH_CYCLIST =
    6u;
  static constexpr uint8_t COLLISION_RISK_WITH_MOTOR_VEHICLE =
    7u;

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::CollisionRiskSubCauseCode_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::CollisionRiskSubCauseCode_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::CollisionRiskSubCauseCode_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::CollisionRiskSubCauseCode_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::CollisionRiskSubCauseCode_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::CollisionRiskSubCauseCode_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::CollisionRiskSubCauseCode_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::CollisionRiskSubCauseCode_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::CollisionRiskSubCauseCode_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::CollisionRiskSubCauseCode_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__CollisionRiskSubCauseCode
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::CollisionRiskSubCauseCode_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__CollisionRiskSubCauseCode
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::CollisionRiskSubCauseCode_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CollisionRiskSubCauseCode_ & other) const
  {
    if (this->value != other.value) {
      return false;
    }
    return true;
  }
  bool operator!=(const CollisionRiskSubCauseCode_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CollisionRiskSubCauseCode_

// alias to use template instance with default allocator
using CollisionRiskSubCauseCode =
  etsi_its_cam_ts_msgs::msg::CollisionRiskSubCauseCode_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CollisionRiskSubCauseCode_<ContainerAllocator>::MIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CollisionRiskSubCauseCode_<ContainerAllocator>::MAX;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CollisionRiskSubCauseCode_<ContainerAllocator>::UNAVAILABLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CollisionRiskSubCauseCode_<ContainerAllocator>::LONGITUDINAL_COLLISION_RISK;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CollisionRiskSubCauseCode_<ContainerAllocator>::CROSSING_COLLISION_RISK;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CollisionRiskSubCauseCode_<ContainerAllocator>::LATERAL_COLLISION_RISK;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CollisionRiskSubCauseCode_<ContainerAllocator>::VULNERABLE_ROAD_USER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CollisionRiskSubCauseCode_<ContainerAllocator>::COLLISION_RISK_WITH_PEDESTRIAN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CollisionRiskSubCauseCode_<ContainerAllocator>::COLLISION_RISK_WITH_CYCLIST;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CollisionRiskSubCauseCode_<ContainerAllocator>::COLLISION_RISK_WITH_MOTOR_VEHICLE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__COLLISION_RISK_SUB_CAUSE_CODE__STRUCT_HPP_
