// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/Curvature.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CURVATURE__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CURVATURE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'curvature_value'
#include "etsi_its_cam_ts_msgs/msg/detail/curvature_value__struct.hpp"
// Member 'curvature_confidence'
#include "etsi_its_cam_ts_msgs/msg/detail/curvature_confidence__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__Curvature __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__Curvature __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Curvature_
{
  using Type = Curvature_<ContainerAllocator>;

  explicit Curvature_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : curvature_value(_init),
    curvature_confidence(_init)
  {
    (void)_init;
  }

  explicit Curvature_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : curvature_value(_alloc, _init),
    curvature_confidence(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _curvature_value_type =
    etsi_its_cam_ts_msgs::msg::CurvatureValue_<ContainerAllocator>;
  _curvature_value_type curvature_value;
  using _curvature_confidence_type =
    etsi_its_cam_ts_msgs::msg::CurvatureConfidence_<ContainerAllocator>;
  _curvature_confidence_type curvature_confidence;

  // setters for named parameter idiom
  Type & set__curvature_value(
    const etsi_its_cam_ts_msgs::msg::CurvatureValue_<ContainerAllocator> & _arg)
  {
    this->curvature_value = _arg;
    return *this;
  }
  Type & set__curvature_confidence(
    const etsi_its_cam_ts_msgs::msg::CurvatureConfidence_<ContainerAllocator> & _arg)
  {
    this->curvature_confidence = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::Curvature_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::Curvature_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::Curvature_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::Curvature_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::Curvature_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::Curvature_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::Curvature_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::Curvature_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::Curvature_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::Curvature_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__Curvature
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::Curvature_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__Curvature
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::Curvature_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Curvature_ & other) const
  {
    if (this->curvature_value != other.curvature_value) {
      return false;
    }
    if (this->curvature_confidence != other.curvature_confidence) {
      return false;
    }
    return true;
  }
  bool operator!=(const Curvature_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Curvature_

// alias to use template instance with default allocator
using Curvature =
  etsi_its_cam_ts_msgs::msg::Curvature_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CURVATURE__STRUCT_HPP_
