// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/DangerousGoodsBasic.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__DANGEROUS_GOODS_BASIC__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__DANGEROUS_GOODS_BASIC__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'EXPLOSIVES1'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic__EXPLOSIVES1 = 0
};

/// Constant 'EXPLOSIVES2'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic__EXPLOSIVES2 = 1
};

/// Constant 'EXPLOSIVES3'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic__EXPLOSIVES3 = 2
};

/// Constant 'EXPLOSIVES4'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic__EXPLOSIVES4 = 3
};

/// Constant 'EXPLOSIVES5'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic__EXPLOSIVES5 = 4
};

/// Constant 'EXPLOSIVES6'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic__EXPLOSIVES6 = 5
};

/// Constant 'FLAMMABLE_GASES'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic__FLAMMABLE_GASES = 6
};

/// Constant 'NON_FLAMMABLE_GASES'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic__NON_FLAMMABLE_GASES = 7
};

/// Constant 'TOXIC_GASES'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic__TOXIC_GASES = 8
};

/// Constant 'FLAMMABLE_LIQUIDS'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic__FLAMMABLE_LIQUIDS = 9
};

/// Constant 'FLAMMABLE_SOLIDS'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic__FLAMMABLE_SOLIDS = 10
};

/// Constant 'SUBSTANCES_LIABLE_TO_SPONTANEOUS_COMBUSTION'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic__SUBSTANCES_LIABLE_TO_SPONTANEOUS_COMBUSTION = 11
};

/// Constant 'SUBSTANCES_EMITTING_FLAMMABLE_GASES_UPON_CONTACT_WITH_WATER'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic__SUBSTANCES_EMITTING_FLAMMABLE_GASES_UPON_CONTACT_WITH_WATER = 12
};

/// Constant 'OXIDIZING_SUBSTANCES'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic__OXIDIZING_SUBSTANCES = 13
};

/// Constant 'ORGANIC_PEROXIDES'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic__ORGANIC_PEROXIDES = 14
};

/// Constant 'TOXIC_SUBSTANCES'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic__TOXIC_SUBSTANCES = 15
};

/// Constant 'INFECTIOUS_SUBSTANCES'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic__INFECTIOUS_SUBSTANCES = 16
};

/// Constant 'RADIOACTIVE_MATERIAL'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic__RADIOACTIVE_MATERIAL = 17
};

/// Constant 'CORROSIVE_SUBSTANCES'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic__CORROSIVE_SUBSTANCES = 18
};

/// Constant 'MISCELLANEOUS_DANGEROUS_SUBSTANCES'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic__MISCELLANEOUS_DANGEROUS_SUBSTANCES = 19
};

/// Struct defined in msg/DangerousGoodsBasic in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates the type of the dangerous goods being carried by a heavy vehicle.
  ///  * The value is assigned according to `class` and `division` definitions of dangerous goods as specified in part II,
  ///  * chapter 2.1.1.1 of European Agreement concerning the International Carriage of Dangerous Goods by Road.
  ///  *
  ///  *
  ///  * @category Vehicle information
  ///  * @revision: V1.3.1
  ///  */
  /// DangerousGoodsBasic::= ENUMERATED {
  ///     explosives1                                          (0),
  ///     explosives2                                          (1),
  ///     explosives3                                          (2),
  ///     explosives4                                          (3),
  ///     explosives5                                          (4),
  ///     explosives6                                          (5),
  ///     flammableGases                                       (6),
  ///     nonFlammableGases                                    (7),
  ///     toxicGases                                           (8),
  ///     flammableLiquids                                     (9),
  ///     flammableSolids                                      (10),
  ///     substancesLiableToSpontaneousCombustion              (11),
  ///     substancesEmittingFlammableGasesUponContactWithWater (12),
  ///     oxidizingSubstances                                  (13),
  ///     organicPeroxides                                     (14),
  ///     toxicSubstances                                      (15),
  ///     infectiousSubstances                                 (16),
  ///     radioactiveMaterial                                  (17),
  ///     corrosiveSubstances                                  (18),
  ///     miscellaneousDangerousSubstances                     (19)
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic.
typedef struct etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic__Sequence
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__DANGEROUS_GOODS_BASIC__STRUCT_H_
