// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/DangerousGoodsBasic.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__DANGEROUS_GOODS_BASIC__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__DANGEROUS_GOODS_BASIC__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DangerousGoodsBasic_
{
  using Type = DangerousGoodsBasic_<ContainerAllocator>;

  explicit DangerousGoodsBasic_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  explicit DangerousGoodsBasic_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  // field types and members
  using _value_type =
    uint8_t;
  _value_type value;

  // setters for named parameter idiom
  Type & set__value(
    const uint8_t & _arg)
  {
    this->value = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t EXPLOSIVES1 =
    0u;
  static constexpr uint8_t EXPLOSIVES2 =
    1u;
  static constexpr uint8_t EXPLOSIVES3 =
    2u;
  static constexpr uint8_t EXPLOSIVES4 =
    3u;
  static constexpr uint8_t EXPLOSIVES5 =
    4u;
  static constexpr uint8_t EXPLOSIVES6 =
    5u;
  static constexpr uint8_t FLAMMABLE_GASES =
    6u;
  static constexpr uint8_t NON_FLAMMABLE_GASES =
    7u;
  static constexpr uint8_t TOXIC_GASES =
    8u;
  static constexpr uint8_t FLAMMABLE_LIQUIDS =
    9u;
  static constexpr uint8_t FLAMMABLE_SOLIDS =
    10u;
  static constexpr uint8_t SUBSTANCES_LIABLE_TO_SPONTANEOUS_COMBUSTION =
    11u;
  static constexpr uint8_t SUBSTANCES_EMITTING_FLAMMABLE_GASES_UPON_CONTACT_WITH_WATER =
    12u;
  static constexpr uint8_t OXIDIZING_SUBSTANCES =
    13u;
  static constexpr uint8_t ORGANIC_PEROXIDES =
    14u;
  static constexpr uint8_t TOXIC_SUBSTANCES =
    15u;
  static constexpr uint8_t INFECTIOUS_SUBSTANCES =
    16u;
  static constexpr uint8_t RADIOACTIVE_MATERIAL =
    17u;
  static constexpr uint8_t CORROSIVE_SUBSTANCES =
    18u;
  static constexpr uint8_t MISCELLANEOUS_DANGEROUS_SUBSTANCES =
    19u;

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::DangerousGoodsBasic_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::DangerousGoodsBasic_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::DangerousGoodsBasic_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::DangerousGoodsBasic_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::DangerousGoodsBasic_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::DangerousGoodsBasic_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::DangerousGoodsBasic_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::DangerousGoodsBasic_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::DangerousGoodsBasic_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::DangerousGoodsBasic_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::DangerousGoodsBasic_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::DangerousGoodsBasic_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DangerousGoodsBasic_ & other) const
  {
    if (this->value != other.value) {
      return false;
    }
    return true;
  }
  bool operator!=(const DangerousGoodsBasic_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DangerousGoodsBasic_

// alias to use template instance with default allocator
using DangerousGoodsBasic =
  etsi_its_cam_ts_msgs::msg::DangerousGoodsBasic_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsBasic_<ContainerAllocator>::EXPLOSIVES1;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsBasic_<ContainerAllocator>::EXPLOSIVES2;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsBasic_<ContainerAllocator>::EXPLOSIVES3;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsBasic_<ContainerAllocator>::EXPLOSIVES4;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsBasic_<ContainerAllocator>::EXPLOSIVES5;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsBasic_<ContainerAllocator>::EXPLOSIVES6;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsBasic_<ContainerAllocator>::FLAMMABLE_GASES;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsBasic_<ContainerAllocator>::NON_FLAMMABLE_GASES;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsBasic_<ContainerAllocator>::TOXIC_GASES;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsBasic_<ContainerAllocator>::FLAMMABLE_LIQUIDS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsBasic_<ContainerAllocator>::FLAMMABLE_SOLIDS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsBasic_<ContainerAllocator>::SUBSTANCES_LIABLE_TO_SPONTANEOUS_COMBUSTION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsBasic_<ContainerAllocator>::SUBSTANCES_EMITTING_FLAMMABLE_GASES_UPON_CONTACT_WITH_WATER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsBasic_<ContainerAllocator>::OXIDIZING_SUBSTANCES;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsBasic_<ContainerAllocator>::ORGANIC_PEROXIDES;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsBasic_<ContainerAllocator>::TOXIC_SUBSTANCES;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsBasic_<ContainerAllocator>::INFECTIOUS_SUBSTANCES;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsBasic_<ContainerAllocator>::RADIOACTIVE_MATERIAL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsBasic_<ContainerAllocator>::CORROSIVE_SUBSTANCES;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsBasic_<ContainerAllocator>::MISCELLANEOUS_DANGEROUS_SUBSTANCES;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__DANGEROUS_GOODS_BASIC__STRUCT_HPP_
