// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/DangerousSituationSubCauseCode.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__DANGEROUS_SITUATION_SUB_CAUSE_CODE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__DANGEROUS_SITUATION_SUB_CAUSE_CODE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousSituationSubCauseCode__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousSituationSubCauseCode__MAX = 255
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousSituationSubCauseCode__UNAVAILABLE = 0
};

/// Constant 'EMERGENCY_ELECTRONIC_BRAKE_ENGAGED'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousSituationSubCauseCode__EMERGENCY_ELECTRONIC_BRAKE_ENGAGED = 1
};

/// Constant 'PRE_CRASH_SYSTEM_ENGAGED'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousSituationSubCauseCode__PRE_CRASH_SYSTEM_ENGAGED = 2
};

/// Constant 'ESP_ENGAGED'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousSituationSubCauseCode__ESP_ENGAGED = 3
};

/// Constant 'ABS_ENGAGED'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousSituationSubCauseCode__ABS_ENGAGED = 4
};

/// Constant 'EB_ENGAGED'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousSituationSubCauseCode__EB_ENGAGED = 5
};

/// Constant 'BRAKE_WARNING_ENGAGED'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousSituationSubCauseCode__BRAKE_WARNING_ENGAGED = 6
};

/// Constant 'COLLISION_RISK_WARNING_ENGAGED'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousSituationSubCauseCode__COLLISION_RISK_WARNING_ENGAGED = 7
};

/// Struct defined in msg/DangerousSituationSubCauseCode in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__DangerousSituationSubCauseCode
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents the value of the sub cause codes of the @ref CauseCode `dangerousSituation`
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 - `unavailable`                      - in case information on the type of dangerous situation is unavailable,
  ///  * - 1 - `emergencyElectronicBrakeEngaged`  - in case emergency electronic brake is engaged,
  ///  * - 2 - `preCrashSystemEngaged`            - in case pre-crash system is engaged,
  ///  * - 3 - `espEngaged`                       - in case Electronic Stability Program (ESP) system is engaged,
  ///  * - 4 - `absEngaged`                       - in case Anti-lock Braking System (ABS) is engaged,
  ///  * - 5 - `aebEngaged`                       - in case Autonomous Emergency Braking (AEB) system is engaged,
  ///  * - 6 - `brakeWarningEngaged`              - in case brake warning is engaged,
  ///  * - 7 - `collisionRiskWarningEngaged`      - in case collision risk warning is engaged,
  ///  * - 8-255                                  - reserved for future usage.
  ///  *
  ///  * @category: Traffic information
  ///  * @revision: V1.3.1
  ///  */
  /// DangerousSituationSubCauseCode ::= INTEGER {
  ///     unavailable                     (0),
  ///     emergencyElectronicBrakeEngaged (1),
  ///     preCrashSystemEngaged           (2),
  ///     espEngaged                      (3),
  ///     absEngaged                      (4),
  ///     ebEngaged                       (5),
  ///     brakeWarningEngaged             (6),
  ///     collisionRiskWarningEngaged     (7)
  /// } (0..255)
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__DangerousSituationSubCauseCode;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__DangerousSituationSubCauseCode.
typedef struct etsi_its_cam_ts_msgs__msg__DangerousSituationSubCauseCode__Sequence
{
  etsi_its_cam_ts_msgs__msg__DangerousSituationSubCauseCode * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__DangerousSituationSubCauseCode__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__DANGEROUS_SITUATION_SUB_CAUSE_CODE__STRUCT_H_
