// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/DangerousSituationSubCauseCode.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__DANGEROUS_SITUATION_SUB_CAUSE_CODE__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__DANGEROUS_SITUATION_SUB_CAUSE_CODE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__DangerousSituationSubCauseCode __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__DangerousSituationSubCauseCode __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DangerousSituationSubCauseCode_
{
  using Type = DangerousSituationSubCauseCode_<ContainerAllocator>;

  explicit DangerousSituationSubCauseCode_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  explicit DangerousSituationSubCauseCode_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  // field types and members
  using _value_type =
    uint8_t;
  _value_type value;

  // setters for named parameter idiom
  Type & set__value(
    const uint8_t & _arg)
  {
    this->value = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t MIN =
    0u;
  static constexpr uint8_t MAX =
    255u;
  static constexpr uint8_t UNAVAILABLE =
    0u;
  static constexpr uint8_t EMERGENCY_ELECTRONIC_BRAKE_ENGAGED =
    1u;
  static constexpr uint8_t PRE_CRASH_SYSTEM_ENGAGED =
    2u;
  static constexpr uint8_t ESP_ENGAGED =
    3u;
  static constexpr uint8_t ABS_ENGAGED =
    4u;
  static constexpr uint8_t EB_ENGAGED =
    5u;
  static constexpr uint8_t BRAKE_WARNING_ENGAGED =
    6u;
  static constexpr uint8_t COLLISION_RISK_WARNING_ENGAGED =
    7u;

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::DangerousSituationSubCauseCode_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::DangerousSituationSubCauseCode_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::DangerousSituationSubCauseCode_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::DangerousSituationSubCauseCode_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::DangerousSituationSubCauseCode_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::DangerousSituationSubCauseCode_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::DangerousSituationSubCauseCode_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::DangerousSituationSubCauseCode_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::DangerousSituationSubCauseCode_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::DangerousSituationSubCauseCode_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__DangerousSituationSubCauseCode
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::DangerousSituationSubCauseCode_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__DangerousSituationSubCauseCode
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::DangerousSituationSubCauseCode_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DangerousSituationSubCauseCode_ & other) const
  {
    if (this->value != other.value) {
      return false;
    }
    return true;
  }
  bool operator!=(const DangerousSituationSubCauseCode_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DangerousSituationSubCauseCode_

// alias to use template instance with default allocator
using DangerousSituationSubCauseCode =
  etsi_its_cam_ts_msgs::msg::DangerousSituationSubCauseCode_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousSituationSubCauseCode_<ContainerAllocator>::MIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousSituationSubCauseCode_<ContainerAllocator>::MAX;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousSituationSubCauseCode_<ContainerAllocator>::UNAVAILABLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousSituationSubCauseCode_<ContainerAllocator>::EMERGENCY_ELECTRONIC_BRAKE_ENGAGED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousSituationSubCauseCode_<ContainerAllocator>::PRE_CRASH_SYSTEM_ENGAGED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousSituationSubCauseCode_<ContainerAllocator>::ESP_ENGAGED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousSituationSubCauseCode_<ContainerAllocator>::ABS_ENGAGED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousSituationSubCauseCode_<ContainerAllocator>::EB_ENGAGED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousSituationSubCauseCode_<ContainerAllocator>::BRAKE_WARNING_ENGAGED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousSituationSubCauseCode_<ContainerAllocator>::COLLISION_RISK_WARNING_ENGAGED;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__DANGEROUS_SITUATION_SUB_CAUSE_CODE__STRUCT_HPP_
