// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/DeltaReferencePosition.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__DELTA_REFERENCE_POSITION__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__DELTA_REFERENCE_POSITION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'delta_latitude'
#include "etsi_its_cam_ts_msgs/msg/detail/delta_latitude__struct.hpp"
// Member 'delta_longitude'
#include "etsi_its_cam_ts_msgs/msg/detail/delta_longitude__struct.hpp"
// Member 'delta_altitude'
#include "etsi_its_cam_ts_msgs/msg/detail/delta_altitude__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__DeltaReferencePosition __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__DeltaReferencePosition __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DeltaReferencePosition_
{
  using Type = DeltaReferencePosition_<ContainerAllocator>;

  explicit DeltaReferencePosition_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : delta_latitude(_init),
    delta_longitude(_init),
    delta_altitude(_init)
  {
    (void)_init;
  }

  explicit DeltaReferencePosition_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : delta_latitude(_alloc, _init),
    delta_longitude(_alloc, _init),
    delta_altitude(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _delta_latitude_type =
    etsi_its_cam_ts_msgs::msg::DeltaLatitude_<ContainerAllocator>;
  _delta_latitude_type delta_latitude;
  using _delta_longitude_type =
    etsi_its_cam_ts_msgs::msg::DeltaLongitude_<ContainerAllocator>;
  _delta_longitude_type delta_longitude;
  using _delta_altitude_type =
    etsi_its_cam_ts_msgs::msg::DeltaAltitude_<ContainerAllocator>;
  _delta_altitude_type delta_altitude;

  // setters for named parameter idiom
  Type & set__delta_latitude(
    const etsi_its_cam_ts_msgs::msg::DeltaLatitude_<ContainerAllocator> & _arg)
  {
    this->delta_latitude = _arg;
    return *this;
  }
  Type & set__delta_longitude(
    const etsi_its_cam_ts_msgs::msg::DeltaLongitude_<ContainerAllocator> & _arg)
  {
    this->delta_longitude = _arg;
    return *this;
  }
  Type & set__delta_altitude(
    const etsi_its_cam_ts_msgs::msg::DeltaAltitude_<ContainerAllocator> & _arg)
  {
    this->delta_altitude = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::DeltaReferencePosition_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::DeltaReferencePosition_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::DeltaReferencePosition_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::DeltaReferencePosition_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::DeltaReferencePosition_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::DeltaReferencePosition_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::DeltaReferencePosition_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::DeltaReferencePosition_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::DeltaReferencePosition_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::DeltaReferencePosition_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__DeltaReferencePosition
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::DeltaReferencePosition_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__DeltaReferencePosition
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::DeltaReferencePosition_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DeltaReferencePosition_ & other) const
  {
    if (this->delta_latitude != other.delta_latitude) {
      return false;
    }
    if (this->delta_longitude != other.delta_longitude) {
      return false;
    }
    if (this->delta_altitude != other.delta_altitude) {
      return false;
    }
    return true;
  }
  bool operator!=(const DeltaReferencePosition_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DeltaReferencePosition_

// alias to use template instance with default allocator
using DeltaReferencePosition =
  etsi_its_cam_ts_msgs::msg::DeltaReferencePosition_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__DELTA_REFERENCE_POSITION__STRUCT_HPP_
