// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cam_ts_msgs:msg/EmergencyContainer.idl
// generated code does not contain a copyright notice
#include "etsi_its_cam_ts_msgs/msg/detail/emergency_container__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `light_bar_siren_in_use`
#include "etsi_its_cam_ts_msgs/msg/detail/light_bar_siren_in_use__functions.h"
// Member `incident_indication`
#include "etsi_its_cam_ts_msgs/msg/detail/cause_code_v2__functions.h"
// Member `emergency_priority`
#include "etsi_its_cam_ts_msgs/msg/detail/emergency_priority__functions.h"

bool
etsi_its_cam_ts_msgs__msg__EmergencyContainer__init(etsi_its_cam_ts_msgs__msg__EmergencyContainer * msg)
{
  if (!msg) {
    return false;
  }
  // light_bar_siren_in_use
  if (!etsi_its_cam_ts_msgs__msg__LightBarSirenInUse__init(&msg->light_bar_siren_in_use)) {
    etsi_its_cam_ts_msgs__msg__EmergencyContainer__fini(msg);
    return false;
  }
  // incident_indication
  if (!etsi_its_cam_ts_msgs__msg__CauseCodeV2__init(&msg->incident_indication)) {
    etsi_its_cam_ts_msgs__msg__EmergencyContainer__fini(msg);
    return false;
  }
  // incident_indication_is_present
  // emergency_priority
  if (!etsi_its_cam_ts_msgs__msg__EmergencyPriority__init(&msg->emergency_priority)) {
    etsi_its_cam_ts_msgs__msg__EmergencyContainer__fini(msg);
    return false;
  }
  // emergency_priority_is_present
  return true;
}

void
etsi_its_cam_ts_msgs__msg__EmergencyContainer__fini(etsi_its_cam_ts_msgs__msg__EmergencyContainer * msg)
{
  if (!msg) {
    return;
  }
  // light_bar_siren_in_use
  etsi_its_cam_ts_msgs__msg__LightBarSirenInUse__fini(&msg->light_bar_siren_in_use);
  // incident_indication
  etsi_its_cam_ts_msgs__msg__CauseCodeV2__fini(&msg->incident_indication);
  // incident_indication_is_present
  // emergency_priority
  etsi_its_cam_ts_msgs__msg__EmergencyPriority__fini(&msg->emergency_priority);
  // emergency_priority_is_present
}

bool
etsi_its_cam_ts_msgs__msg__EmergencyContainer__are_equal(const etsi_its_cam_ts_msgs__msg__EmergencyContainer * lhs, const etsi_its_cam_ts_msgs__msg__EmergencyContainer * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // light_bar_siren_in_use
  if (!etsi_its_cam_ts_msgs__msg__LightBarSirenInUse__are_equal(
      &(lhs->light_bar_siren_in_use), &(rhs->light_bar_siren_in_use)))
  {
    return false;
  }
  // incident_indication
  if (!etsi_its_cam_ts_msgs__msg__CauseCodeV2__are_equal(
      &(lhs->incident_indication), &(rhs->incident_indication)))
  {
    return false;
  }
  // incident_indication_is_present
  if (lhs->incident_indication_is_present != rhs->incident_indication_is_present) {
    return false;
  }
  // emergency_priority
  if (!etsi_its_cam_ts_msgs__msg__EmergencyPriority__are_equal(
      &(lhs->emergency_priority), &(rhs->emergency_priority)))
  {
    return false;
  }
  // emergency_priority_is_present
  if (lhs->emergency_priority_is_present != rhs->emergency_priority_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__EmergencyContainer__copy(
  const etsi_its_cam_ts_msgs__msg__EmergencyContainer * input,
  etsi_its_cam_ts_msgs__msg__EmergencyContainer * output)
{
  if (!input || !output) {
    return false;
  }
  // light_bar_siren_in_use
  if (!etsi_its_cam_ts_msgs__msg__LightBarSirenInUse__copy(
      &(input->light_bar_siren_in_use), &(output->light_bar_siren_in_use)))
  {
    return false;
  }
  // incident_indication
  if (!etsi_its_cam_ts_msgs__msg__CauseCodeV2__copy(
      &(input->incident_indication), &(output->incident_indication)))
  {
    return false;
  }
  // incident_indication_is_present
  output->incident_indication_is_present = input->incident_indication_is_present;
  // emergency_priority
  if (!etsi_its_cam_ts_msgs__msg__EmergencyPriority__copy(
      &(input->emergency_priority), &(output->emergency_priority)))
  {
    return false;
  }
  // emergency_priority_is_present
  output->emergency_priority_is_present = input->emergency_priority_is_present;
  return true;
}

etsi_its_cam_ts_msgs__msg__EmergencyContainer *
etsi_its_cam_ts_msgs__msg__EmergencyContainer__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__EmergencyContainer * msg = (etsi_its_cam_ts_msgs__msg__EmergencyContainer *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__EmergencyContainer), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cam_ts_msgs__msg__EmergencyContainer));
  bool success = etsi_its_cam_ts_msgs__msg__EmergencyContainer__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cam_ts_msgs__msg__EmergencyContainer__destroy(etsi_its_cam_ts_msgs__msg__EmergencyContainer * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cam_ts_msgs__msg__EmergencyContainer__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cam_ts_msgs__msg__EmergencyContainer__Sequence__init(etsi_its_cam_ts_msgs__msg__EmergencyContainer__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__EmergencyContainer * data = NULL;

  if (size) {
    data = (etsi_its_cam_ts_msgs__msg__EmergencyContainer *)allocator.zero_allocate(size, sizeof(etsi_its_cam_ts_msgs__msg__EmergencyContainer), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cam_ts_msgs__msg__EmergencyContainer__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cam_ts_msgs__msg__EmergencyContainer__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cam_ts_msgs__msg__EmergencyContainer__Sequence__fini(etsi_its_cam_ts_msgs__msg__EmergencyContainer__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cam_ts_msgs__msg__EmergencyContainer__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cam_ts_msgs__msg__EmergencyContainer__Sequence *
etsi_its_cam_ts_msgs__msg__EmergencyContainer__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__EmergencyContainer__Sequence * array = (etsi_its_cam_ts_msgs__msg__EmergencyContainer__Sequence *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__EmergencyContainer__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cam_ts_msgs__msg__EmergencyContainer__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cam_ts_msgs__msg__EmergencyContainer__Sequence__destroy(etsi_its_cam_ts_msgs__msg__EmergencyContainer__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cam_ts_msgs__msg__EmergencyContainer__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cam_ts_msgs__msg__EmergencyContainer__Sequence__are_equal(const etsi_its_cam_ts_msgs__msg__EmergencyContainer__Sequence * lhs, const etsi_its_cam_ts_msgs__msg__EmergencyContainer__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__EmergencyContainer__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__EmergencyContainer__Sequence__copy(
  const etsi_its_cam_ts_msgs__msg__EmergencyContainer__Sequence * input,
  etsi_its_cam_ts_msgs__msg__EmergencyContainer__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cam_ts_msgs__msg__EmergencyContainer);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cam_ts_msgs__msg__EmergencyContainer * data =
      (etsi_its_cam_ts_msgs__msg__EmergencyContainer *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cam_ts_msgs__msg__EmergencyContainer__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cam_ts_msgs__msg__EmergencyContainer__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__EmergencyContainer__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
