// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/EmergencyContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__EMERGENCY_CONTAINER__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__EMERGENCY_CONTAINER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/emergency_container__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'light_bar_siren_in_use'
#include "etsi_its_cam_ts_msgs/msg/detail/light_bar_siren_in_use__traits.hpp"
// Member 'incident_indication'
#include "etsi_its_cam_ts_msgs/msg/detail/cause_code_v2__traits.hpp"
// Member 'emergency_priority'
#include "etsi_its_cam_ts_msgs/msg/detail/emergency_priority__traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const EmergencyContainer & msg,
  std::ostream & out)
{
  out << "{";
  // member: light_bar_siren_in_use
  {
    out << "light_bar_siren_in_use: ";
    to_flow_style_yaml(msg.light_bar_siren_in_use, out);
    out << ", ";
  }

  // member: incident_indication
  {
    out << "incident_indication: ";
    to_flow_style_yaml(msg.incident_indication, out);
    out << ", ";
  }

  // member: incident_indication_is_present
  {
    out << "incident_indication_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.incident_indication_is_present, out);
    out << ", ";
  }

  // member: emergency_priority
  {
    out << "emergency_priority: ";
    to_flow_style_yaml(msg.emergency_priority, out);
    out << ", ";
  }

  // member: emergency_priority_is_present
  {
    out << "emergency_priority_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.emergency_priority_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const EmergencyContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: light_bar_siren_in_use
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "light_bar_siren_in_use:\n";
    to_block_style_yaml(msg.light_bar_siren_in_use, out, indentation + 2);
  }

  // member: incident_indication
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "incident_indication:\n";
    to_block_style_yaml(msg.incident_indication, out, indentation + 2);
  }

  // member: incident_indication_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "incident_indication_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.incident_indication_is_present, out);
    out << "\n";
  }

  // member: emergency_priority
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "emergency_priority:\n";
    to_block_style_yaml(msg.emergency_priority, out, indentation + 2);
  }

  // member: emergency_priority_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "emergency_priority_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.emergency_priority_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const EmergencyContainer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::EmergencyContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::EmergencyContainer & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::EmergencyContainer>()
{
  return "etsi_its_cam_ts_msgs::msg::EmergencyContainer";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::EmergencyContainer>()
{
  return "etsi_its_cam_ts_msgs/msg/EmergencyContainer";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::EmergencyContainer>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_ts_msgs::msg::CauseCodeV2>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::EmergencyPriority>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::LightBarSirenInUse>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::EmergencyContainer>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_ts_msgs::msg::CauseCodeV2>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::EmergencyPriority>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::LightBarSirenInUse>::value> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::EmergencyContainer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__EMERGENCY_CONTAINER__TRAITS_HPP_
