// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/HazardousLocationAnimalOnTheRoadSubCauseCode.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HAZARDOUS_LOCATION_ANIMAL_ON_THE_ROAD_SUB_CAUSE_CODE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HAZARDOUS_LOCATION_ANIMAL_ON_THE_ROAD_SUB_CAUSE_CODE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationAnimalOnTheRoadSubCauseCode__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationAnimalOnTheRoadSubCauseCode__MAX = 255
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationAnimalOnTheRoadSubCauseCode__UNAVAILABLE = 0
};

/// Constant 'WILD_ANIMALS'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationAnimalOnTheRoadSubCauseCode__WILD_ANIMALS = 1
};

/// Constant 'HERD_OF_ANIMALS'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationAnimalOnTheRoadSubCauseCode__HERD_OF_ANIMALS = 2
};

/// Constant 'SMALL_ANIMALS'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationAnimalOnTheRoadSubCauseCode__SMALL_ANIMALS = 3
};

/// Constant 'LARGE_ANIMALS'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationAnimalOnTheRoadSubCauseCode__LARGE_ANIMALS = 4
};

/// Constant 'WILD_ANIMALS_SMALL'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationAnimalOnTheRoadSubCauseCode__WILD_ANIMALS_SMALL = 5
};

/// Constant 'WILD_ANIMALS_LARGE'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationAnimalOnTheRoadSubCauseCode__WILD_ANIMALS_LARGE = 6
};

/// Constant 'DOMESTIC_ANIMALS'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationAnimalOnTheRoadSubCauseCode__DOMESTIC_ANIMALS = 7
};

/// Constant 'DOMESTIC_ANIMALS_SMALL'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationAnimalOnTheRoadSubCauseCode__DOMESTIC_ANIMALS_SMALL = 8
};

/// Constant 'DOMESTIC_ANIMALS_LARGE'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationAnimalOnTheRoadSubCauseCode__DOMESTIC_ANIMALS_LARGE = 9
};

/// Struct defined in msg/HazardousLocationAnimalOnTheRoadSubCauseCode in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__HazardousLocationAnimalOnTheRoadSubCauseCode
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents the value of the sub cause code of the @ref CauseCode `hazardousLocation-AnimalOnTheRoad`.
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 - `unavailable`          - in case further detailed information on the animal(s) on the road is unavailable,
  ///  * - 1 - `wildAnimals`          - in case wild animals of unknown size are present on the road,
  ///  * - 2 - `herdOfAnimals`        - in case a herd of animals is present on the road,
  ///  * - 3 - `smallAnimals`         - in case small size animals of unknown type are present on the road,
  ///  * - 4 - `largeAnimals`         - in case large size animals of unknown type are present on the road,
  ///  * - 5 - `wildAnimalsSmall`     - in case small size wild animal(s) are present on the road,
  ///  * - 6 - `wildAnimalsLarge`     - in case large size wild animal(s) are present on the road,
  ///  * - 7 - `domesticAnimals`      - in case domestic animal(s) of unknown size are detected on the road,
  ///  * - 8 - `domesticAnimalsSmall` - in case small size domestic animal(s) are present on the road,
  ///  * - 9 - `domesticAnimalsLarge` - in case large size domestic animal(s) are present on the road.
  ///  * - 10-255                     - are reserved for future usage.
  ///  *
  ///  * @category: Traffic information
  ///  * @revision: V1.3.1, named values 5 to 9 added in V2.2.1
  ///  */
  /// HazardousLocation-AnimalOnTheRoadSubCauseCode ::= INTEGER {
  ///     unavailable           (0),
  ///     wildAnimals           (1),
  ///     herdOfAnimals         (2),
  ///     smallAnimals          (3),
  ///     largeAnimals          (4),
  ///     wildAnimalsSmall      (5),
  ///     wildAnimalsLarge      (6),
  ///     domesticAnimals       (7),
  ///     domesticAnimalsSmall  (8),
  ///     domesticAnimalsLarge  (9)
  /// } (0..255)
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__HazardousLocationAnimalOnTheRoadSubCauseCode;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__HazardousLocationAnimalOnTheRoadSubCauseCode.
typedef struct etsi_its_cam_ts_msgs__msg__HazardousLocationAnimalOnTheRoadSubCauseCode__Sequence
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationAnimalOnTheRoadSubCauseCode * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__HazardousLocationAnimalOnTheRoadSubCauseCode__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HAZARDOUS_LOCATION_ANIMAL_ON_THE_ROAD_SUB_CAUSE_CODE__STRUCT_H_
