// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/HazardousLocationObstacleOnTheRoadSubCauseCode.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HAZARDOUS_LOCATION_OBSTACLE_ON_THE_ROAD_SUB_CAUSE_CODE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HAZARDOUS_LOCATION_OBSTACLE_ON_THE_ROAD_SUB_CAUSE_CODE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationObstacleOnTheRoadSubCauseCode__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationObstacleOnTheRoadSubCauseCode__MAX = 255
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationObstacleOnTheRoadSubCauseCode__UNAVAILABLE = 0
};

/// Constant 'SHED_LOAD'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationObstacleOnTheRoadSubCauseCode__SHED_LOAD = 1
};

/// Constant 'PARTS_OF_VEHICLES'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationObstacleOnTheRoadSubCauseCode__PARTS_OF_VEHICLES = 2
};

/// Constant 'PARTS_OF_TYRES'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationObstacleOnTheRoadSubCauseCode__PARTS_OF_TYRES = 3
};

/// Constant 'BIG_OBJECTS'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationObstacleOnTheRoadSubCauseCode__BIG_OBJECTS = 4
};

/// Constant 'FALLEN_TREES'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationObstacleOnTheRoadSubCauseCode__FALLEN_TREES = 5
};

/// Constant 'HUB_CAPS'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationObstacleOnTheRoadSubCauseCode__HUB_CAPS = 6
};

/// Constant 'WAITING_VEHICLES'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationObstacleOnTheRoadSubCauseCode__WAITING_VEHICLES = 7
};

/// Struct defined in msg/HazardousLocationObstacleOnTheRoadSubCauseCode in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__HazardousLocationObstacleOnTheRoadSubCauseCode
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents the value of the sub cause code of the @ref CauseCode `hazardousLocation-ObstacleOnTheRoad`.
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 - `unavailable`    - in case further detailed information on the detected obstacle is unavailable,
  ///  * - 1 - `shedLoad`       - in case detected obstacle is large amount of obstacles (shedload),
  ///  * - 2 - `partsOfVehicles`- in case detected obstacles are parts of vehicles,
  ///  * - 3 - `partsOfTyres`   - in case the detected obstacles are parts of tyres,
  ///  * - 4 - `bigObjects`     - in case the detected obstacles are big objects,
  ///  * - 5 - `fallenTrees`    - in case the detected obstacles are fallen trees,
  ///  * - 6 - `hubCaps`        - in case the detected obstacles are hub caps,
  ///  * - 7 - `waitingVehicles`- in case the detected obstacles are waiting vehicles.
  ///  * - 8-255                - are reserved for future usage.
  ///  *
  ///  * @category: Traffic information
  ///  * @revision: V1.3.1
  ///  */
  /// HazardousLocation-ObstacleOnTheRoadSubCauseCode ::= INTEGER {
  ///     unavailable     (0),
  ///     shedLoad        (1),
  ///     partsOfVehicles (2),
  ///     partsOfTyres    (3),
  ///     bigObjects      (4),
  ///     fallenTrees     (5),
  ///     hubCaps         (6),
  ///     waitingVehicles (7)
  /// } (0..255)
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__HazardousLocationObstacleOnTheRoadSubCauseCode;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__HazardousLocationObstacleOnTheRoadSubCauseCode.
typedef struct etsi_its_cam_ts_msgs__msg__HazardousLocationObstacleOnTheRoadSubCauseCode__Sequence
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationObstacleOnTheRoadSubCauseCode * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__HazardousLocationObstacleOnTheRoadSubCauseCode__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HAZARDOUS_LOCATION_OBSTACLE_ON_THE_ROAD_SUB_CAUSE_CODE__STRUCT_H_
