// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/HeadingValue.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HEADING_VALUE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HEADING_VALUE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__HeadingValue__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__HeadingValue__MAX = 3601
};

/// Constant 'WGS84_NORTH'.
enum
{
  etsi_its_cam_ts_msgs__msg__HeadingValue__WGS84_NORTH = 0
};

/// Constant 'WGS84_EAST'.
enum
{
  etsi_its_cam_ts_msgs__msg__HeadingValue__WGS84_EAST = 900
};

/// Constant 'WGS84_SOUTH'.
enum
{
  etsi_its_cam_ts_msgs__msg__HeadingValue__WGS84_SOUTH = 1800
};

/// Constant 'WGS84_WEST'.
enum
{
  etsi_its_cam_ts_msgs__msg__HeadingValue__WGS84_WEST = 2700
};

/// Constant 'DO_NOT_USE'.
enum
{
  etsi_its_cam_ts_msgs__msg__HeadingValue__DO_NOT_USE = 3600
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__HeadingValue__UNAVAILABLE = 3601
};

/// Struct defined in msg/HeadingValue in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__HeadingValue
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents the orientation of the horizontal velocity vector with regards to the WGS84 north.
  ///  * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
  ///  *
  ///  * @note: this DE is kept for backwards compatibility reasons only. It is recommended to use the @ref Wgs84AngleValue instead.
  ///  *
  ///  * Unit: 0,1 degree
  ///  * Categories: GeoReference information
  ///  * @revision: Description revised in V2.1.1 (usage of value 3600 specified)
  /// */
  /// HeadingValue ::= INTEGER {
  ///     wgs84North  (0),
  ///     wgs84East   (900),
  ///     wgs84South  (1800),
  ///     wgs84West   (2700),
  ///     doNotUse    (3600),
  ///     unavailable (3601)
  /// } (0..3601)
  /// ------------------------------------------------------------------------------
  uint16_t value;
} etsi_its_cam_ts_msgs__msg__HeadingValue;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__HeadingValue.
typedef struct etsi_its_cam_ts_msgs__msg__HeadingValue__Sequence
{
  etsi_its_cam_ts_msgs__msg__HeadingValue * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__HeadingValue__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HEADING_VALUE__STRUCT_H_
