// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/HumanPresenceOnTheRoadSubCauseCode.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HUMAN_PRESENCE_ON_THE_ROAD_SUB_CAUSE_CODE__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HUMAN_PRESENCE_ON_THE_ROAD_SUB_CAUSE_CODE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__HumanPresenceOnTheRoadSubCauseCode __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__HumanPresenceOnTheRoadSubCauseCode __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct HumanPresenceOnTheRoadSubCauseCode_
{
  using Type = HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>;

  explicit HumanPresenceOnTheRoadSubCauseCode_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  explicit HumanPresenceOnTheRoadSubCauseCode_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  // field types and members
  using _value_type =
    uint8_t;
  _value_type value;

  // setters for named parameter idiom
  Type & set__value(
    const uint8_t & _arg)
  {
    this->value = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t MIN =
    0u;
  static constexpr uint8_t MAX =
    255u;
  static constexpr uint8_t UNAVAILABLE =
    0u;
  static constexpr uint8_t CHILDREN_ON_ROADWAY =
    1u;
  static constexpr uint8_t CYCLIST_ON_ROADWAY =
    2u;
  static constexpr uint8_t MOTORCYCLIST_ON_ROADWAY =
    3u;
  static constexpr uint8_t PEDESTRIAN =
    4u;
  static constexpr uint8_t ORDINARY_PEDESTRIAN =
    5u;
  static constexpr uint8_t ROAD_WORKER =
    6u;
  static constexpr uint8_t FIRST_RESPONDER =
    7u;
  static constexpr uint8_t LIGHT_VRU_VEHICLE =
    8u;
  static constexpr uint8_t BICYCLIST =
    9u;
  static constexpr uint8_t WHEELCHAIR_USER =
    10u;
  static constexpr uint8_t HORSE_AND_RIDER =
    11u;
  static constexpr uint8_t ROLLERSKATER =
    12u;
  static constexpr uint8_t E_SCOOTER =
    13u;
  static constexpr uint8_t PERSONAL_TRANSPORTER =
    14u;
  static constexpr uint8_t PEDELEC =
    15u;
  static constexpr uint8_t SPEED_PEDELEC =
    16u;
  static constexpr uint8_t PTW =
    17u;
  static constexpr uint8_t MOPED =
    18u;
  static constexpr uint8_t MOTORCYCLE =
    19u;
  static constexpr uint8_t MOTORCYCLE_AND_SIDECAR_RIGHT =
    20u;
  static constexpr uint8_t MOTORCYCLE_AND_SIDECAR_LEFT =
    21u;

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__HumanPresenceOnTheRoadSubCauseCode
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__HumanPresenceOnTheRoadSubCauseCode
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const HumanPresenceOnTheRoadSubCauseCode_ & other) const
  {
    if (this->value != other.value) {
      return false;
    }
    return true;
  }
  bool operator!=(const HumanPresenceOnTheRoadSubCauseCode_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct HumanPresenceOnTheRoadSubCauseCode_

// alias to use template instance with default allocator
using HumanPresenceOnTheRoadSubCauseCode =
  etsi_its_cam_ts_msgs::msg::HumanPresenceOnTheRoadSubCauseCode_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::MIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::MAX;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::UNAVAILABLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::CHILDREN_ON_ROADWAY;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::CYCLIST_ON_ROADWAY;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::MOTORCYCLIST_ON_ROADWAY;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::PEDESTRIAN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::ORDINARY_PEDESTRIAN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::ROAD_WORKER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::FIRST_RESPONDER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::LIGHT_VRU_VEHICLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::BICYCLIST;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::WHEELCHAIR_USER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::HORSE_AND_RIDER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::ROLLERSKATER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::E_SCOOTER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::PERSONAL_TRANSPORTER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::PEDELEC;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::SPEED_PEDELEC;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::PTW;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::MOPED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::MOTORCYCLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::MOTORCYCLE_AND_SIDECAR_RIGHT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t HumanPresenceOnTheRoadSubCauseCode_<ContainerAllocator>::MOTORCYCLE_AND_SIDECAR_LEFT;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HUMAN_PRESENCE_ON_THE_ROAD_SUB_CAUSE_CODE__STRUCT_HPP_
