// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/ImpassabilitySubCauseCode.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__IMPASSABILITY_SUB_CAUSE_CODE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__IMPASSABILITY_SUB_CAUSE_CODE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode__MAX = 255
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode__UNAVAILABLE = 0
};

/// Constant 'FLOODING'.
enum
{
  etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode__FLOODING = 1
};

/// Constant 'DANGER_OF_AVALANCHES'.
enum
{
  etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode__DANGER_OF_AVALANCHES = 2
};

/// Constant 'BLASTING_OF_AVALANCHES'.
enum
{
  etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode__BLASTING_OF_AVALANCHES = 3
};

/// Constant 'LANDSLIPS'.
enum
{
  etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode__LANDSLIPS = 4
};

/// Constant 'CHEMICAL_SPILLAGE'.
enum
{
  etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode__CHEMICAL_SPILLAGE = 5
};

/// Constant 'WINTER_CLOSURE'.
enum
{
  etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode__WINTER_CLOSURE = 6
};

/// Constant 'SINKHOLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode__SINKHOLE = 7
};

/// Constant 'EARTHQUAKE_DAMAGE'.
enum
{
  etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode__EARTHQUAKE_DAMAGE = 8
};

/// Constant 'FALLEN_TREES'.
enum
{
  etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode__FALLEN_TREES = 9
};

/// Constant 'ROCKFALLS'.
enum
{
  etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode__ROCKFALLS = 10
};

/// Constant 'SEWER_OVERFLOW'.
enum
{
  etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode__SEWER_OVERFLOW = 11
};

/// Constant 'STORM_DAMAGE'.
enum
{
  etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode__STORM_DAMAGE = 12
};

/// Constant 'SUBSIDENCE'.
enum
{
  etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode__SUBSIDENCE = 13
};

/// Constant 'BURST_PIPE'.
enum
{
  etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode__BURST_PIPE = 14
};

/// Constant 'BURST_WATER_MAIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode__BURST_WATER_MAIN = 15
};

/// Constant 'FALLEN_POWER_CABLES'.
enum
{
  etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode__FALLEN_POWER_CABLES = 16
};

/// Constant 'SNOW_DRIFTS'.
enum
{
  etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode__SNOW_DRIFTS = 17
};

/// Struct defined in msg/ImpassabilitySubCauseCode in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents the value of the sub cause codes of the @ref CauseCode `impassability`
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 `unavailable`              - in case further detailed information about the unmanaged road blockage is unavailable,
  ///  * - 1 `flooding          `       - in case the road is affected by flooding,
  ///  * - 2 `dangerOfAvalanches`       - in case the road is at risk of being affected or blocked by avalanches,
  ///  * - 3 `blastingOfAvalanches`     - in case there is an active blasting of avalanches on or near the road,
  ///  * - 4 `landslips`                - in case the road is affected by landslips,
  ///  * - 5 `chemicalSpillage`         - in case the road is affected by chemical spillage,
  ///  * - 6 `winterClosure`            - in case the road is impassable due to a winter closure.
  ///  * - 7 `sinkhole`                 - in case the road is impassable due to large holes in the road surface.
  ///  * - 8 `earthquakeDamage`         - in case the road is obstructed or partially obstructed because of damage caused by an earthquake.
  ///  * - 9 `fallenTrees`              - in case the road is obstructed or partially obstructed by one or more fallen trees.
  ///  * - 10 `rockfalls`               - in case the road is obstructed or partially obstructed due to fallen rocks.
  ///  * - 11 `sewerOverflow`           - in case the road is obstructed or partially obstructed by overflows from one or more sewers.
  ///  * - 12 `stormDamage`             - in case the road is obstructed or partially obstructed by debris caused by strong winds.
  ///  * - 13 `subsidence`              - in case the road surface has sunken or collapsed in places.
  ///  * - 14 `burstPipe`               - in case the road surface has sunken or collapsed in places due to burst pipes.
  ///  * - 15 `burstWaterMain`          - in case the road is obstructed due to local flooding and/or subsidence.
  ///  * - 16 `fallenPowerCables`       - in case the road is obstructed or partly obstructed by one or more fallen power cables.
  ///  * - 17 `snowDrifts`              - in case the road is obstructed or partially obstructed by snow drifting in progress or patches of deep snow due to earlier drifting.
  ///  * - 15-255                       - are reserved for future usage.
  ///  *
  ///  * @category: Traffic information
  ///  * @revision: Created in V2.2.1
  /// */
  /// ImpassabilitySubCauseCode ::= INTEGER {
  ///     unavailable               (0),
  ///     flooding                  (1),
  ///     dangerOfAvalanches        (2),
  ///     blastingOfAvalanches      (3),
  ///     landslips                 (4),
  ///     chemicalSpillage          (5),
  ///     winterClosure             (6),
  ///     sinkhole                  (7),
  ///     earthquakeDamage          (8),
  ///     fallenTrees               (9),
  ///     rockfalls                 (10),
  ///     sewerOverflow             (11),
  ///     stormDamage               (12),
  ///     subsidence                (13),
  ///     burstPipe                 (14),
  ///     burstWaterMain            (15),
  ///     fallenPowerCables         (16),
  ///     snowDrifts                (17)
  /// } (0..255)
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode.
typedef struct etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode__Sequence
{
  etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__IMPASSABILITY_SUB_CAUSE_CODE__STRUCT_H_
