// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/ItsPduHeader.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ITS_PDU_HEADER__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ITS_PDU_HEADER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'protocol_version'
#include "etsi_its_cam_ts_msgs/msg/detail/ordinal_number1_b__struct.h"
// Member 'message_id'
#include "etsi_its_cam_ts_msgs/msg/detail/message_id__struct.h"
// Member 'station_id'
#include "etsi_its_cam_ts_msgs/msg/detail/station_id__struct.h"

/// Struct defined in msg/ItsPduHeader in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__ItsPduHeader
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF represents a common message header for application and facilities layer messages.
  ///  * It is included at the beginning of an ITS message as the message header.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field protocolVersion: version of the ITS message.
  ///  *
  ///  * @field messageId: type of the ITS message.
  ///  *
  ///  * @field stationId: the identifier of the ITS-S that generated the ITS message.
  ///  *
  ///  * @category: Communication information
  ///  * @revision:  update in V2.1.1: messageID and stationID changed to messageId and stationId; messageId is of type MessageId.
  ///  */
  /// ItsPduHeader ::= SEQUENCE {
  ///     protocolVersion    OrdinalNumber1B,
  ///     messageId          MessageId,
  ///     stationId          StationId
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cam_ts_msgs__msg__OrdinalNumber1B protocol_version;
  etsi_its_cam_ts_msgs__msg__MessageId message_id;
  etsi_its_cam_ts_msgs__msg__StationId station_id;
} etsi_its_cam_ts_msgs__msg__ItsPduHeader;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__ItsPduHeader.
typedef struct etsi_its_cam_ts_msgs__msg__ItsPduHeader__Sequence
{
  etsi_its_cam_ts_msgs__msg__ItsPduHeader * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__ItsPduHeader__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ITS_PDU_HEADER__STRUCT_H_
