// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/ItsPduHeader.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ITS_PDU_HEADER__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ITS_PDU_HEADER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/its_pdu_header__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'protocol_version'
#include "etsi_its_cam_ts_msgs/msg/detail/ordinal_number1_b__traits.hpp"
// Member 'message_id'
#include "etsi_its_cam_ts_msgs/msg/detail/message_id__traits.hpp"
// Member 'station_id'
#include "etsi_its_cam_ts_msgs/msg/detail/station_id__traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ItsPduHeader & msg,
  std::ostream & out)
{
  out << "{";
  // member: protocol_version
  {
    out << "protocol_version: ";
    to_flow_style_yaml(msg.protocol_version, out);
    out << ", ";
  }

  // member: message_id
  {
    out << "message_id: ";
    to_flow_style_yaml(msg.message_id, out);
    out << ", ";
  }

  // member: station_id
  {
    out << "station_id: ";
    to_flow_style_yaml(msg.station_id, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ItsPduHeader & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: protocol_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "protocol_version:\n";
    to_block_style_yaml(msg.protocol_version, out, indentation + 2);
  }

  // member: message_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "message_id:\n";
    to_block_style_yaml(msg.message_id, out, indentation + 2);
  }

  // member: station_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "station_id:\n";
    to_block_style_yaml(msg.station_id, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ItsPduHeader & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::ItsPduHeader & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::ItsPduHeader & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::ItsPduHeader>()
{
  return "etsi_its_cam_ts_msgs::msg::ItsPduHeader";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::ItsPduHeader>()
{
  return "etsi_its_cam_ts_msgs/msg/ItsPduHeader";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::ItsPduHeader>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_ts_msgs::msg::MessageId>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::OrdinalNumber1B>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::StationId>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::ItsPduHeader>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_ts_msgs::msg::MessageId>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::OrdinalNumber1B>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::StationId>::value> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::ItsPduHeader>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ITS_PDU_HEADER__TRAITS_HPP_
