// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/Path.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PATH__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PATH__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN_SIZE'.
enum
{
  etsi_its_cam_ts_msgs__msg__Path__MIN_SIZE = 0
};

/// Constant 'MAX_SIZE'.
enum
{
  etsi_its_cam_ts_msgs__msg__Path__MAX_SIZE = 40
};

// Include directives for member types
// Member 'array'
#include "etsi_its_cam_ts_msgs/msg/detail/path_point__struct.h"

/// Struct defined in msg/Path in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__Path
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF represents a path with a set of path points.
  ///  * It shall contain up to `40` @ref PathPoint.
  ///  *
  ///  * The first PathPoint presents an offset delta position with regards to an external reference position.
  ///  * Each other PathPoint presents an offset delta position and optionally an offset travel time with regards to the previous PathPoint.
  ///  *
  ///  * @category: GeoReference information, Vehicle information
  ///  * @revision: created in V2.1.1 based on PathHistory
  ///  */
  /// Path::= SEQUENCE (SIZE(0..40)) OF PathPoint
  /// ------------------------------------------------------------------------------
  etsi_its_cam_ts_msgs__msg__PathPoint__Sequence array;
} etsi_its_cam_ts_msgs__msg__Path;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__Path.
typedef struct etsi_its_cam_ts_msgs__msg__Path__Sequence
{
  etsi_its_cam_ts_msgs__msg__Path * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__Path__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PATH__STRUCT_H_
