// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/PathPoint.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PATH_POINT__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PATH_POINT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/path_point__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'path_position'
#include "etsi_its_cam_ts_msgs/msg/detail/delta_reference_position__traits.hpp"
// Member 'path_delta_time'
#include "etsi_its_cam_ts_msgs/msg/detail/path_delta_time__traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const PathPoint & msg,
  std::ostream & out)
{
  out << "{";
  // member: path_position
  {
    out << "path_position: ";
    to_flow_style_yaml(msg.path_position, out);
    out << ", ";
  }

  // member: path_delta_time
  {
    out << "path_delta_time: ";
    to_flow_style_yaml(msg.path_delta_time, out);
    out << ", ";
  }

  // member: path_delta_time_is_present
  {
    out << "path_delta_time_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.path_delta_time_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PathPoint & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: path_position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "path_position:\n";
    to_block_style_yaml(msg.path_position, out, indentation + 2);
  }

  // member: path_delta_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "path_delta_time:\n";
    to_block_style_yaml(msg.path_delta_time, out, indentation + 2);
  }

  // member: path_delta_time_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "path_delta_time_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.path_delta_time_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PathPoint & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::PathPoint & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::PathPoint & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::PathPoint>()
{
  return "etsi_its_cam_ts_msgs::msg::PathPoint";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::PathPoint>()
{
  return "etsi_its_cam_ts_msgs/msg/PathPoint";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::PathPoint>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_ts_msgs::msg::DeltaReferencePosition>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::PathDeltaTime>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::PathPoint>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_ts_msgs::msg::DeltaReferencePosition>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::PathDeltaTime>::value> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::PathPoint>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PATH_POINT__TRAITS_HPP_
