// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cam_ts_msgs:msg/PositionConfidenceEllipse.idl
// generated code does not contain a copyright notice
#include "etsi_its_cam_ts_msgs/msg/detail/position_confidence_ellipse__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `semi_major_axis_length`
// Member `semi_minor_axis_length`
#include "etsi_its_cam_ts_msgs/msg/detail/semi_axis_length__functions.h"
// Member `semi_major_axis_orientation`
#include "etsi_its_cam_ts_msgs/msg/detail/wgs84_angle_value__functions.h"

bool
etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__init(etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse * msg)
{
  if (!msg) {
    return false;
  }
  // semi_major_axis_length
  if (!etsi_its_cam_ts_msgs__msg__SemiAxisLength__init(&msg->semi_major_axis_length)) {
    etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__fini(msg);
    return false;
  }
  // semi_minor_axis_length
  if (!etsi_its_cam_ts_msgs__msg__SemiAxisLength__init(&msg->semi_minor_axis_length)) {
    etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__fini(msg);
    return false;
  }
  // semi_major_axis_orientation
  if (!etsi_its_cam_ts_msgs__msg__Wgs84AngleValue__init(&msg->semi_major_axis_orientation)) {
    etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__fini(etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse * msg)
{
  if (!msg) {
    return;
  }
  // semi_major_axis_length
  etsi_its_cam_ts_msgs__msg__SemiAxisLength__fini(&msg->semi_major_axis_length);
  // semi_minor_axis_length
  etsi_its_cam_ts_msgs__msg__SemiAxisLength__fini(&msg->semi_minor_axis_length);
  // semi_major_axis_orientation
  etsi_its_cam_ts_msgs__msg__Wgs84AngleValue__fini(&msg->semi_major_axis_orientation);
}

bool
etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__are_equal(const etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse * lhs, const etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // semi_major_axis_length
  if (!etsi_its_cam_ts_msgs__msg__SemiAxisLength__are_equal(
      &(lhs->semi_major_axis_length), &(rhs->semi_major_axis_length)))
  {
    return false;
  }
  // semi_minor_axis_length
  if (!etsi_its_cam_ts_msgs__msg__SemiAxisLength__are_equal(
      &(lhs->semi_minor_axis_length), &(rhs->semi_minor_axis_length)))
  {
    return false;
  }
  // semi_major_axis_orientation
  if (!etsi_its_cam_ts_msgs__msg__Wgs84AngleValue__are_equal(
      &(lhs->semi_major_axis_orientation), &(rhs->semi_major_axis_orientation)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__copy(
  const etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse * input,
  etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse * output)
{
  if (!input || !output) {
    return false;
  }
  // semi_major_axis_length
  if (!etsi_its_cam_ts_msgs__msg__SemiAxisLength__copy(
      &(input->semi_major_axis_length), &(output->semi_major_axis_length)))
  {
    return false;
  }
  // semi_minor_axis_length
  if (!etsi_its_cam_ts_msgs__msg__SemiAxisLength__copy(
      &(input->semi_minor_axis_length), &(output->semi_minor_axis_length)))
  {
    return false;
  }
  // semi_major_axis_orientation
  if (!etsi_its_cam_ts_msgs__msg__Wgs84AngleValue__copy(
      &(input->semi_major_axis_orientation), &(output->semi_major_axis_orientation)))
  {
    return false;
  }
  return true;
}

etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse *
etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse * msg = (etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse));
  bool success = etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__destroy(etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__Sequence__init(etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse * data = NULL;

  if (size) {
    data = (etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse *)allocator.zero_allocate(size, sizeof(etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__Sequence__fini(etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__Sequence *
etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__Sequence * array = (etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__Sequence *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__Sequence__destroy(etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__Sequence__are_equal(const etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__Sequence * lhs, const etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__Sequence__copy(
  const etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__Sequence * input,
  etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse * data =
      (etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
