// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cam_ts_msgs:msg/ProtectedCommunicationZone.idl
// generated code does not contain a copyright notice
#include "etsi_its_cam_ts_msgs/msg/detail/protected_communication_zone__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `protected_zone_type`
#include "etsi_its_cam_ts_msgs/msg/detail/protected_zone_type__functions.h"
// Member `expiry_time`
#include "etsi_its_cam_ts_msgs/msg/detail/timestamp_its__functions.h"
// Member `protected_zone_latitude`
#include "etsi_its_cam_ts_msgs/msg/detail/latitude__functions.h"
// Member `protected_zone_longitude`
#include "etsi_its_cam_ts_msgs/msg/detail/longitude__functions.h"
// Member `protected_zone_radius`
#include "etsi_its_cam_ts_msgs/msg/detail/protected_zone_radius__functions.h"
// Member `protected_zone_id`
#include "etsi_its_cam_ts_msgs/msg/detail/protected_zone_id__functions.h"

bool
etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__init(etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone * msg)
{
  if (!msg) {
    return false;
  }
  // protected_zone_type
  if (!etsi_its_cam_ts_msgs__msg__ProtectedZoneType__init(&msg->protected_zone_type)) {
    etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__fini(msg);
    return false;
  }
  // expiry_time
  if (!etsi_its_cam_ts_msgs__msg__TimestampIts__init(&msg->expiry_time)) {
    etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__fini(msg);
    return false;
  }
  // expiry_time_is_present
  // protected_zone_latitude
  if (!etsi_its_cam_ts_msgs__msg__Latitude__init(&msg->protected_zone_latitude)) {
    etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__fini(msg);
    return false;
  }
  // protected_zone_longitude
  if (!etsi_its_cam_ts_msgs__msg__Longitude__init(&msg->protected_zone_longitude)) {
    etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__fini(msg);
    return false;
  }
  // protected_zone_radius
  if (!etsi_its_cam_ts_msgs__msg__ProtectedZoneRadius__init(&msg->protected_zone_radius)) {
    etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__fini(msg);
    return false;
  }
  // protected_zone_radius_is_present
  // protected_zone_id
  if (!etsi_its_cam_ts_msgs__msg__ProtectedZoneId__init(&msg->protected_zone_id)) {
    etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__fini(msg);
    return false;
  }
  // protected_zone_id_is_present
  return true;
}

void
etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__fini(etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone * msg)
{
  if (!msg) {
    return;
  }
  // protected_zone_type
  etsi_its_cam_ts_msgs__msg__ProtectedZoneType__fini(&msg->protected_zone_type);
  // expiry_time
  etsi_its_cam_ts_msgs__msg__TimestampIts__fini(&msg->expiry_time);
  // expiry_time_is_present
  // protected_zone_latitude
  etsi_its_cam_ts_msgs__msg__Latitude__fini(&msg->protected_zone_latitude);
  // protected_zone_longitude
  etsi_its_cam_ts_msgs__msg__Longitude__fini(&msg->protected_zone_longitude);
  // protected_zone_radius
  etsi_its_cam_ts_msgs__msg__ProtectedZoneRadius__fini(&msg->protected_zone_radius);
  // protected_zone_radius_is_present
  // protected_zone_id
  etsi_its_cam_ts_msgs__msg__ProtectedZoneId__fini(&msg->protected_zone_id);
  // protected_zone_id_is_present
}

bool
etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__are_equal(const etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone * lhs, const etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // protected_zone_type
  if (!etsi_its_cam_ts_msgs__msg__ProtectedZoneType__are_equal(
      &(lhs->protected_zone_type), &(rhs->protected_zone_type)))
  {
    return false;
  }
  // expiry_time
  if (!etsi_its_cam_ts_msgs__msg__TimestampIts__are_equal(
      &(lhs->expiry_time), &(rhs->expiry_time)))
  {
    return false;
  }
  // expiry_time_is_present
  if (lhs->expiry_time_is_present != rhs->expiry_time_is_present) {
    return false;
  }
  // protected_zone_latitude
  if (!etsi_its_cam_ts_msgs__msg__Latitude__are_equal(
      &(lhs->protected_zone_latitude), &(rhs->protected_zone_latitude)))
  {
    return false;
  }
  // protected_zone_longitude
  if (!etsi_its_cam_ts_msgs__msg__Longitude__are_equal(
      &(lhs->protected_zone_longitude), &(rhs->protected_zone_longitude)))
  {
    return false;
  }
  // protected_zone_radius
  if (!etsi_its_cam_ts_msgs__msg__ProtectedZoneRadius__are_equal(
      &(lhs->protected_zone_radius), &(rhs->protected_zone_radius)))
  {
    return false;
  }
  // protected_zone_radius_is_present
  if (lhs->protected_zone_radius_is_present != rhs->protected_zone_radius_is_present) {
    return false;
  }
  // protected_zone_id
  if (!etsi_its_cam_ts_msgs__msg__ProtectedZoneId__are_equal(
      &(lhs->protected_zone_id), &(rhs->protected_zone_id)))
  {
    return false;
  }
  // protected_zone_id_is_present
  if (lhs->protected_zone_id_is_present != rhs->protected_zone_id_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__copy(
  const etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone * input,
  etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone * output)
{
  if (!input || !output) {
    return false;
  }
  // protected_zone_type
  if (!etsi_its_cam_ts_msgs__msg__ProtectedZoneType__copy(
      &(input->protected_zone_type), &(output->protected_zone_type)))
  {
    return false;
  }
  // expiry_time
  if (!etsi_its_cam_ts_msgs__msg__TimestampIts__copy(
      &(input->expiry_time), &(output->expiry_time)))
  {
    return false;
  }
  // expiry_time_is_present
  output->expiry_time_is_present = input->expiry_time_is_present;
  // protected_zone_latitude
  if (!etsi_its_cam_ts_msgs__msg__Latitude__copy(
      &(input->protected_zone_latitude), &(output->protected_zone_latitude)))
  {
    return false;
  }
  // protected_zone_longitude
  if (!etsi_its_cam_ts_msgs__msg__Longitude__copy(
      &(input->protected_zone_longitude), &(output->protected_zone_longitude)))
  {
    return false;
  }
  // protected_zone_radius
  if (!etsi_its_cam_ts_msgs__msg__ProtectedZoneRadius__copy(
      &(input->protected_zone_radius), &(output->protected_zone_radius)))
  {
    return false;
  }
  // protected_zone_radius_is_present
  output->protected_zone_radius_is_present = input->protected_zone_radius_is_present;
  // protected_zone_id
  if (!etsi_its_cam_ts_msgs__msg__ProtectedZoneId__copy(
      &(input->protected_zone_id), &(output->protected_zone_id)))
  {
    return false;
  }
  // protected_zone_id_is_present
  output->protected_zone_id_is_present = input->protected_zone_id_is_present;
  return true;
}

etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone *
etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone * msg = (etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone));
  bool success = etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__destroy(etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__Sequence__init(etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone * data = NULL;

  if (size) {
    data = (etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone *)allocator.zero_allocate(size, sizeof(etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__Sequence__fini(etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__Sequence *
etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__Sequence * array = (etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__Sequence *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__Sequence__destroy(etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__Sequence__are_equal(const etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__Sequence * lhs, const etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__Sequence__copy(
  const etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__Sequence * input,
  etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone * data =
      (etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
