// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/ProtectedCommunicationZone.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PROTECTED_COMMUNICATION_ZONE__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PROTECTED_COMMUNICATION_ZONE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'protected_zone_type'
#include "etsi_its_cam_ts_msgs/msg/detail/protected_zone_type__struct.hpp"
// Member 'expiry_time'
#include "etsi_its_cam_ts_msgs/msg/detail/timestamp_its__struct.hpp"
// Member 'protected_zone_latitude'
#include "etsi_its_cam_ts_msgs/msg/detail/latitude__struct.hpp"
// Member 'protected_zone_longitude'
#include "etsi_its_cam_ts_msgs/msg/detail/longitude__struct.hpp"
// Member 'protected_zone_radius'
#include "etsi_its_cam_ts_msgs/msg/detail/protected_zone_radius__struct.hpp"
// Member 'protected_zone_id'
#include "etsi_its_cam_ts_msgs/msg/detail/protected_zone_id__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ProtectedCommunicationZone_
{
  using Type = ProtectedCommunicationZone_<ContainerAllocator>;

  explicit ProtectedCommunicationZone_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : protected_zone_type(_init),
    expiry_time(_init),
    protected_zone_latitude(_init),
    protected_zone_longitude(_init),
    protected_zone_radius(_init),
    protected_zone_id(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->expiry_time_is_present = false;
      this->protected_zone_radius_is_present = false;
      this->protected_zone_id_is_present = false;
    }
  }

  explicit ProtectedCommunicationZone_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : protected_zone_type(_alloc, _init),
    expiry_time(_alloc, _init),
    protected_zone_latitude(_alloc, _init),
    protected_zone_longitude(_alloc, _init),
    protected_zone_radius(_alloc, _init),
    protected_zone_id(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->expiry_time_is_present = false;
      this->protected_zone_radius_is_present = false;
      this->protected_zone_id_is_present = false;
    }
  }

  // field types and members
  using _protected_zone_type_type =
    etsi_its_cam_ts_msgs::msg::ProtectedZoneType_<ContainerAllocator>;
  _protected_zone_type_type protected_zone_type;
  using _expiry_time_type =
    etsi_its_cam_ts_msgs::msg::TimestampIts_<ContainerAllocator>;
  _expiry_time_type expiry_time;
  using _expiry_time_is_present_type =
    bool;
  _expiry_time_is_present_type expiry_time_is_present;
  using _protected_zone_latitude_type =
    etsi_its_cam_ts_msgs::msg::Latitude_<ContainerAllocator>;
  _protected_zone_latitude_type protected_zone_latitude;
  using _protected_zone_longitude_type =
    etsi_its_cam_ts_msgs::msg::Longitude_<ContainerAllocator>;
  _protected_zone_longitude_type protected_zone_longitude;
  using _protected_zone_radius_type =
    etsi_its_cam_ts_msgs::msg::ProtectedZoneRadius_<ContainerAllocator>;
  _protected_zone_radius_type protected_zone_radius;
  using _protected_zone_radius_is_present_type =
    bool;
  _protected_zone_radius_is_present_type protected_zone_radius_is_present;
  using _protected_zone_id_type =
    etsi_its_cam_ts_msgs::msg::ProtectedZoneId_<ContainerAllocator>;
  _protected_zone_id_type protected_zone_id;
  using _protected_zone_id_is_present_type =
    bool;
  _protected_zone_id_is_present_type protected_zone_id_is_present;

  // setters for named parameter idiom
  Type & set__protected_zone_type(
    const etsi_its_cam_ts_msgs::msg::ProtectedZoneType_<ContainerAllocator> & _arg)
  {
    this->protected_zone_type = _arg;
    return *this;
  }
  Type & set__expiry_time(
    const etsi_its_cam_ts_msgs::msg::TimestampIts_<ContainerAllocator> & _arg)
  {
    this->expiry_time = _arg;
    return *this;
  }
  Type & set__expiry_time_is_present(
    const bool & _arg)
  {
    this->expiry_time_is_present = _arg;
    return *this;
  }
  Type & set__protected_zone_latitude(
    const etsi_its_cam_ts_msgs::msg::Latitude_<ContainerAllocator> & _arg)
  {
    this->protected_zone_latitude = _arg;
    return *this;
  }
  Type & set__protected_zone_longitude(
    const etsi_its_cam_ts_msgs::msg::Longitude_<ContainerAllocator> & _arg)
  {
    this->protected_zone_longitude = _arg;
    return *this;
  }
  Type & set__protected_zone_radius(
    const etsi_its_cam_ts_msgs::msg::ProtectedZoneRadius_<ContainerAllocator> & _arg)
  {
    this->protected_zone_radius = _arg;
    return *this;
  }
  Type & set__protected_zone_radius_is_present(
    const bool & _arg)
  {
    this->protected_zone_radius_is_present = _arg;
    return *this;
  }
  Type & set__protected_zone_id(
    const etsi_its_cam_ts_msgs::msg::ProtectedZoneId_<ContainerAllocator> & _arg)
  {
    this->protected_zone_id = _arg;
    return *this;
  }
  Type & set__protected_zone_id_is_present(
    const bool & _arg)
  {
    this->protected_zone_id_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::ProtectedCommunicationZone_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::ProtectedCommunicationZone_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::ProtectedCommunicationZone_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::ProtectedCommunicationZone_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::ProtectedCommunicationZone_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::ProtectedCommunicationZone_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::ProtectedCommunicationZone_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::ProtectedCommunicationZone_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::ProtectedCommunicationZone_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::ProtectedCommunicationZone_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::ProtectedCommunicationZone_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__ProtectedCommunicationZone
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::ProtectedCommunicationZone_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ProtectedCommunicationZone_ & other) const
  {
    if (this->protected_zone_type != other.protected_zone_type) {
      return false;
    }
    if (this->expiry_time != other.expiry_time) {
      return false;
    }
    if (this->expiry_time_is_present != other.expiry_time_is_present) {
      return false;
    }
    if (this->protected_zone_latitude != other.protected_zone_latitude) {
      return false;
    }
    if (this->protected_zone_longitude != other.protected_zone_longitude) {
      return false;
    }
    if (this->protected_zone_radius != other.protected_zone_radius) {
      return false;
    }
    if (this->protected_zone_radius_is_present != other.protected_zone_radius_is_present) {
      return false;
    }
    if (this->protected_zone_id != other.protected_zone_id) {
      return false;
    }
    if (this->protected_zone_id_is_present != other.protected_zone_id_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const ProtectedCommunicationZone_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ProtectedCommunicationZone_

// alias to use template instance with default allocator
using ProtectedCommunicationZone =
  etsi_its_cam_ts_msgs::msg::ProtectedCommunicationZone_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PROTECTED_COMMUNICATION_ZONE__STRUCT_HPP_
