// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/ProtectedCommunicationZone.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PROTECTED_COMMUNICATION_ZONE__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PROTECTED_COMMUNICATION_ZONE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/protected_communication_zone__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'protected_zone_type'
#include "etsi_its_cam_ts_msgs/msg/detail/protected_zone_type__traits.hpp"
// Member 'expiry_time'
#include "etsi_its_cam_ts_msgs/msg/detail/timestamp_its__traits.hpp"
// Member 'protected_zone_latitude'
#include "etsi_its_cam_ts_msgs/msg/detail/latitude__traits.hpp"
// Member 'protected_zone_longitude'
#include "etsi_its_cam_ts_msgs/msg/detail/longitude__traits.hpp"
// Member 'protected_zone_radius'
#include "etsi_its_cam_ts_msgs/msg/detail/protected_zone_radius__traits.hpp"
// Member 'protected_zone_id'
#include "etsi_its_cam_ts_msgs/msg/detail/protected_zone_id__traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ProtectedCommunicationZone & msg,
  std::ostream & out)
{
  out << "{";
  // member: protected_zone_type
  {
    out << "protected_zone_type: ";
    to_flow_style_yaml(msg.protected_zone_type, out);
    out << ", ";
  }

  // member: expiry_time
  {
    out << "expiry_time: ";
    to_flow_style_yaml(msg.expiry_time, out);
    out << ", ";
  }

  // member: expiry_time_is_present
  {
    out << "expiry_time_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.expiry_time_is_present, out);
    out << ", ";
  }

  // member: protected_zone_latitude
  {
    out << "protected_zone_latitude: ";
    to_flow_style_yaml(msg.protected_zone_latitude, out);
    out << ", ";
  }

  // member: protected_zone_longitude
  {
    out << "protected_zone_longitude: ";
    to_flow_style_yaml(msg.protected_zone_longitude, out);
    out << ", ";
  }

  // member: protected_zone_radius
  {
    out << "protected_zone_radius: ";
    to_flow_style_yaml(msg.protected_zone_radius, out);
    out << ", ";
  }

  // member: protected_zone_radius_is_present
  {
    out << "protected_zone_radius_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.protected_zone_radius_is_present, out);
    out << ", ";
  }

  // member: protected_zone_id
  {
    out << "protected_zone_id: ";
    to_flow_style_yaml(msg.protected_zone_id, out);
    out << ", ";
  }

  // member: protected_zone_id_is_present
  {
    out << "protected_zone_id_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.protected_zone_id_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ProtectedCommunicationZone & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: protected_zone_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "protected_zone_type:\n";
    to_block_style_yaml(msg.protected_zone_type, out, indentation + 2);
  }

  // member: expiry_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "expiry_time:\n";
    to_block_style_yaml(msg.expiry_time, out, indentation + 2);
  }

  // member: expiry_time_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "expiry_time_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.expiry_time_is_present, out);
    out << "\n";
  }

  // member: protected_zone_latitude
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "protected_zone_latitude:\n";
    to_block_style_yaml(msg.protected_zone_latitude, out, indentation + 2);
  }

  // member: protected_zone_longitude
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "protected_zone_longitude:\n";
    to_block_style_yaml(msg.protected_zone_longitude, out, indentation + 2);
  }

  // member: protected_zone_radius
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "protected_zone_radius:\n";
    to_block_style_yaml(msg.protected_zone_radius, out, indentation + 2);
  }

  // member: protected_zone_radius_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "protected_zone_radius_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.protected_zone_radius_is_present, out);
    out << "\n";
  }

  // member: protected_zone_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "protected_zone_id:\n";
    to_block_style_yaml(msg.protected_zone_id, out, indentation + 2);
  }

  // member: protected_zone_id_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "protected_zone_id_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.protected_zone_id_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ProtectedCommunicationZone & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::ProtectedCommunicationZone & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::ProtectedCommunicationZone & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::ProtectedCommunicationZone>()
{
  return "etsi_its_cam_ts_msgs::msg::ProtectedCommunicationZone";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::ProtectedCommunicationZone>()
{
  return "etsi_its_cam_ts_msgs/msg/ProtectedCommunicationZone";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::ProtectedCommunicationZone>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_ts_msgs::msg::Latitude>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::Longitude>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::ProtectedZoneId>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::ProtectedZoneRadius>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::ProtectedZoneType>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::TimestampIts>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::ProtectedCommunicationZone>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_ts_msgs::msg::Latitude>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::Longitude>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::ProtectedZoneId>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::ProtectedZoneRadius>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::ProtectedZoneType>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::TimestampIts>::value> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::ProtectedCommunicationZone>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PROTECTED_COMMUNICATION_ZONE__TRAITS_HPP_
