// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/PtActivationType.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PT_ACTIVATION_TYPE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PT_ACTIVATION_TYPE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__PtActivationType__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__PtActivationType__MAX = 255
};

/// Constant 'UNDEFINED_CODING_TYPE'.
enum
{
  etsi_its_cam_ts_msgs__msg__PtActivationType__UNDEFINED_CODING_TYPE = 0
};

/// Constant 'R09_16_CODING_TYPE'.
enum
{
  etsi_its_cam_ts_msgs__msg__PtActivationType__R09_16_CODING_TYPE = 1
};

/// Constant 'VDV_50149_CODING_TYPE'.
enum
{
  etsi_its_cam_ts_msgs__msg__PtActivationType__VDV_50149_CODING_TYPE = 2
};

/// Struct defined in msg/PtActivationType in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__PtActivationType
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates a certain coding type of the PtActivationData data.
  ///  *
  ///  * The folowing value are specified:
  ///  * - 0 `undefinedCodingType`  : undefined coding type,
  ///  * - 1 `r09-16CodingType`     : coding of PtActivationData conform to VDV recommendation 420 [7],
  ///  * - 2 `vdv-50149CodingType`  : coding of PtActivationData based on VDV recommendation 420 [7].
  ///  * - 3 - 255                  : reserved for alternative and future use.
  ///  *
  ///  * @category: Vehicle information
  ///  * @revision: V1.3.1
  ///  */
  /// PtActivationType ::= INTEGER {
  ///     undefinedCodingType (0),
  ///     r09-16CodingType    (1),
  ///     vdv-50149CodingType (2)
  /// } (0..255)
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__PtActivationType;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__PtActivationType.
typedef struct etsi_its_cam_ts_msgs__msg__PtActivationType__Sequence
{
  etsi_its_cam_ts_msgs__msg__PtActivationType * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__PtActivationType__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PT_ACTIVATION_TYPE__STRUCT_H_
