// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/RescueAndRecoveryWorkInProgressSubCauseCode.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__RESCUE_AND_RECOVERY_WORK_IN_PROGRESS_SUB_CAUSE_CODE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__RESCUE_AND_RECOVERY_WORK_IN_PROGRESS_SUB_CAUSE_CODE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__MAX = 255
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__UNAVAILABLE = 0
};

/// Constant 'EMERGENCY_VEHICLES'.
enum
{
  etsi_its_cam_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__EMERGENCY_VEHICLES = 1
};

/// Constant 'RESCUE_HELICOPTER_LANDING'.
enum
{
  etsi_its_cam_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__RESCUE_HELICOPTER_LANDING = 2
};

/// Constant 'POLICE_ACTIVITY_ONGOING'.
enum
{
  etsi_its_cam_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__POLICE_ACTIVITY_ONGOING = 3
};

/// Constant 'MEDICAL_EMERGENCY_ONGOING'.
enum
{
  etsi_its_cam_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__MEDICAL_EMERGENCY_ONGOING = 4
};

/// Constant 'CHILD_ABDUCTION_IN_PROGRESS'.
enum
{
  etsi_its_cam_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__CHILD_ABDUCTION_IN_PROGRESS = 5
};

/// Constant 'PRIORITIZED_VEHICLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__PRIORITIZED_VEHICLE = 6
};

/// Constant 'RESCUE_AND_RECOVERY_VEHICLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__RESCUE_AND_RECOVERY_VEHICLE = 7
};

/// Struct defined in msg/RescueAndRecoveryWorkInProgressSubCauseCode in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents the value of the sub cause codes of the @ref CauseCode `rescueAndRecoveryWorkInProgress`
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 `unavailable`              - in case further detailed information on rescue and recovery work is unavailable,
  ///  * - 1 `emergencyVehicles`        - in case rescue and/or safeguarding work is ongoing by emergency vehicles, i.e. by vehicles that have the absolute right of way,
  ///  * - 2 `rescueHelicopterLanding`  - in case rescue helicopter is landing,
  ///  * - 3 `policeActivityOngoing`    - in case police activity is ongoing (only to be used if a more specific sub cause than (1) is needed),
  ///  * - 4 `medicalEmergencyOngoing`  - in case medical emergency recovery is ongoing (only to be used if a more specific sub cause than (1) is needed),
  ///  * - 5 `childAbductionInProgress` - in case a child kidnapping alarm is activated and rescue work is ongoing (only to be used if a more specific sub cause than (1) is needed),
  ///  * - 6 `prioritizedVehicle`       - in case rescue and/or safeguarding work is ongoing by prioritized vehicles, i.e. by vehicles that have priority but not the absolute right of way,
  ///  * - 7 `rescueAndRecoveryVehicle` - in case technical rescue work is ongoing by rescue and recovery vehicles.
  ///  * - 8-255: reserved for future usage.
  ///
  ///  *
  ///  * @category: Traffic information
  ///  * @revision: V1.3.1, named values 6 and 7 added in V2.2.1
  ///  */
  /// RescueAndRecoveryWorkInProgressSubCauseCode ::= INTEGER {
  ///    unavailable              (0),
  ///    emergencyVehicles        (1),
  ///    rescueHelicopterLanding  (2),
  ///    policeActivityOngoing    (3),
  ///    medicalEmergencyOngoing  (4),
  ///    childAbductionInProgress (5),
  ///    prioritizedVehicle       (6),
  ///    rescueAndRecoveryVehicle (7)
  /// } (0..255)
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode.
typedef struct etsi_its_cam_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__Sequence
{
  etsi_its_cam_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__RescueAndRecoveryWorkInProgressSubCauseCode__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__RESCUE_AND_RECOVERY_WORK_IN_PROGRESS_SUB_CAUSE_CODE__STRUCT_H_
