// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/RescueContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__RESCUE_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__RESCUE_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'light_bar_siren_in_use'
#include "etsi_its_cam_ts_msgs/msg/detail/light_bar_siren_in_use__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__RescueContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__RescueContainer __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RescueContainer_
{
  using Type = RescueContainer_<ContainerAllocator>;

  explicit RescueContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : light_bar_siren_in_use(_init)
  {
    (void)_init;
  }

  explicit RescueContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : light_bar_siren_in_use(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _light_bar_siren_in_use_type =
    etsi_its_cam_ts_msgs::msg::LightBarSirenInUse_<ContainerAllocator>;
  _light_bar_siren_in_use_type light_bar_siren_in_use;

  // setters for named parameter idiom
  Type & set__light_bar_siren_in_use(
    const etsi_its_cam_ts_msgs::msg::LightBarSirenInUse_<ContainerAllocator> & _arg)
  {
    this->light_bar_siren_in_use = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::RescueContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::RescueContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::RescueContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::RescueContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::RescueContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::RescueContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::RescueContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::RescueContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::RescueContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::RescueContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__RescueContainer
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::RescueContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__RescueContainer
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::RescueContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RescueContainer_ & other) const
  {
    if (this->light_bar_siren_in_use != other.light_bar_siren_in_use) {
      return false;
    }
    return true;
  }
  bool operator!=(const RescueContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RescueContainer_

// alias to use template instance with default allocator
using RescueContainer =
  etsi_its_cam_ts_msgs::msg::RescueContainer_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__RESCUE_CONTAINER__STRUCT_HPP_
