// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cam_ts_msgs:msg/RoadWorksContainerBasic.idl
// generated code does not contain a copyright notice
#include "etsi_its_cam_ts_msgs/msg/detail/road_works_container_basic__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `roadworks_sub_cause_code`
#include "etsi_its_cam_ts_msgs/msg/detail/roadworks_sub_cause_code__functions.h"
// Member `light_bar_siren_in_use`
#include "etsi_its_cam_ts_msgs/msg/detail/light_bar_siren_in_use__functions.h"
// Member `closed_lanes`
#include "etsi_its_cam_ts_msgs/msg/detail/closed_lanes__functions.h"

bool
etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__init(etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic * msg)
{
  if (!msg) {
    return false;
  }
  // roadworks_sub_cause_code
  if (!etsi_its_cam_ts_msgs__msg__RoadworksSubCauseCode__init(&msg->roadworks_sub_cause_code)) {
    etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__fini(msg);
    return false;
  }
  // roadworks_sub_cause_code_is_present
  // light_bar_siren_in_use
  if (!etsi_its_cam_ts_msgs__msg__LightBarSirenInUse__init(&msg->light_bar_siren_in_use)) {
    etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__fini(msg);
    return false;
  }
  // closed_lanes
  if (!etsi_its_cam_ts_msgs__msg__ClosedLanes__init(&msg->closed_lanes)) {
    etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__fini(msg);
    return false;
  }
  // closed_lanes_is_present
  return true;
}

void
etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__fini(etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic * msg)
{
  if (!msg) {
    return;
  }
  // roadworks_sub_cause_code
  etsi_its_cam_ts_msgs__msg__RoadworksSubCauseCode__fini(&msg->roadworks_sub_cause_code);
  // roadworks_sub_cause_code_is_present
  // light_bar_siren_in_use
  etsi_its_cam_ts_msgs__msg__LightBarSirenInUse__fini(&msg->light_bar_siren_in_use);
  // closed_lanes
  etsi_its_cam_ts_msgs__msg__ClosedLanes__fini(&msg->closed_lanes);
  // closed_lanes_is_present
}

bool
etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__are_equal(const etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic * lhs, const etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // roadworks_sub_cause_code
  if (!etsi_its_cam_ts_msgs__msg__RoadworksSubCauseCode__are_equal(
      &(lhs->roadworks_sub_cause_code), &(rhs->roadworks_sub_cause_code)))
  {
    return false;
  }
  // roadworks_sub_cause_code_is_present
  if (lhs->roadworks_sub_cause_code_is_present != rhs->roadworks_sub_cause_code_is_present) {
    return false;
  }
  // light_bar_siren_in_use
  if (!etsi_its_cam_ts_msgs__msg__LightBarSirenInUse__are_equal(
      &(lhs->light_bar_siren_in_use), &(rhs->light_bar_siren_in_use)))
  {
    return false;
  }
  // closed_lanes
  if (!etsi_its_cam_ts_msgs__msg__ClosedLanes__are_equal(
      &(lhs->closed_lanes), &(rhs->closed_lanes)))
  {
    return false;
  }
  // closed_lanes_is_present
  if (lhs->closed_lanes_is_present != rhs->closed_lanes_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__copy(
  const etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic * input,
  etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic * output)
{
  if (!input || !output) {
    return false;
  }
  // roadworks_sub_cause_code
  if (!etsi_its_cam_ts_msgs__msg__RoadworksSubCauseCode__copy(
      &(input->roadworks_sub_cause_code), &(output->roadworks_sub_cause_code)))
  {
    return false;
  }
  // roadworks_sub_cause_code_is_present
  output->roadworks_sub_cause_code_is_present = input->roadworks_sub_cause_code_is_present;
  // light_bar_siren_in_use
  if (!etsi_its_cam_ts_msgs__msg__LightBarSirenInUse__copy(
      &(input->light_bar_siren_in_use), &(output->light_bar_siren_in_use)))
  {
    return false;
  }
  // closed_lanes
  if (!etsi_its_cam_ts_msgs__msg__ClosedLanes__copy(
      &(input->closed_lanes), &(output->closed_lanes)))
  {
    return false;
  }
  // closed_lanes_is_present
  output->closed_lanes_is_present = input->closed_lanes_is_present;
  return true;
}

etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic *
etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic * msg = (etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic));
  bool success = etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__destroy(etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__Sequence__init(etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic * data = NULL;

  if (size) {
    data = (etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic *)allocator.zero_allocate(size, sizeof(etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__Sequence__fini(etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__Sequence *
etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__Sequence * array = (etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__Sequence *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__Sequence__destroy(etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__Sequence__are_equal(const etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__Sequence * lhs, const etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__Sequence__copy(
  const etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__Sequence * input,
  etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic * data =
      (etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
