// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/RoadWorksContainerBasic.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ROAD_WORKS_CONTAINER_BASIC__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ROAD_WORKS_CONTAINER_BASIC__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'roadworks_sub_cause_code'
#include "etsi_its_cam_ts_msgs/msg/detail/roadworks_sub_cause_code__struct.hpp"
// Member 'light_bar_siren_in_use'
#include "etsi_its_cam_ts_msgs/msg/detail/light_bar_siren_in_use__struct.hpp"
// Member 'closed_lanes'
#include "etsi_its_cam_ts_msgs/msg/detail/closed_lanes__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RoadWorksContainerBasic_
{
  using Type = RoadWorksContainerBasic_<ContainerAllocator>;

  explicit RoadWorksContainerBasic_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : roadworks_sub_cause_code(_init),
    light_bar_siren_in_use(_init),
    closed_lanes(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->roadworks_sub_cause_code_is_present = false;
      this->closed_lanes_is_present = false;
    }
  }

  explicit RoadWorksContainerBasic_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : roadworks_sub_cause_code(_alloc, _init),
    light_bar_siren_in_use(_alloc, _init),
    closed_lanes(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->roadworks_sub_cause_code_is_present = false;
      this->closed_lanes_is_present = false;
    }
  }

  // field types and members
  using _roadworks_sub_cause_code_type =
    etsi_its_cam_ts_msgs::msg::RoadworksSubCauseCode_<ContainerAllocator>;
  _roadworks_sub_cause_code_type roadworks_sub_cause_code;
  using _roadworks_sub_cause_code_is_present_type =
    bool;
  _roadworks_sub_cause_code_is_present_type roadworks_sub_cause_code_is_present;
  using _light_bar_siren_in_use_type =
    etsi_its_cam_ts_msgs::msg::LightBarSirenInUse_<ContainerAllocator>;
  _light_bar_siren_in_use_type light_bar_siren_in_use;
  using _closed_lanes_type =
    etsi_its_cam_ts_msgs::msg::ClosedLanes_<ContainerAllocator>;
  _closed_lanes_type closed_lanes;
  using _closed_lanes_is_present_type =
    bool;
  _closed_lanes_is_present_type closed_lanes_is_present;

  // setters for named parameter idiom
  Type & set__roadworks_sub_cause_code(
    const etsi_its_cam_ts_msgs::msg::RoadworksSubCauseCode_<ContainerAllocator> & _arg)
  {
    this->roadworks_sub_cause_code = _arg;
    return *this;
  }
  Type & set__roadworks_sub_cause_code_is_present(
    const bool & _arg)
  {
    this->roadworks_sub_cause_code_is_present = _arg;
    return *this;
  }
  Type & set__light_bar_siren_in_use(
    const etsi_its_cam_ts_msgs::msg::LightBarSirenInUse_<ContainerAllocator> & _arg)
  {
    this->light_bar_siren_in_use = _arg;
    return *this;
  }
  Type & set__closed_lanes(
    const etsi_its_cam_ts_msgs::msg::ClosedLanes_<ContainerAllocator> & _arg)
  {
    this->closed_lanes = _arg;
    return *this;
  }
  Type & set__closed_lanes_is_present(
    const bool & _arg)
  {
    this->closed_lanes_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RoadWorksContainerBasic_ & other) const
  {
    if (this->roadworks_sub_cause_code != other.roadworks_sub_cause_code) {
      return false;
    }
    if (this->roadworks_sub_cause_code_is_present != other.roadworks_sub_cause_code_is_present) {
      return false;
    }
    if (this->light_bar_siren_in_use != other.light_bar_siren_in_use) {
      return false;
    }
    if (this->closed_lanes != other.closed_lanes) {
      return false;
    }
    if (this->closed_lanes_is_present != other.closed_lanes_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const RoadWorksContainerBasic_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RoadWorksContainerBasic_

// alias to use template instance with default allocator
using RoadWorksContainerBasic =
  etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ROAD_WORKS_CONTAINER_BASIC__STRUCT_HPP_
