// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/SafetyCarContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SAFETY_CAR_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SAFETY_CAR_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'light_bar_siren_in_use'
#include "etsi_its_cam_ts_msgs/msg/detail/light_bar_siren_in_use__struct.hpp"
// Member 'incident_indication'
#include "etsi_its_cam_ts_msgs/msg/detail/cause_code_v2__struct.hpp"
// Member 'traffic_rule'
#include "etsi_its_cam_ts_msgs/msg/detail/traffic_rule__struct.hpp"
// Member 'speed_limit'
#include "etsi_its_cam_ts_msgs/msg/detail/speed_limit__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__SafetyCarContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__SafetyCarContainer __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SafetyCarContainer_
{
  using Type = SafetyCarContainer_<ContainerAllocator>;

  explicit SafetyCarContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : light_bar_siren_in_use(_init),
    incident_indication(_init),
    traffic_rule(_init),
    speed_limit(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->incident_indication_is_present = false;
      this->traffic_rule_is_present = false;
      this->speed_limit_is_present = false;
    }
  }

  explicit SafetyCarContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : light_bar_siren_in_use(_alloc, _init),
    incident_indication(_alloc, _init),
    traffic_rule(_alloc, _init),
    speed_limit(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->incident_indication_is_present = false;
      this->traffic_rule_is_present = false;
      this->speed_limit_is_present = false;
    }
  }

  // field types and members
  using _light_bar_siren_in_use_type =
    etsi_its_cam_ts_msgs::msg::LightBarSirenInUse_<ContainerAllocator>;
  _light_bar_siren_in_use_type light_bar_siren_in_use;
  using _incident_indication_type =
    etsi_its_cam_ts_msgs::msg::CauseCodeV2_<ContainerAllocator>;
  _incident_indication_type incident_indication;
  using _incident_indication_is_present_type =
    bool;
  _incident_indication_is_present_type incident_indication_is_present;
  using _traffic_rule_type =
    etsi_its_cam_ts_msgs::msg::TrafficRule_<ContainerAllocator>;
  _traffic_rule_type traffic_rule;
  using _traffic_rule_is_present_type =
    bool;
  _traffic_rule_is_present_type traffic_rule_is_present;
  using _speed_limit_type =
    etsi_its_cam_ts_msgs::msg::SpeedLimit_<ContainerAllocator>;
  _speed_limit_type speed_limit;
  using _speed_limit_is_present_type =
    bool;
  _speed_limit_is_present_type speed_limit_is_present;

  // setters for named parameter idiom
  Type & set__light_bar_siren_in_use(
    const etsi_its_cam_ts_msgs::msg::LightBarSirenInUse_<ContainerAllocator> & _arg)
  {
    this->light_bar_siren_in_use = _arg;
    return *this;
  }
  Type & set__incident_indication(
    const etsi_its_cam_ts_msgs::msg::CauseCodeV2_<ContainerAllocator> & _arg)
  {
    this->incident_indication = _arg;
    return *this;
  }
  Type & set__incident_indication_is_present(
    const bool & _arg)
  {
    this->incident_indication_is_present = _arg;
    return *this;
  }
  Type & set__traffic_rule(
    const etsi_its_cam_ts_msgs::msg::TrafficRule_<ContainerAllocator> & _arg)
  {
    this->traffic_rule = _arg;
    return *this;
  }
  Type & set__traffic_rule_is_present(
    const bool & _arg)
  {
    this->traffic_rule_is_present = _arg;
    return *this;
  }
  Type & set__speed_limit(
    const etsi_its_cam_ts_msgs::msg::SpeedLimit_<ContainerAllocator> & _arg)
  {
    this->speed_limit = _arg;
    return *this;
  }
  Type & set__speed_limit_is_present(
    const bool & _arg)
  {
    this->speed_limit_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::SafetyCarContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::SafetyCarContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::SafetyCarContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::SafetyCarContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::SafetyCarContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::SafetyCarContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::SafetyCarContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::SafetyCarContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::SafetyCarContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::SafetyCarContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__SafetyCarContainer
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::SafetyCarContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__SafetyCarContainer
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::SafetyCarContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SafetyCarContainer_ & other) const
  {
    if (this->light_bar_siren_in_use != other.light_bar_siren_in_use) {
      return false;
    }
    if (this->incident_indication != other.incident_indication) {
      return false;
    }
    if (this->incident_indication_is_present != other.incident_indication_is_present) {
      return false;
    }
    if (this->traffic_rule != other.traffic_rule) {
      return false;
    }
    if (this->traffic_rule_is_present != other.traffic_rule_is_present) {
      return false;
    }
    if (this->speed_limit != other.speed_limit) {
      return false;
    }
    if (this->speed_limit_is_present != other.speed_limit_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const SafetyCarContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SafetyCarContainer_

// alias to use template instance with default allocator
using SafetyCarContainer =
  etsi_its_cam_ts_msgs::msg::SafetyCarContainer_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SAFETY_CAR_CONTAINER__STRUCT_HPP_
