// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/SpecialTransportContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SPECIAL_TRANSPORT_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SPECIAL_TRANSPORT_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'special_transport_type'
#include "etsi_its_cam_ts_msgs/msg/detail/special_transport_type__struct.hpp"
// Member 'light_bar_siren_in_use'
#include "etsi_its_cam_ts_msgs/msg/detail/light_bar_siren_in_use__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__SpecialTransportContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__SpecialTransportContainer __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SpecialTransportContainer_
{
  using Type = SpecialTransportContainer_<ContainerAllocator>;

  explicit SpecialTransportContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : special_transport_type(_init),
    light_bar_siren_in_use(_init)
  {
    (void)_init;
  }

  explicit SpecialTransportContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : special_transport_type(_alloc, _init),
    light_bar_siren_in_use(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _special_transport_type_type =
    etsi_its_cam_ts_msgs::msg::SpecialTransportType_<ContainerAllocator>;
  _special_transport_type_type special_transport_type;
  using _light_bar_siren_in_use_type =
    etsi_its_cam_ts_msgs::msg::LightBarSirenInUse_<ContainerAllocator>;
  _light_bar_siren_in_use_type light_bar_siren_in_use;

  // setters for named parameter idiom
  Type & set__special_transport_type(
    const etsi_its_cam_ts_msgs::msg::SpecialTransportType_<ContainerAllocator> & _arg)
  {
    this->special_transport_type = _arg;
    return *this;
  }
  Type & set__light_bar_siren_in_use(
    const etsi_its_cam_ts_msgs::msg::LightBarSirenInUse_<ContainerAllocator> & _arg)
  {
    this->light_bar_siren_in_use = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::SpecialTransportContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::SpecialTransportContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::SpecialTransportContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::SpecialTransportContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::SpecialTransportContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::SpecialTransportContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::SpecialTransportContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::SpecialTransportContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::SpecialTransportContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::SpecialTransportContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__SpecialTransportContainer
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::SpecialTransportContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__SpecialTransportContainer
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::SpecialTransportContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SpecialTransportContainer_ & other) const
  {
    if (this->special_transport_type != other.special_transport_type) {
      return false;
    }
    if (this->light_bar_siren_in_use != other.light_bar_siren_in_use) {
      return false;
    }
    return true;
  }
  bool operator!=(const SpecialTransportContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SpecialTransportContainer_

// alias to use template instance with default allocator
using SpecialTransportContainer =
  etsi_its_cam_ts_msgs::msg::SpecialTransportContainer_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SPECIAL_TRANSPORT_CONTAINER__STRUCT_HPP_
