// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/SpecialTransportType.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SPECIAL_TRANSPORT_TYPE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SPECIAL_TRANSPORT_TYPE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'SIZE_BITS'.
enum
{
  etsi_its_cam_ts_msgs__msg__SpecialTransportType__SIZE_BITS = 4
};

/// Constant 'BIT_INDEX_HEAVY_LOAD'.
enum
{
  etsi_its_cam_ts_msgs__msg__SpecialTransportType__BIT_INDEX_HEAVY_LOAD = 0
};

/// Constant 'BIT_INDEX_EXCESS_WIDTH'.
enum
{
  etsi_its_cam_ts_msgs__msg__SpecialTransportType__BIT_INDEX_EXCESS_WIDTH = 1
};

/// Constant 'BIT_INDEX_EXCESS_LENGTH'.
enum
{
  etsi_its_cam_ts_msgs__msg__SpecialTransportType__BIT_INDEX_EXCESS_LENGTH = 2
};

/// Constant 'BIT_INDEX_EXCESS_HEIGHT'.
enum
{
  etsi_its_cam_ts_msgs__msg__SpecialTransportType__BIT_INDEX_EXCESS_HEIGHT = 3
};

// Include directives for member types
// Member 'value'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/SpecialTransportType in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__SpecialTransportType
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * The DE indicates if a vehicle is carrying goods in the special transport conditions.
  ///  *
  ///  * The corresponding bit shall be set to 1 under the following conditions:
  ///  * - 0 `heavyLoad`        - the vehicle is carrying goods with heavy load,
  ///  * - 1 `excessWidth`      - the vehicle is carrying goods in excess of width,
  ///  * - 2 `excessLength`     - the vehicle is carrying goods in excess of length,
  ///  * - 3 `excessHeight`     - the vehicle is carrying goods in excess of height.
  ///  *
  ///  * Otherwise, the corresponding bit shall be set to 0.
  ///  * @category Vehicle information
  ///  * @revision: Description revised in V2.1.1
  ///  */
  /// SpecialTransportType ::= BIT STRING {
  ///     heavyLoad    (0),
  ///     excessWidth  (1),
  ///     excessLength (2),
  ///     excessHeight (3)
  /// } (SIZE(4))
  /// ------------------------------------------------------------------------------
  rosidl_runtime_c__uint8__Sequence value;
  uint8_t bits_unused;
} etsi_its_cam_ts_msgs__msg__SpecialTransportType;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__SpecialTransportType.
typedef struct etsi_its_cam_ts_msgs__msg__SpecialTransportType__Sequence
{
  etsi_its_cam_ts_msgs__msg__SpecialTransportType * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__SpecialTransportType__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SPECIAL_TRANSPORT_TYPE__STRUCT_H_
