// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/SteeringWheelAngle.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__STEERING_WHEEL_ANGLE__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__STEERING_WHEEL_ANGLE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/steering_wheel_angle__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'steering_wheel_angle_value'
#include "etsi_its_cam_ts_msgs/msg/detail/steering_wheel_angle_value__traits.hpp"
// Member 'steering_wheel_angle_confidence'
#include "etsi_its_cam_ts_msgs/msg/detail/steering_wheel_angle_confidence__traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SteeringWheelAngle & msg,
  std::ostream & out)
{
  out << "{";
  // member: steering_wheel_angle_value
  {
    out << "steering_wheel_angle_value: ";
    to_flow_style_yaml(msg.steering_wheel_angle_value, out);
    out << ", ";
  }

  // member: steering_wheel_angle_confidence
  {
    out << "steering_wheel_angle_confidence: ";
    to_flow_style_yaml(msg.steering_wheel_angle_confidence, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SteeringWheelAngle & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: steering_wheel_angle_value
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "steering_wheel_angle_value:\n";
    to_block_style_yaml(msg.steering_wheel_angle_value, out, indentation + 2);
  }

  // member: steering_wheel_angle_confidence
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "steering_wheel_angle_confidence:\n";
    to_block_style_yaml(msg.steering_wheel_angle_confidence, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SteeringWheelAngle & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::SteeringWheelAngle & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::SteeringWheelAngle & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::SteeringWheelAngle>()
{
  return "etsi_its_cam_ts_msgs::msg::SteeringWheelAngle";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::SteeringWheelAngle>()
{
  return "etsi_its_cam_ts_msgs/msg/SteeringWheelAngle";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::SteeringWheelAngle>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_ts_msgs::msg::SteeringWheelAngleConfidence>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::SteeringWheelAngleValue>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::SteeringWheelAngle>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_ts_msgs::msg::SteeringWheelAngleConfidence>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::SteeringWheelAngleValue>::value> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::SteeringWheelAngle>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__STEERING_WHEEL_ANGLE__TRAITS_HPP_
