// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/TrafficConditionSubCauseCode.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__TRAFFIC_CONDITION_SUB_CAUSE_CODE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__TRAFFIC_CONDITION_SUB_CAUSE_CODE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficConditionSubCauseCode__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficConditionSubCauseCode__MAX = 255
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficConditionSubCauseCode__UNAVAILABLE = 0
};

/// Constant 'INCREASED_VOLUME_OF_TRAFFIC'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficConditionSubCauseCode__INCREASED_VOLUME_OF_TRAFFIC = 1
};

/// Constant 'TRAFFIC_JAM_SLOWLY_INCREASING'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficConditionSubCauseCode__TRAFFIC_JAM_SLOWLY_INCREASING = 2
};

/// Constant 'TRAFFIC_JAM_INCREASING'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficConditionSubCauseCode__TRAFFIC_JAM_INCREASING = 3
};

/// Constant 'TRAFFIC_JAM_STRONGLY_INCREASING'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficConditionSubCauseCode__TRAFFIC_JAM_STRONGLY_INCREASING = 4
};

/// Constant 'TRAFFIC_JAM'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficConditionSubCauseCode__TRAFFIC_JAM = 5
};

/// Constant 'TRAFFIC_JAM_SLIGHTLY_DECREASING'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficConditionSubCauseCode__TRAFFIC_JAM_SLIGHTLY_DECREASING = 6
};

/// Constant 'TRAFFIC_JAM_DECREASING'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficConditionSubCauseCode__TRAFFIC_JAM_DECREASING = 7
};

/// Constant 'TRAFFIC_JAM_STRONGLY_DECREASING'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficConditionSubCauseCode__TRAFFIC_JAM_STRONGLY_DECREASING = 8
};

/// Constant 'TRAFFIC_JAM_STABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__TrafficConditionSubCauseCode__TRAFFIC_JAM_STABLE = 9
};

/// Struct defined in msg/TrafficConditionSubCauseCode in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__TrafficConditionSubCauseCode
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents the value of the sub cause codes of the @ref CauseCode `trafficCondition`.
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 `unavailable`                  - in case further detailed information on the traffic condition is unavailable,
  ///  * - 1 `increasedVolumeOfTraffic`     - in case the type of traffic condition is increased traffic volume,
  ///  * - 2 `trafficJamSlowlyIncreasing`   - in case the type of traffic condition is a traffic jam which volume is increasing slowly,
  ///  * - 3 `trafficJamIncreasing`         - in case the type of traffic condition is a traffic jam which volume is increasing,
  ///  * - 4 `trafficJamStronglyIncreasing` - in case the type of traffic condition is a traffic jam which volume is strongly increasing,
  ///  * - 5 `trafficJam`         `         - in case the type of traffic condition is a traffic jam and no further detailed information about its volume is available,
  ///  * - 6 `trafficJamSlightlyDecreasing` - in case the type of traffic condition is a traffic jam which volume is decreasing slowly,
  ///  * - 7 `trafficJamDecreasing`         - in case the type of traffic condition is a traffic jam which volume is decreasing,
  ///  * - 8 `trafficJamStronglyDecreasing` - in case the type of traffic condition is a traffic jam which volume is decreasing rapidly,
  ///  * - 9 `trafficJamStable`             - in case the traffic condition is a traffic jam with stable volume,
  ///  * - 10-255: reserved for future usage.
  ///  *
  ///  * @category: Traffic information
  ///  * @revision: V1.3.1, definition of value 0 and 1 changed in V2.2.1, name and definition of value 5 changed in V2.2.1, value 9 added in V2.2.1
  ///  */
  /// TrafficConditionSubCauseCode ::= INTEGER {
  ///     unavailable                  (0),
  ///     increasedVolumeOfTraffic     (1),
  ///     trafficJamSlowlyIncreasing   (2),
  ///     trafficJamIncreasing         (3),
  ///     trafficJamStronglyIncreasing (4),
  ///     trafficJam                   (5),
  ///     trafficJamSlightlyDecreasing (6),
  ///     trafficJamDecreasing         (7),
  ///     trafficJamStronglyDecreasing (8),
  ///     trafficJamStable             (9)
  /// } (0..255)
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__TrafficConditionSubCauseCode;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__TrafficConditionSubCauseCode.
typedef struct etsi_its_cam_ts_msgs__msg__TrafficConditionSubCauseCode__Sequence
{
  etsi_its_cam_ts_msgs__msg__TrafficConditionSubCauseCode * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__TrafficConditionSubCauseCode__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__TRAFFIC_CONDITION_SUB_CAUSE_CODE__STRUCT_H_
