// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/VehicleBreakdownSubCauseCode.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__VEHICLE_BREAKDOWN_SUB_CAUSE_CODE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__VEHICLE_BREAKDOWN_SUB_CAUSE_CODE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__VehicleBreakdownSubCauseCode__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__VehicleBreakdownSubCauseCode__MAX = 255
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__VehicleBreakdownSubCauseCode__UNAVAILABLE = 0
};

/// Constant 'LACK_OF_FUEL'.
enum
{
  etsi_its_cam_ts_msgs__msg__VehicleBreakdownSubCauseCode__LACK_OF_FUEL = 1
};

/// Constant 'LACK_OF_BATTERY_POWER'.
enum
{
  etsi_its_cam_ts_msgs__msg__VehicleBreakdownSubCauseCode__LACK_OF_BATTERY_POWER = 2
};

/// Constant 'ENGINE_PROBLEM'.
enum
{
  etsi_its_cam_ts_msgs__msg__VehicleBreakdownSubCauseCode__ENGINE_PROBLEM = 3
};

/// Constant 'TRANSMISSION_PROBLEM'.
enum
{
  etsi_its_cam_ts_msgs__msg__VehicleBreakdownSubCauseCode__TRANSMISSION_PROBLEM = 4
};

/// Constant 'ENGINE_COOLING_PROBLEM'.
enum
{
  etsi_its_cam_ts_msgs__msg__VehicleBreakdownSubCauseCode__ENGINE_COOLING_PROBLEM = 5
};

/// Constant 'BRAKING_SYSTEM_PROBLEM'.
enum
{
  etsi_its_cam_ts_msgs__msg__VehicleBreakdownSubCauseCode__BRAKING_SYSTEM_PROBLEM = 6
};

/// Constant 'STEERING_PROBLEM'.
enum
{
  etsi_its_cam_ts_msgs__msg__VehicleBreakdownSubCauseCode__STEERING_PROBLEM = 7
};

/// Constant 'TYRE_PUNCTURE'.
enum
{
  etsi_its_cam_ts_msgs__msg__VehicleBreakdownSubCauseCode__TYRE_PUNCTURE = 8
};

/// Constant 'TYRE_PRESSURE_PROBLEM'.
enum
{
  etsi_its_cam_ts_msgs__msg__VehicleBreakdownSubCauseCode__TYRE_PRESSURE_PROBLEM = 9
};

/// Constant 'VEHICLE_ON_FIRE'.
enum
{
  etsi_its_cam_ts_msgs__msg__VehicleBreakdownSubCauseCode__VEHICLE_ON_FIRE = 10
};

/// Struct defined in msg/VehicleBreakdownSubCauseCode in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__VehicleBreakdownSubCauseCode
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents the value of the sub cause codes of the @ref CauseCode `vehicleBreakdown`.
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 `unavailable`         - in case further detailed information on cause of vehicle break down is unavailable,
  ///  * - 1 `lackOfFuel`          - in case vehicle break down is due to lack of fuel,
  ///  * - 2 `lackOfBatteryPower`  - in case vehicle break down is caused by lack of battery power,
  ///  * - 3 `engineProblem`       - in case vehicle break down is caused by an engine problem,
  ///  * - 4 `transmissionProblem` - in case vehicle break down is caused by transmission problem,
  ///  * - 5 `engineCoolingProblem`- in case vehicle break down is caused by an engine cooling problem,
  ///  * - 6 `brakingSystemProblem`- in case vehicle break down is caused by a braking system problem,
  ///  * - 7 `steeringProblem`     - in case vehicle break down is caused by a steering problem,
  ///  * - 8 `tyrePuncture`        - in case vehicle break down is caused by tyre puncture,
  ///  * - 9 `tyrePressureProblem` - in case low tyre pressure in detected,
  ///  * - 10 `vehicleOnFire`      - in case the vehicle is on fire.
  ///  * - 11-255                  - are reserved for future usage.
  ///  *
  ///  * @category: Traffic information
  ///
  ///  */
  /// VehicleBreakdownSubCauseCode ::= INTEGER {
  ///     unavailable          (0),
  ///     lackOfFuel           (1),
  ///     lackOfBatteryPower   (2),
  ///     engineProblem        (3),
  ///     transmissionProblem  (4),
  ///     engineCoolingProblem (5),
  ///     brakingSystemProblem (6),
  ///     steeringProblem      (7),
  ///     tyrePuncture         (8),
  ///     tyrePressureProblem  (9),
  ///     vehicleOnFire        (10)
  /// } (0..255)
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__VehicleBreakdownSubCauseCode;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__VehicleBreakdownSubCauseCode.
typedef struct etsi_its_cam_ts_msgs__msg__VehicleBreakdownSubCauseCode__Sequence
{
  etsi_its_cam_ts_msgs__msg__VehicleBreakdownSubCauseCode * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__VehicleBreakdownSubCauseCode__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__VEHICLE_BREAKDOWN_SUB_CAUSE_CODE__STRUCT_H_
