// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/YawRate.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__YAW_RATE__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__YAW_RATE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'yaw_rate_value'
#include "etsi_its_cam_ts_msgs/msg/detail/yaw_rate_value__struct.hpp"
// Member 'yaw_rate_confidence'
#include "etsi_its_cam_ts_msgs/msg/detail/yaw_rate_confidence__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__YawRate __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__YawRate __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct YawRate_
{
  using Type = YawRate_<ContainerAllocator>;

  explicit YawRate_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : yaw_rate_value(_init),
    yaw_rate_confidence(_init)
  {
    (void)_init;
  }

  explicit YawRate_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : yaw_rate_value(_alloc, _init),
    yaw_rate_confidence(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _yaw_rate_value_type =
    etsi_its_cam_ts_msgs::msg::YawRateValue_<ContainerAllocator>;
  _yaw_rate_value_type yaw_rate_value;
  using _yaw_rate_confidence_type =
    etsi_its_cam_ts_msgs::msg::YawRateConfidence_<ContainerAllocator>;
  _yaw_rate_confidence_type yaw_rate_confidence;

  // setters for named parameter idiom
  Type & set__yaw_rate_value(
    const etsi_its_cam_ts_msgs::msg::YawRateValue_<ContainerAllocator> & _arg)
  {
    this->yaw_rate_value = _arg;
    return *this;
  }
  Type & set__yaw_rate_confidence(
    const etsi_its_cam_ts_msgs::msg::YawRateConfidence_<ContainerAllocator> & _arg)
  {
    this->yaw_rate_confidence = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::YawRate_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::YawRate_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::YawRate_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::YawRate_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::YawRate_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::YawRate_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::YawRate_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::YawRate_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::YawRate_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::YawRate_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__YawRate
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::YawRate_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__YawRate
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::YawRate_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const YawRate_ & other) const
  {
    if (this->yaw_rate_value != other.yaw_rate_value) {
      return false;
    }
    if (this->yaw_rate_confidence != other.yaw_rate_confidence) {
      return false;
    }
    return true;
  }
  bool operator!=(const YawRate_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct YawRate_

// alias to use template instance with default allocator
using YawRate =
  etsi_its_cam_ts_msgs::msg::YawRate_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__YAW_RATE__STRUCT_HPP_
