// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/AccidentSubCauseCode.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ACCIDENT_SUB_CAUSE_CODE__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ACCIDENT_SUB_CAUSE_CODE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__AccidentSubCauseCode __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__AccidentSubCauseCode __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct AccidentSubCauseCode_
{
  using Type = AccidentSubCauseCode_<ContainerAllocator>;

  explicit AccidentSubCauseCode_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  explicit AccidentSubCauseCode_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  // field types and members
  using _value_type =
    uint8_t;
  _value_type value;

  // setters for named parameter idiom
  Type & set__value(
    const uint8_t & _arg)
  {
    this->value = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t MIN =
    0u;
  static constexpr uint8_t MAX =
    255u;
  static constexpr uint8_t UNAVAILABLE =
    0u;
  static constexpr uint8_t MULTI_VEHICLE_ACCIDENT =
    1u;
  static constexpr uint8_t HEAVY_ACCIDENT =
    2u;
  static constexpr uint8_t ACCIDENT_INVOLVING_LORRY =
    3u;
  static constexpr uint8_t ACCIDENT_INVOLVING_BUS =
    4u;
  static constexpr uint8_t ACCIDENT_INVOLVING_HAZARDOUS_MATERIALS =
    5u;
  static constexpr uint8_t ACCIDENT_ON_OPPOSITE_LANE =
    6u;
  static constexpr uint8_t UNSECURED_ACCIDENT =
    7u;
  static constexpr uint8_t ASSISTANCE_REQUESTED =
    8u;

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::AccidentSubCauseCode_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::AccidentSubCauseCode_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::AccidentSubCauseCode_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::AccidentSubCauseCode_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::AccidentSubCauseCode_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::AccidentSubCauseCode_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::AccidentSubCauseCode_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::AccidentSubCauseCode_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::AccidentSubCauseCode_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::AccidentSubCauseCode_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__AccidentSubCauseCode
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::AccidentSubCauseCode_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__AccidentSubCauseCode
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::AccidentSubCauseCode_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AccidentSubCauseCode_ & other) const
  {
    if (this->value != other.value) {
      return false;
    }
    return true;
  }
  bool operator!=(const AccidentSubCauseCode_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AccidentSubCauseCode_

// alias to use template instance with default allocator
using AccidentSubCauseCode =
  etsi_its_cam_ts_msgs::msg::AccidentSubCauseCode_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AccidentSubCauseCode_<ContainerAllocator>::MIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AccidentSubCauseCode_<ContainerAllocator>::MAX;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AccidentSubCauseCode_<ContainerAllocator>::UNAVAILABLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AccidentSubCauseCode_<ContainerAllocator>::MULTI_VEHICLE_ACCIDENT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AccidentSubCauseCode_<ContainerAllocator>::HEAVY_ACCIDENT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AccidentSubCauseCode_<ContainerAllocator>::ACCIDENT_INVOLVING_LORRY;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AccidentSubCauseCode_<ContainerAllocator>::ACCIDENT_INVOLVING_BUS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AccidentSubCauseCode_<ContainerAllocator>::ACCIDENT_INVOLVING_HAZARDOUS_MATERIALS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AccidentSubCauseCode_<ContainerAllocator>::ACCIDENT_ON_OPPOSITE_LANE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AccidentSubCauseCode_<ContainerAllocator>::UNSECURED_ACCIDENT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AccidentSubCauseCode_<ContainerAllocator>::ASSISTANCE_REQUESTED;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ACCIDENT_SUB_CAUSE_CODE__STRUCT_HPP_
