// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/BasicContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__BASIC_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__BASIC_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'station_type'
#include "etsi_its_cam_ts_msgs/msg/detail/traffic_participant_type__struct.hpp"
// Member 'reference_position'
#include "etsi_its_cam_ts_msgs/msg/detail/reference_position_with_confidence__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__BasicContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__BasicContainer __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct BasicContainer_
{
  using Type = BasicContainer_<ContainerAllocator>;

  explicit BasicContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : station_type(_init),
    reference_position(_init)
  {
    (void)_init;
  }

  explicit BasicContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : station_type(_alloc, _init),
    reference_position(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _station_type_type =
    etsi_its_cam_ts_msgs::msg::TrafficParticipantType_<ContainerAllocator>;
  _station_type_type station_type;
  using _reference_position_type =
    etsi_its_cam_ts_msgs::msg::ReferencePositionWithConfidence_<ContainerAllocator>;
  _reference_position_type reference_position;

  // setters for named parameter idiom
  Type & set__station_type(
    const etsi_its_cam_ts_msgs::msg::TrafficParticipantType_<ContainerAllocator> & _arg)
  {
    this->station_type = _arg;
    return *this;
  }
  Type & set__reference_position(
    const etsi_its_cam_ts_msgs::msg::ReferencePositionWithConfidence_<ContainerAllocator> & _arg)
  {
    this->reference_position = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::BasicContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::BasicContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::BasicContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::BasicContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::BasicContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::BasicContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::BasicContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::BasicContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::BasicContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::BasicContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__BasicContainer
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::BasicContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__BasicContainer
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::BasicContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const BasicContainer_ & other) const
  {
    if (this->station_type != other.station_type) {
      return false;
    }
    if (this->reference_position != other.reference_position) {
      return false;
    }
    return true;
  }
  bool operator!=(const BasicContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct BasicContainer_

// alias to use template instance with default allocator
using BasicContainer =
  etsi_its_cam_ts_msgs::msg::BasicContainer_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__BASIC_CONTAINER__STRUCT_HPP_
