// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/BasicContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__BASIC_CONTAINER__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__BASIC_CONTAINER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/basic_container__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'station_type'
#include "etsi_its_cam_ts_msgs/msg/detail/traffic_participant_type__traits.hpp"
// Member 'reference_position'
#include "etsi_its_cam_ts_msgs/msg/detail/reference_position_with_confidence__traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const BasicContainer & msg,
  std::ostream & out)
{
  out << "{";
  // member: station_type
  {
    out << "station_type: ";
    to_flow_style_yaml(msg.station_type, out);
    out << ", ";
  }

  // member: reference_position
  {
    out << "reference_position: ";
    to_flow_style_yaml(msg.reference_position, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const BasicContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: station_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "station_type:\n";
    to_block_style_yaml(msg.station_type, out, indentation + 2);
  }

  // member: reference_position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "reference_position:\n";
    to_block_style_yaml(msg.reference_position, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const BasicContainer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::BasicContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::BasicContainer & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::BasicContainer>()
{
  return "etsi_its_cam_ts_msgs::msg::BasicContainer";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::BasicContainer>()
{
  return "etsi_its_cam_ts_msgs/msg/BasicContainer";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::BasicContainer>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_ts_msgs::msg::ReferencePositionWithConfidence>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::TrafficParticipantType>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::BasicContainer>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_ts_msgs::msg::ReferencePositionWithConfidence>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::TrafficParticipantType>::value> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::BasicContainer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__BASIC_CONTAINER__TRAITS_HPP_
