// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/BasicVehicleContainerHighFrequency.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__BASIC_VEHICLE_CONTAINER_HIGH_FREQUENCY__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__BASIC_VEHICLE_CONTAINER_HIGH_FREQUENCY__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/basic_vehicle_container_high_frequency__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'heading'
#include "etsi_its_cam_ts_msgs/msg/detail/heading__traits.hpp"
// Member 'speed'
#include "etsi_its_cam_ts_msgs/msg/detail/speed__traits.hpp"
// Member 'drive_direction'
#include "etsi_its_cam_ts_msgs/msg/detail/drive_direction__traits.hpp"
// Member 'vehicle_length'
#include "etsi_its_cam_ts_msgs/msg/detail/vehicle_length__traits.hpp"
// Member 'vehicle_width'
#include "etsi_its_cam_ts_msgs/msg/detail/vehicle_width__traits.hpp"
// Member 'longitudinal_acceleration'
// Member 'lateral_acceleration'
// Member 'vertical_acceleration'
#include "etsi_its_cam_ts_msgs/msg/detail/acceleration_component__traits.hpp"
// Member 'curvature'
#include "etsi_its_cam_ts_msgs/msg/detail/curvature__traits.hpp"
// Member 'curvature_calculation_mode'
#include "etsi_its_cam_ts_msgs/msg/detail/curvature_calculation_mode__traits.hpp"
// Member 'yaw_rate'
#include "etsi_its_cam_ts_msgs/msg/detail/yaw_rate__traits.hpp"
// Member 'acceleration_control'
#include "etsi_its_cam_ts_msgs/msg/detail/acceleration_control__traits.hpp"
// Member 'lane_position'
#include "etsi_its_cam_ts_msgs/msg/detail/lane_position__traits.hpp"
// Member 'steering_wheel_angle'
#include "etsi_its_cam_ts_msgs/msg/detail/steering_wheel_angle__traits.hpp"
// Member 'performance_class'
#include "etsi_its_cam_ts_msgs/msg/detail/performance_class__traits.hpp"
// Member 'cen_dsrc_tolling_zone'
#include "etsi_its_cam_ts_msgs/msg/detail/cen_dsrc_tolling_zone__traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const BasicVehicleContainerHighFrequency & msg,
  std::ostream & out)
{
  out << "{";
  // member: heading
  {
    out << "heading: ";
    to_flow_style_yaml(msg.heading, out);
    out << ", ";
  }

  // member: speed
  {
    out << "speed: ";
    to_flow_style_yaml(msg.speed, out);
    out << ", ";
  }

  // member: drive_direction
  {
    out << "drive_direction: ";
    to_flow_style_yaml(msg.drive_direction, out);
    out << ", ";
  }

  // member: vehicle_length
  {
    out << "vehicle_length: ";
    to_flow_style_yaml(msg.vehicle_length, out);
    out << ", ";
  }

  // member: vehicle_width
  {
    out << "vehicle_width: ";
    to_flow_style_yaml(msg.vehicle_width, out);
    out << ", ";
  }

  // member: longitudinal_acceleration
  {
    out << "longitudinal_acceleration: ";
    to_flow_style_yaml(msg.longitudinal_acceleration, out);
    out << ", ";
  }

  // member: curvature
  {
    out << "curvature: ";
    to_flow_style_yaml(msg.curvature, out);
    out << ", ";
  }

  // member: curvature_calculation_mode
  {
    out << "curvature_calculation_mode: ";
    to_flow_style_yaml(msg.curvature_calculation_mode, out);
    out << ", ";
  }

  // member: yaw_rate
  {
    out << "yaw_rate: ";
    to_flow_style_yaml(msg.yaw_rate, out);
    out << ", ";
  }

  // member: acceleration_control
  {
    out << "acceleration_control: ";
    to_flow_style_yaml(msg.acceleration_control, out);
    out << ", ";
  }

  // member: acceleration_control_is_present
  {
    out << "acceleration_control_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.acceleration_control_is_present, out);
    out << ", ";
  }

  // member: lane_position
  {
    out << "lane_position: ";
    to_flow_style_yaml(msg.lane_position, out);
    out << ", ";
  }

  // member: lane_position_is_present
  {
    out << "lane_position_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.lane_position_is_present, out);
    out << ", ";
  }

  // member: steering_wheel_angle
  {
    out << "steering_wheel_angle: ";
    to_flow_style_yaml(msg.steering_wheel_angle, out);
    out << ", ";
  }

  // member: steering_wheel_angle_is_present
  {
    out << "steering_wheel_angle_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.steering_wheel_angle_is_present, out);
    out << ", ";
  }

  // member: lateral_acceleration
  {
    out << "lateral_acceleration: ";
    to_flow_style_yaml(msg.lateral_acceleration, out);
    out << ", ";
  }

  // member: lateral_acceleration_is_present
  {
    out << "lateral_acceleration_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.lateral_acceleration_is_present, out);
    out << ", ";
  }

  // member: vertical_acceleration
  {
    out << "vertical_acceleration: ";
    to_flow_style_yaml(msg.vertical_acceleration, out);
    out << ", ";
  }

  // member: vertical_acceleration_is_present
  {
    out << "vertical_acceleration_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.vertical_acceleration_is_present, out);
    out << ", ";
  }

  // member: performance_class
  {
    out << "performance_class: ";
    to_flow_style_yaml(msg.performance_class, out);
    out << ", ";
  }

  // member: performance_class_is_present
  {
    out << "performance_class_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.performance_class_is_present, out);
    out << ", ";
  }

  // member: cen_dsrc_tolling_zone
  {
    out << "cen_dsrc_tolling_zone: ";
    to_flow_style_yaml(msg.cen_dsrc_tolling_zone, out);
    out << ", ";
  }

  // member: cen_dsrc_tolling_zone_is_present
  {
    out << "cen_dsrc_tolling_zone_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.cen_dsrc_tolling_zone_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const BasicVehicleContainerHighFrequency & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: heading
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "heading:\n";
    to_block_style_yaml(msg.heading, out, indentation + 2);
  }

  // member: speed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speed:\n";
    to_block_style_yaml(msg.speed, out, indentation + 2);
  }

  // member: drive_direction
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "drive_direction:\n";
    to_block_style_yaml(msg.drive_direction, out, indentation + 2);
  }

  // member: vehicle_length
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vehicle_length:\n";
    to_block_style_yaml(msg.vehicle_length, out, indentation + 2);
  }

  // member: vehicle_width
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vehicle_width:\n";
    to_block_style_yaml(msg.vehicle_width, out, indentation + 2);
  }

  // member: longitudinal_acceleration
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "longitudinal_acceleration:\n";
    to_block_style_yaml(msg.longitudinal_acceleration, out, indentation + 2);
  }

  // member: curvature
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "curvature:\n";
    to_block_style_yaml(msg.curvature, out, indentation + 2);
  }

  // member: curvature_calculation_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "curvature_calculation_mode:\n";
    to_block_style_yaml(msg.curvature_calculation_mode, out, indentation + 2);
  }

  // member: yaw_rate
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "yaw_rate:\n";
    to_block_style_yaml(msg.yaw_rate, out, indentation + 2);
  }

  // member: acceleration_control
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "acceleration_control:\n";
    to_block_style_yaml(msg.acceleration_control, out, indentation + 2);
  }

  // member: acceleration_control_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "acceleration_control_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.acceleration_control_is_present, out);
    out << "\n";
  }

  // member: lane_position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lane_position:\n";
    to_block_style_yaml(msg.lane_position, out, indentation + 2);
  }

  // member: lane_position_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lane_position_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.lane_position_is_present, out);
    out << "\n";
  }

  // member: steering_wheel_angle
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "steering_wheel_angle:\n";
    to_block_style_yaml(msg.steering_wheel_angle, out, indentation + 2);
  }

  // member: steering_wheel_angle_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "steering_wheel_angle_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.steering_wheel_angle_is_present, out);
    out << "\n";
  }

  // member: lateral_acceleration
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lateral_acceleration:\n";
    to_block_style_yaml(msg.lateral_acceleration, out, indentation + 2);
  }

  // member: lateral_acceleration_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lateral_acceleration_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.lateral_acceleration_is_present, out);
    out << "\n";
  }

  // member: vertical_acceleration
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vertical_acceleration:\n";
    to_block_style_yaml(msg.vertical_acceleration, out, indentation + 2);
  }

  // member: vertical_acceleration_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vertical_acceleration_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.vertical_acceleration_is_present, out);
    out << "\n";
  }

  // member: performance_class
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "performance_class:\n";
    to_block_style_yaml(msg.performance_class, out, indentation + 2);
  }

  // member: performance_class_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "performance_class_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.performance_class_is_present, out);
    out << "\n";
  }

  // member: cen_dsrc_tolling_zone
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cen_dsrc_tolling_zone:\n";
    to_block_style_yaml(msg.cen_dsrc_tolling_zone, out, indentation + 2);
  }

  // member: cen_dsrc_tolling_zone_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cen_dsrc_tolling_zone_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.cen_dsrc_tolling_zone_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const BasicVehicleContainerHighFrequency & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::BasicVehicleContainerHighFrequency & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::BasicVehicleContainerHighFrequency & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::BasicVehicleContainerHighFrequency>()
{
  return "etsi_its_cam_ts_msgs::msg::BasicVehicleContainerHighFrequency";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::BasicVehicleContainerHighFrequency>()
{
  return "etsi_its_cam_ts_msgs/msg/BasicVehicleContainerHighFrequency";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::BasicVehicleContainerHighFrequency>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_ts_msgs::msg::AccelerationComponent>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::AccelerationControl>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::CenDsrcTollingZone>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::Curvature>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::CurvatureCalculationMode>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::DriveDirection>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::Heading>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::LanePosition>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::PerformanceClass>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::Speed>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::SteeringWheelAngle>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::VehicleLength>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::VehicleWidth>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::YawRate>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::BasicVehicleContainerHighFrequency>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_ts_msgs::msg::AccelerationComponent>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::AccelerationControl>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::CenDsrcTollingZone>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::Curvature>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::CurvatureCalculationMode>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::DriveDirection>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::Heading>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::LanePosition>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::PerformanceClass>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::Speed>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::SteeringWheelAngle>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::VehicleLength>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::VehicleWidth>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::YawRate>::value> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::BasicVehicleContainerHighFrequency>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__BASIC_VEHICLE_CONTAINER_HIGH_FREQUENCY__TRAITS_HPP_
