// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/CAM.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CAM__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CAM__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/cam__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "etsi_its_cam_ts_msgs/msg/detail/its_pdu_header__traits.hpp"
// Member 'cam'
#include "etsi_its_cam_ts_msgs/msg/detail/cam_payload__traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const CAM & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: cam
  {
    out << "cam: ";
    to_flow_style_yaml(msg.cam, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CAM & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: cam
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cam:\n";
    to_block_style_yaml(msg.cam, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CAM & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::CAM & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::CAM & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::CAM>()
{
  return "etsi_its_cam_ts_msgs::msg::CAM";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::CAM>()
{
  return "etsi_its_cam_ts_msgs/msg/CAM";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::CAM>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_ts_msgs::msg::CamPayload>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::ItsPduHeader>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::CAM>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_ts_msgs::msg::CamPayload>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::ItsPduHeader>::value> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::CAM>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CAM__TRAITS_HPP_
