// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/CamParameters.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CAM_PARAMETERS__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CAM_PARAMETERS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'basic_container'
#include "etsi_its_cam_ts_msgs/msg/detail/basic_container__struct.hpp"
// Member 'high_frequency_container'
#include "etsi_its_cam_ts_msgs/msg/detail/high_frequency_container__struct.hpp"
// Member 'low_frequency_container'
#include "etsi_its_cam_ts_msgs/msg/detail/low_frequency_container__struct.hpp"
// Member 'special_vehicle_container'
#include "etsi_its_cam_ts_msgs/msg/detail/special_vehicle_container__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__CamParameters __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__CamParameters __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct CamParameters_
{
  using Type = CamParameters_<ContainerAllocator>;

  explicit CamParameters_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : basic_container(_init),
    high_frequency_container(_init),
    low_frequency_container(_init),
    special_vehicle_container(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->low_frequency_container_is_present = false;
      this->special_vehicle_container_is_present = false;
    }
  }

  explicit CamParameters_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : basic_container(_alloc, _init),
    high_frequency_container(_alloc, _init),
    low_frequency_container(_alloc, _init),
    special_vehicle_container(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->low_frequency_container_is_present = false;
      this->special_vehicle_container_is_present = false;
    }
  }

  // field types and members
  using _basic_container_type =
    etsi_its_cam_ts_msgs::msg::BasicContainer_<ContainerAllocator>;
  _basic_container_type basic_container;
  using _high_frequency_container_type =
    etsi_its_cam_ts_msgs::msg::HighFrequencyContainer_<ContainerAllocator>;
  _high_frequency_container_type high_frequency_container;
  using _low_frequency_container_type =
    etsi_its_cam_ts_msgs::msg::LowFrequencyContainer_<ContainerAllocator>;
  _low_frequency_container_type low_frequency_container;
  using _low_frequency_container_is_present_type =
    bool;
  _low_frequency_container_is_present_type low_frequency_container_is_present;
  using _special_vehicle_container_type =
    etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer_<ContainerAllocator>;
  _special_vehicle_container_type special_vehicle_container;
  using _special_vehicle_container_is_present_type =
    bool;
  _special_vehicle_container_is_present_type special_vehicle_container_is_present;

  // setters for named parameter idiom
  Type & set__basic_container(
    const etsi_its_cam_ts_msgs::msg::BasicContainer_<ContainerAllocator> & _arg)
  {
    this->basic_container = _arg;
    return *this;
  }
  Type & set__high_frequency_container(
    const etsi_its_cam_ts_msgs::msg::HighFrequencyContainer_<ContainerAllocator> & _arg)
  {
    this->high_frequency_container = _arg;
    return *this;
  }
  Type & set__low_frequency_container(
    const etsi_its_cam_ts_msgs::msg::LowFrequencyContainer_<ContainerAllocator> & _arg)
  {
    this->low_frequency_container = _arg;
    return *this;
  }
  Type & set__low_frequency_container_is_present(
    const bool & _arg)
  {
    this->low_frequency_container_is_present = _arg;
    return *this;
  }
  Type & set__special_vehicle_container(
    const etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer_<ContainerAllocator> & _arg)
  {
    this->special_vehicle_container = _arg;
    return *this;
  }
  Type & set__special_vehicle_container_is_present(
    const bool & _arg)
  {
    this->special_vehicle_container_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::CamParameters_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::CamParameters_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::CamParameters_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::CamParameters_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::CamParameters_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::CamParameters_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::CamParameters_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::CamParameters_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::CamParameters_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::CamParameters_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__CamParameters
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::CamParameters_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__CamParameters
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::CamParameters_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CamParameters_ & other) const
  {
    if (this->basic_container != other.basic_container) {
      return false;
    }
    if (this->high_frequency_container != other.high_frequency_container) {
      return false;
    }
    if (this->low_frequency_container != other.low_frequency_container) {
      return false;
    }
    if (this->low_frequency_container_is_present != other.low_frequency_container_is_present) {
      return false;
    }
    if (this->special_vehicle_container != other.special_vehicle_container) {
      return false;
    }
    if (this->special_vehicle_container_is_present != other.special_vehicle_container_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const CamParameters_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CamParameters_

// alias to use template instance with default allocator
using CamParameters =
  etsi_its_cam_ts_msgs::msg::CamParameters_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CAM_PARAMETERS__STRUCT_HPP_
