// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/CamParameters.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CAM_PARAMETERS__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CAM_PARAMETERS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/cam_parameters__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'basic_container'
#include "etsi_its_cam_ts_msgs/msg/detail/basic_container__traits.hpp"
// Member 'high_frequency_container'
#include "etsi_its_cam_ts_msgs/msg/detail/high_frequency_container__traits.hpp"
// Member 'low_frequency_container'
#include "etsi_its_cam_ts_msgs/msg/detail/low_frequency_container__traits.hpp"
// Member 'special_vehicle_container'
#include "etsi_its_cam_ts_msgs/msg/detail/special_vehicle_container__traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const CamParameters & msg,
  std::ostream & out)
{
  out << "{";
  // member: basic_container
  {
    out << "basic_container: ";
    to_flow_style_yaml(msg.basic_container, out);
    out << ", ";
  }

  // member: high_frequency_container
  {
    out << "high_frequency_container: ";
    to_flow_style_yaml(msg.high_frequency_container, out);
    out << ", ";
  }

  // member: low_frequency_container
  {
    out << "low_frequency_container: ";
    to_flow_style_yaml(msg.low_frequency_container, out);
    out << ", ";
  }

  // member: low_frequency_container_is_present
  {
    out << "low_frequency_container_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.low_frequency_container_is_present, out);
    out << ", ";
  }

  // member: special_vehicle_container
  {
    out << "special_vehicle_container: ";
    to_flow_style_yaml(msg.special_vehicle_container, out);
    out << ", ";
  }

  // member: special_vehicle_container_is_present
  {
    out << "special_vehicle_container_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.special_vehicle_container_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CamParameters & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: basic_container
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "basic_container:\n";
    to_block_style_yaml(msg.basic_container, out, indentation + 2);
  }

  // member: high_frequency_container
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "high_frequency_container:\n";
    to_block_style_yaml(msg.high_frequency_container, out, indentation + 2);
  }

  // member: low_frequency_container
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "low_frequency_container:\n";
    to_block_style_yaml(msg.low_frequency_container, out, indentation + 2);
  }

  // member: low_frequency_container_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "low_frequency_container_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.low_frequency_container_is_present, out);
    out << "\n";
  }

  // member: special_vehicle_container
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "special_vehicle_container:\n";
    to_block_style_yaml(msg.special_vehicle_container, out, indentation + 2);
  }

  // member: special_vehicle_container_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "special_vehicle_container_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.special_vehicle_container_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CamParameters & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::CamParameters & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::CamParameters & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::CamParameters>()
{
  return "etsi_its_cam_ts_msgs::msg::CamParameters";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::CamParameters>()
{
  return "etsi_its_cam_ts_msgs/msg/CamParameters";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::CamParameters>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_ts_msgs::msg::BasicContainer>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::HighFrequencyContainer>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::LowFrequencyContainer>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::CamParameters>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_ts_msgs::msg::BasicContainer>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::HighFrequencyContainer>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::LowFrequencyContainer>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer>::value> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::CamParameters>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CAM_PARAMETERS__TRAITS_HPP_
