// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/ClosedLanes.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CLOSED_LANES__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CLOSED_LANES__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'innerhard_shoulder_status'
// Member 'outerhard_shoulder_status'
#include "etsi_its_cam_ts_msgs/msg/detail/hard_shoulder_status__struct.hpp"
// Member 'driving_lane_status'
#include "etsi_its_cam_ts_msgs/msg/detail/driving_lane_status__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__ClosedLanes __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__ClosedLanes __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ClosedLanes_
{
  using Type = ClosedLanes_<ContainerAllocator>;

  explicit ClosedLanes_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : innerhard_shoulder_status(_init),
    outerhard_shoulder_status(_init),
    driving_lane_status(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->innerhard_shoulder_status_is_present = false;
      this->outerhard_shoulder_status_is_present = false;
      this->driving_lane_status_is_present = false;
    }
  }

  explicit ClosedLanes_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : innerhard_shoulder_status(_alloc, _init),
    outerhard_shoulder_status(_alloc, _init),
    driving_lane_status(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->innerhard_shoulder_status_is_present = false;
      this->outerhard_shoulder_status_is_present = false;
      this->driving_lane_status_is_present = false;
    }
  }

  // field types and members
  using _innerhard_shoulder_status_type =
    etsi_its_cam_ts_msgs::msg::HardShoulderStatus_<ContainerAllocator>;
  _innerhard_shoulder_status_type innerhard_shoulder_status;
  using _innerhard_shoulder_status_is_present_type =
    bool;
  _innerhard_shoulder_status_is_present_type innerhard_shoulder_status_is_present;
  using _outerhard_shoulder_status_type =
    etsi_its_cam_ts_msgs::msg::HardShoulderStatus_<ContainerAllocator>;
  _outerhard_shoulder_status_type outerhard_shoulder_status;
  using _outerhard_shoulder_status_is_present_type =
    bool;
  _outerhard_shoulder_status_is_present_type outerhard_shoulder_status_is_present;
  using _driving_lane_status_type =
    etsi_its_cam_ts_msgs::msg::DrivingLaneStatus_<ContainerAllocator>;
  _driving_lane_status_type driving_lane_status;
  using _driving_lane_status_is_present_type =
    bool;
  _driving_lane_status_is_present_type driving_lane_status_is_present;

  // setters for named parameter idiom
  Type & set__innerhard_shoulder_status(
    const etsi_its_cam_ts_msgs::msg::HardShoulderStatus_<ContainerAllocator> & _arg)
  {
    this->innerhard_shoulder_status = _arg;
    return *this;
  }
  Type & set__innerhard_shoulder_status_is_present(
    const bool & _arg)
  {
    this->innerhard_shoulder_status_is_present = _arg;
    return *this;
  }
  Type & set__outerhard_shoulder_status(
    const etsi_its_cam_ts_msgs::msg::HardShoulderStatus_<ContainerAllocator> & _arg)
  {
    this->outerhard_shoulder_status = _arg;
    return *this;
  }
  Type & set__outerhard_shoulder_status_is_present(
    const bool & _arg)
  {
    this->outerhard_shoulder_status_is_present = _arg;
    return *this;
  }
  Type & set__driving_lane_status(
    const etsi_its_cam_ts_msgs::msg::DrivingLaneStatus_<ContainerAllocator> & _arg)
  {
    this->driving_lane_status = _arg;
    return *this;
  }
  Type & set__driving_lane_status_is_present(
    const bool & _arg)
  {
    this->driving_lane_status_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::ClosedLanes_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::ClosedLanes_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::ClosedLanes_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::ClosedLanes_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::ClosedLanes_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::ClosedLanes_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::ClosedLanes_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::ClosedLanes_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::ClosedLanes_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::ClosedLanes_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__ClosedLanes
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::ClosedLanes_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__ClosedLanes
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::ClosedLanes_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ClosedLanes_ & other) const
  {
    if (this->innerhard_shoulder_status != other.innerhard_shoulder_status) {
      return false;
    }
    if (this->innerhard_shoulder_status_is_present != other.innerhard_shoulder_status_is_present) {
      return false;
    }
    if (this->outerhard_shoulder_status != other.outerhard_shoulder_status) {
      return false;
    }
    if (this->outerhard_shoulder_status_is_present != other.outerhard_shoulder_status_is_present) {
      return false;
    }
    if (this->driving_lane_status != other.driving_lane_status) {
      return false;
    }
    if (this->driving_lane_status_is_present != other.driving_lane_status_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const ClosedLanes_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ClosedLanes_

// alias to use template instance with default allocator
using ClosedLanes =
  etsi_its_cam_ts_msgs::msg::ClosedLanes_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CLOSED_LANES__STRUCT_HPP_
