// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/ClosedLanes.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CLOSED_LANES__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CLOSED_LANES__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/closed_lanes__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'innerhard_shoulder_status'
// Member 'outerhard_shoulder_status'
#include "etsi_its_cam_ts_msgs/msg/detail/hard_shoulder_status__traits.hpp"
// Member 'driving_lane_status'
#include "etsi_its_cam_ts_msgs/msg/detail/driving_lane_status__traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ClosedLanes & msg,
  std::ostream & out)
{
  out << "{";
  // member: innerhard_shoulder_status
  {
    out << "innerhard_shoulder_status: ";
    to_flow_style_yaml(msg.innerhard_shoulder_status, out);
    out << ", ";
  }

  // member: innerhard_shoulder_status_is_present
  {
    out << "innerhard_shoulder_status_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.innerhard_shoulder_status_is_present, out);
    out << ", ";
  }

  // member: outerhard_shoulder_status
  {
    out << "outerhard_shoulder_status: ";
    to_flow_style_yaml(msg.outerhard_shoulder_status, out);
    out << ", ";
  }

  // member: outerhard_shoulder_status_is_present
  {
    out << "outerhard_shoulder_status_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.outerhard_shoulder_status_is_present, out);
    out << ", ";
  }

  // member: driving_lane_status
  {
    out << "driving_lane_status: ";
    to_flow_style_yaml(msg.driving_lane_status, out);
    out << ", ";
  }

  // member: driving_lane_status_is_present
  {
    out << "driving_lane_status_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.driving_lane_status_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ClosedLanes & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: innerhard_shoulder_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "innerhard_shoulder_status:\n";
    to_block_style_yaml(msg.innerhard_shoulder_status, out, indentation + 2);
  }

  // member: innerhard_shoulder_status_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "innerhard_shoulder_status_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.innerhard_shoulder_status_is_present, out);
    out << "\n";
  }

  // member: outerhard_shoulder_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "outerhard_shoulder_status:\n";
    to_block_style_yaml(msg.outerhard_shoulder_status, out, indentation + 2);
  }

  // member: outerhard_shoulder_status_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "outerhard_shoulder_status_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.outerhard_shoulder_status_is_present, out);
    out << "\n";
  }

  // member: driving_lane_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "driving_lane_status:\n";
    to_block_style_yaml(msg.driving_lane_status, out, indentation + 2);
  }

  // member: driving_lane_status_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "driving_lane_status_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.driving_lane_status_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ClosedLanes & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::ClosedLanes & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::ClosedLanes & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::ClosedLanes>()
{
  return "etsi_its_cam_ts_msgs::msg::ClosedLanes";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::ClosedLanes>()
{
  return "etsi_its_cam_ts_msgs/msg/ClosedLanes";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::ClosedLanes>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_ts_msgs::msg::DrivingLaneStatus>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::HardShoulderStatus>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::ClosedLanes>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_ts_msgs::msg::DrivingLaneStatus>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::HardShoulderStatus>::value> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::ClosedLanes>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CLOSED_LANES__TRAITS_HPP_
