// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/EmergencyPriority.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__EMERGENCY_PRIORITY__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__EMERGENCY_PRIORITY__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'SIZE_BITS'.
enum
{
  etsi_its_cam_ts_msgs__msg__EmergencyPriority__SIZE_BITS = 2
};

/// Constant 'BIT_INDEX_REQUEST_FOR_RIGHT_OF_WAY'.
enum
{
  etsi_its_cam_ts_msgs__msg__EmergencyPriority__BIT_INDEX_REQUEST_FOR_RIGHT_OF_WAY = 0
};

/// Constant 'BIT_INDEX_REQUEST_FOR_FREE_CROSSING_AT_A_TRAFFIC_LIGHT'.
enum
{
  etsi_its_cam_ts_msgs__msg__EmergencyPriority__BIT_INDEX_REQUEST_FOR_FREE_CROSSING_AT_A_TRAFFIC_LIGHT = 1
};

// Include directives for member types
// Member 'value'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/EmergencyPriority in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__EmergencyPriority
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates the right of priority requested or assumed by an operating emergency vehicle.
  ///  * The right-of-priority bit shall be set to `1` if the corresponding right is requested.
  ///  *
  ///  * The corresponding bit shall be set to 1 under the following conditions:
  ///  * - 0 - `requestForRightOfWay`                  - when the vehicle is requesting/assuming the right of way,
  ///  * - 1 - `requestForFreeCrossingAtATrafficLight` - when the vehicle is requesting/assuming the right to pass at a (red) traffic light.
  ///  *
  ///  * @category: Traffic information
  ///  * @revision: description revised in V2.1.1
  ///  */
  /// EmergencyPriority ::= BIT STRING {
  ///     requestForRightOfWay                  (0),
  ///     requestForFreeCrossingAtATrafficLight (1)
  /// } (SIZE(2))
  /// ------------------------------------------------------------------------------
  rosidl_runtime_c__uint8__Sequence value;
  uint8_t bits_unused;
} etsi_its_cam_ts_msgs__msg__EmergencyPriority;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__EmergencyPriority.
typedef struct etsi_its_cam_ts_msgs__msg__EmergencyPriority__Sequence
{
  etsi_its_cam_ts_msgs__msg__EmergencyPriority * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__EmergencyPriority__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__EMERGENCY_PRIORITY__STRUCT_H_
