// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/HazardousLocationSurfaceConditionSubCauseCode.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HAZARDOUS_LOCATION_SURFACE_CONDITION_SUB_CAUSE_CODE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HAZARDOUS_LOCATION_SURFACE_CONDITION_SUB_CAUSE_CODE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__MAX = 255
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__UNAVAILABLE = 0
};

/// Constant 'ROCKFALLS'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__ROCKFALLS = 1
};

/// Constant 'EARTHQUAKE_DAMAGE'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__EARTHQUAKE_DAMAGE = 2
};

/// Constant 'SEWER_COLLAPSE'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__SEWER_COLLAPSE = 3
};

/// Constant 'SUBSIDENCE'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__SUBSIDENCE = 4
};

/// Constant 'SNOW_DRIFTS'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__SNOW_DRIFTS = 5
};

/// Constant 'STORM_DAMAGE'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__STORM_DAMAGE = 6
};

/// Constant 'BURST_PIPE'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__BURST_PIPE = 7
};

/// Constant 'VOLCANO_ERUPTION'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__VOLCANO_ERUPTION = 8
};

/// Constant 'FALLING_ICE'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__FALLING_ICE = 9
};

/// Constant 'FIRE'.
enum
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__FIRE = 10
};

/// Struct defined in msg/HazardousLocationSurfaceConditionSubCauseCode in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents the value of the sub cause code of the @ref CauseCode `hazardousLocation-SurfaceCondition`.
  ///  *
  /// The value shall be set to:
  ///  * - 0  - `unavailable`     - in case further detailed information on the road surface condition is unavailable,
  ///  * - 1  - `rockfalls`       - in case rock falls are detected on the road surface,
  ///  * - 2  - `earthquakeDamage`- in case the road surface is damaged by earthquake,
  ///  * - 3  - `sewerCollapse`   - in case of sewer collapse on the road surface,
  ///  * - 4  - `subsidence`      - in case road surface is damaged by subsidence,
  ///  * - 5  - `snowDrifts`      - in case road surface is damaged due to snow drift,
  ///  * - 6  - `stormDamage`     - in case road surface is damaged by strong storm,
  ///  * - 7  - `burstPipe`       - in case road surface is damaged due to pipe burst,
  ///  * - 8  - `volcanoEruption` - in case road surface is damaged due to volcano eruption,
  ///  * - 9  - `fallingIce`      - in case road surface damage is due to falling ice,
  ///  * - 10 - `fire`            - in case there is fire on or near to the road surface.
  ///  * - 11-255                 - are reserved for future usage.
  ///  *
  ///  * @category: Traffic information
  ///  * @revision: V1.3.1
  ///  */
  /// HazardousLocation-SurfaceConditionSubCauseCode ::= INTEGER {
  ///     unavailable      (0),
  ///     rockfalls        (1),
  ///     earthquakeDamage (2),
  ///     sewerCollapse    (3),
  ///     subsidence       (4),
  ///     snowDrifts       (5),
  ///     stormDamage      (6),
  ///     burstPipe        (7),
  ///     volcanoEruption  (8),
  ///     fallingIce       (9),
  ///     fire             (10)
  /// } (0..255)
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode.
typedef struct etsi_its_cam_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__Sequence
{
  etsi_its_cam_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HAZARDOUS_LOCATION_SURFACE_CONDITION_SUB_CAUSE_CODE__STRUCT_H_
