// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/ImpassabilitySubCauseCode.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__IMPASSABILITY_SUB_CAUSE_CODE__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__IMPASSABILITY_SUB_CAUSE_CODE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ImpassabilitySubCauseCode_
{
  using Type = ImpassabilitySubCauseCode_<ContainerAllocator>;

  explicit ImpassabilitySubCauseCode_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  explicit ImpassabilitySubCauseCode_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  // field types and members
  using _value_type =
    uint8_t;
  _value_type value;

  // setters for named parameter idiom
  Type & set__value(
    const uint8_t & _arg)
  {
    this->value = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t MIN =
    0u;
  static constexpr uint8_t MAX =
    255u;
  static constexpr uint8_t UNAVAILABLE =
    0u;
  static constexpr uint8_t FLOODING =
    1u;
  static constexpr uint8_t DANGER_OF_AVALANCHES =
    2u;
  static constexpr uint8_t BLASTING_OF_AVALANCHES =
    3u;
  static constexpr uint8_t LANDSLIPS =
    4u;
  static constexpr uint8_t CHEMICAL_SPILLAGE =
    5u;
  static constexpr uint8_t WINTER_CLOSURE =
    6u;
  static constexpr uint8_t SINKHOLE =
    7u;
  static constexpr uint8_t EARTHQUAKE_DAMAGE =
    8u;
  static constexpr uint8_t FALLEN_TREES =
    9u;
  static constexpr uint8_t ROCKFALLS =
    10u;
  static constexpr uint8_t SEWER_OVERFLOW =
    11u;
  static constexpr uint8_t STORM_DAMAGE =
    12u;
  static constexpr uint8_t SUBSIDENCE =
    13u;
  static constexpr uint8_t BURST_PIPE =
    14u;
  static constexpr uint8_t BURST_WATER_MAIN =
    15u;
  static constexpr uint8_t FALLEN_POWER_CABLES =
    16u;
  static constexpr uint8_t SNOW_DRIFTS =
    17u;

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::ImpassabilitySubCauseCode_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::ImpassabilitySubCauseCode_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::ImpassabilitySubCauseCode_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::ImpassabilitySubCauseCode_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::ImpassabilitySubCauseCode_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::ImpassabilitySubCauseCode_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::ImpassabilitySubCauseCode_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::ImpassabilitySubCauseCode_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::ImpassabilitySubCauseCode_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::ImpassabilitySubCauseCode_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::ImpassabilitySubCauseCode_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__ImpassabilitySubCauseCode
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::ImpassabilitySubCauseCode_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ImpassabilitySubCauseCode_ & other) const
  {
    if (this->value != other.value) {
      return false;
    }
    return true;
  }
  bool operator!=(const ImpassabilitySubCauseCode_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ImpassabilitySubCauseCode_

// alias to use template instance with default allocator
using ImpassabilitySubCauseCode =
  etsi_its_cam_ts_msgs::msg::ImpassabilitySubCauseCode_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ImpassabilitySubCauseCode_<ContainerAllocator>::MIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ImpassabilitySubCauseCode_<ContainerAllocator>::MAX;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ImpassabilitySubCauseCode_<ContainerAllocator>::UNAVAILABLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ImpassabilitySubCauseCode_<ContainerAllocator>::FLOODING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ImpassabilitySubCauseCode_<ContainerAllocator>::DANGER_OF_AVALANCHES;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ImpassabilitySubCauseCode_<ContainerAllocator>::BLASTING_OF_AVALANCHES;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ImpassabilitySubCauseCode_<ContainerAllocator>::LANDSLIPS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ImpassabilitySubCauseCode_<ContainerAllocator>::CHEMICAL_SPILLAGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ImpassabilitySubCauseCode_<ContainerAllocator>::WINTER_CLOSURE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ImpassabilitySubCauseCode_<ContainerAllocator>::SINKHOLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ImpassabilitySubCauseCode_<ContainerAllocator>::EARTHQUAKE_DAMAGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ImpassabilitySubCauseCode_<ContainerAllocator>::FALLEN_TREES;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ImpassabilitySubCauseCode_<ContainerAllocator>::ROCKFALLS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ImpassabilitySubCauseCode_<ContainerAllocator>::SEWER_OVERFLOW;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ImpassabilitySubCauseCode_<ContainerAllocator>::STORM_DAMAGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ImpassabilitySubCauseCode_<ContainerAllocator>::SUBSIDENCE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ImpassabilitySubCauseCode_<ContainerAllocator>::BURST_PIPE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ImpassabilitySubCauseCode_<ContainerAllocator>::BURST_WATER_MAIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ImpassabilitySubCauseCode_<ContainerAllocator>::FALLEN_POWER_CABLES;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ImpassabilitySubCauseCode_<ContainerAllocator>::SNOW_DRIFTS;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__IMPASSABILITY_SUB_CAUSE_CODE__STRUCT_HPP_
