// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cam_ts_msgs:msg/ItsPduHeader.idl
// generated code does not contain a copyright notice
#include "etsi_its_cam_ts_msgs/msg/detail/its_pdu_header__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `protocol_version`
#include "etsi_its_cam_ts_msgs/msg/detail/ordinal_number1_b__functions.h"
// Member `message_id`
#include "etsi_its_cam_ts_msgs/msg/detail/message_id__functions.h"
// Member `station_id`
#include "etsi_its_cam_ts_msgs/msg/detail/station_id__functions.h"

bool
etsi_its_cam_ts_msgs__msg__ItsPduHeader__init(etsi_its_cam_ts_msgs__msg__ItsPduHeader * msg)
{
  if (!msg) {
    return false;
  }
  // protocol_version
  if (!etsi_its_cam_ts_msgs__msg__OrdinalNumber1B__init(&msg->protocol_version)) {
    etsi_its_cam_ts_msgs__msg__ItsPduHeader__fini(msg);
    return false;
  }
  // message_id
  if (!etsi_its_cam_ts_msgs__msg__MessageId__init(&msg->message_id)) {
    etsi_its_cam_ts_msgs__msg__ItsPduHeader__fini(msg);
    return false;
  }
  // station_id
  if (!etsi_its_cam_ts_msgs__msg__StationId__init(&msg->station_id)) {
    etsi_its_cam_ts_msgs__msg__ItsPduHeader__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_cam_ts_msgs__msg__ItsPduHeader__fini(etsi_its_cam_ts_msgs__msg__ItsPduHeader * msg)
{
  if (!msg) {
    return;
  }
  // protocol_version
  etsi_its_cam_ts_msgs__msg__OrdinalNumber1B__fini(&msg->protocol_version);
  // message_id
  etsi_its_cam_ts_msgs__msg__MessageId__fini(&msg->message_id);
  // station_id
  etsi_its_cam_ts_msgs__msg__StationId__fini(&msg->station_id);
}

bool
etsi_its_cam_ts_msgs__msg__ItsPduHeader__are_equal(const etsi_its_cam_ts_msgs__msg__ItsPduHeader * lhs, const etsi_its_cam_ts_msgs__msg__ItsPduHeader * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // protocol_version
  if (!etsi_its_cam_ts_msgs__msg__OrdinalNumber1B__are_equal(
      &(lhs->protocol_version), &(rhs->protocol_version)))
  {
    return false;
  }
  // message_id
  if (!etsi_its_cam_ts_msgs__msg__MessageId__are_equal(
      &(lhs->message_id), &(rhs->message_id)))
  {
    return false;
  }
  // station_id
  if (!etsi_its_cam_ts_msgs__msg__StationId__are_equal(
      &(lhs->station_id), &(rhs->station_id)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__ItsPduHeader__copy(
  const etsi_its_cam_ts_msgs__msg__ItsPduHeader * input,
  etsi_its_cam_ts_msgs__msg__ItsPduHeader * output)
{
  if (!input || !output) {
    return false;
  }
  // protocol_version
  if (!etsi_its_cam_ts_msgs__msg__OrdinalNumber1B__copy(
      &(input->protocol_version), &(output->protocol_version)))
  {
    return false;
  }
  // message_id
  if (!etsi_its_cam_ts_msgs__msg__MessageId__copy(
      &(input->message_id), &(output->message_id)))
  {
    return false;
  }
  // station_id
  if (!etsi_its_cam_ts_msgs__msg__StationId__copy(
      &(input->station_id), &(output->station_id)))
  {
    return false;
  }
  return true;
}

etsi_its_cam_ts_msgs__msg__ItsPduHeader *
etsi_its_cam_ts_msgs__msg__ItsPduHeader__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__ItsPduHeader * msg = (etsi_its_cam_ts_msgs__msg__ItsPduHeader *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__ItsPduHeader), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cam_ts_msgs__msg__ItsPduHeader));
  bool success = etsi_its_cam_ts_msgs__msg__ItsPduHeader__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cam_ts_msgs__msg__ItsPduHeader__destroy(etsi_its_cam_ts_msgs__msg__ItsPduHeader * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cam_ts_msgs__msg__ItsPduHeader__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cam_ts_msgs__msg__ItsPduHeader__Sequence__init(etsi_its_cam_ts_msgs__msg__ItsPduHeader__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__ItsPduHeader * data = NULL;

  if (size) {
    data = (etsi_its_cam_ts_msgs__msg__ItsPduHeader *)allocator.zero_allocate(size, sizeof(etsi_its_cam_ts_msgs__msg__ItsPduHeader), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cam_ts_msgs__msg__ItsPduHeader__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cam_ts_msgs__msg__ItsPduHeader__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cam_ts_msgs__msg__ItsPduHeader__Sequence__fini(etsi_its_cam_ts_msgs__msg__ItsPduHeader__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cam_ts_msgs__msg__ItsPduHeader__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cam_ts_msgs__msg__ItsPduHeader__Sequence *
etsi_its_cam_ts_msgs__msg__ItsPduHeader__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__ItsPduHeader__Sequence * array = (etsi_its_cam_ts_msgs__msg__ItsPduHeader__Sequence *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__ItsPduHeader__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cam_ts_msgs__msg__ItsPduHeader__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cam_ts_msgs__msg__ItsPduHeader__Sequence__destroy(etsi_its_cam_ts_msgs__msg__ItsPduHeader__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cam_ts_msgs__msg__ItsPduHeader__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cam_ts_msgs__msg__ItsPduHeader__Sequence__are_equal(const etsi_its_cam_ts_msgs__msg__ItsPduHeader__Sequence * lhs, const etsi_its_cam_ts_msgs__msg__ItsPduHeader__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__ItsPduHeader__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__ItsPduHeader__Sequence__copy(
  const etsi_its_cam_ts_msgs__msg__ItsPduHeader__Sequence * input,
  etsi_its_cam_ts_msgs__msg__ItsPduHeader__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cam_ts_msgs__msg__ItsPduHeader);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cam_ts_msgs__msg__ItsPduHeader * data =
      (etsi_its_cam_ts_msgs__msg__ItsPduHeader *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cam_ts_msgs__msg__ItsPduHeader__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cam_ts_msgs__msg__ItsPduHeader__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__ItsPduHeader__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
