// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/LowFrequencyContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__LOW_FREQUENCY_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__LOW_FREQUENCY_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'basic_vehicle_container_low_frequency'
#include "etsi_its_cam_ts_msgs/msg/detail/basic_vehicle_container_low_frequency__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__LowFrequencyContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__LowFrequencyContainer __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct LowFrequencyContainer_
{
  using Type = LowFrequencyContainer_<ContainerAllocator>;

  explicit LowFrequencyContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : basic_vehicle_container_low_frequency(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->choice = 0;
    }
  }

  explicit LowFrequencyContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : basic_vehicle_container_low_frequency(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->choice = 0;
    }
  }

  // field types and members
  using _choice_type =
    uint8_t;
  _choice_type choice;
  using _basic_vehicle_container_low_frequency_type =
    etsi_its_cam_ts_msgs::msg::BasicVehicleContainerLowFrequency_<ContainerAllocator>;
  _basic_vehicle_container_low_frequency_type basic_vehicle_container_low_frequency;

  // setters for named parameter idiom
  Type & set__choice(
    const uint8_t & _arg)
  {
    this->choice = _arg;
    return *this;
  }
  Type & set__basic_vehicle_container_low_frequency(
    const etsi_its_cam_ts_msgs::msg::BasicVehicleContainerLowFrequency_<ContainerAllocator> & _arg)
  {
    this->basic_vehicle_container_low_frequency = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t CHOICE_BASIC_VEHICLE_CONTAINER_LOW_FREQUENCY =
    0u;

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::LowFrequencyContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::LowFrequencyContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::LowFrequencyContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::LowFrequencyContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::LowFrequencyContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::LowFrequencyContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::LowFrequencyContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::LowFrequencyContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::LowFrequencyContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::LowFrequencyContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__LowFrequencyContainer
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::LowFrequencyContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__LowFrequencyContainer
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::LowFrequencyContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LowFrequencyContainer_ & other) const
  {
    if (this->choice != other.choice) {
      return false;
    }
    if (this->basic_vehicle_container_low_frequency != other.basic_vehicle_container_low_frequency) {
      return false;
    }
    return true;
  }
  bool operator!=(const LowFrequencyContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LowFrequencyContainer_

// alias to use template instance with default allocator
using LowFrequencyContainer =
  etsi_its_cam_ts_msgs::msg::LowFrequencyContainer_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t LowFrequencyContainer_<ContainerAllocator>::CHOICE_BASIC_VEHICLE_CONTAINER_LOW_FREQUENCY;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__LOW_FREQUENCY_CONTAINER__STRUCT_HPP_
