// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/LowFrequencyContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__LOW_FREQUENCY_CONTAINER__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__LOW_FREQUENCY_CONTAINER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/low_frequency_container__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'basic_vehicle_container_low_frequency'
#include "etsi_its_cam_ts_msgs/msg/detail/basic_vehicle_container_low_frequency__traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const LowFrequencyContainer & msg,
  std::ostream & out)
{
  out << "{";
  // member: choice
  {
    out << "choice: ";
    rosidl_generator_traits::value_to_yaml(msg.choice, out);
    out << ", ";
  }

  // member: basic_vehicle_container_low_frequency
  {
    out << "basic_vehicle_container_low_frequency: ";
    to_flow_style_yaml(msg.basic_vehicle_container_low_frequency, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const LowFrequencyContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: choice
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "choice: ";
    rosidl_generator_traits::value_to_yaml(msg.choice, out);
    out << "\n";
  }

  // member: basic_vehicle_container_low_frequency
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "basic_vehicle_container_low_frequency:\n";
    to_block_style_yaml(msg.basic_vehicle_container_low_frequency, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const LowFrequencyContainer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::LowFrequencyContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::LowFrequencyContainer & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::LowFrequencyContainer>()
{
  return "etsi_its_cam_ts_msgs::msg::LowFrequencyContainer";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::LowFrequencyContainer>()
{
  return "etsi_its_cam_ts_msgs/msg/LowFrequencyContainer";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::LowFrequencyContainer>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_ts_msgs::msg::BasicVehicleContainerLowFrequency>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::LowFrequencyContainer>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_ts_msgs::msg::BasicVehicleContainerLowFrequency>::value> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::LowFrequencyContainer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__LOW_FREQUENCY_CONTAINER__TRAITS_HPP_
