// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/PositionConfidenceEllipse.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__POSITION_CONFIDENCE_ELLIPSE__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__POSITION_CONFIDENCE_ELLIPSE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'semi_major_axis_length'
// Member 'semi_minor_axis_length'
#include "etsi_its_cam_ts_msgs/msg/detail/semi_axis_length__struct.hpp"
// Member 'semi_major_axis_orientation'
#include "etsi_its_cam_ts_msgs/msg/detail/wgs84_angle_value__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PositionConfidenceEllipse_
{
  using Type = PositionConfidenceEllipse_<ContainerAllocator>;

  explicit PositionConfidenceEllipse_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : semi_major_axis_length(_init),
    semi_minor_axis_length(_init),
    semi_major_axis_orientation(_init)
  {
    (void)_init;
  }

  explicit PositionConfidenceEllipse_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : semi_major_axis_length(_alloc, _init),
    semi_minor_axis_length(_alloc, _init),
    semi_major_axis_orientation(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _semi_major_axis_length_type =
    etsi_its_cam_ts_msgs::msg::SemiAxisLength_<ContainerAllocator>;
  _semi_major_axis_length_type semi_major_axis_length;
  using _semi_minor_axis_length_type =
    etsi_its_cam_ts_msgs::msg::SemiAxisLength_<ContainerAllocator>;
  _semi_minor_axis_length_type semi_minor_axis_length;
  using _semi_major_axis_orientation_type =
    etsi_its_cam_ts_msgs::msg::Wgs84AngleValue_<ContainerAllocator>;
  _semi_major_axis_orientation_type semi_major_axis_orientation;

  // setters for named parameter idiom
  Type & set__semi_major_axis_length(
    const etsi_its_cam_ts_msgs::msg::SemiAxisLength_<ContainerAllocator> & _arg)
  {
    this->semi_major_axis_length = _arg;
    return *this;
  }
  Type & set__semi_minor_axis_length(
    const etsi_its_cam_ts_msgs::msg::SemiAxisLength_<ContainerAllocator> & _arg)
  {
    this->semi_minor_axis_length = _arg;
    return *this;
  }
  Type & set__semi_major_axis_orientation(
    const etsi_its_cam_ts_msgs::msg::Wgs84AngleValue_<ContainerAllocator> & _arg)
  {
    this->semi_major_axis_orientation = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::PositionConfidenceEllipse_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::PositionConfidenceEllipse_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::PositionConfidenceEllipse_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::PositionConfidenceEllipse_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::PositionConfidenceEllipse_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::PositionConfidenceEllipse_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::PositionConfidenceEllipse_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::PositionConfidenceEllipse_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::PositionConfidenceEllipse_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::PositionConfidenceEllipse_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::PositionConfidenceEllipse_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__PositionConfidenceEllipse
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::PositionConfidenceEllipse_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PositionConfidenceEllipse_ & other) const
  {
    if (this->semi_major_axis_length != other.semi_major_axis_length) {
      return false;
    }
    if (this->semi_minor_axis_length != other.semi_minor_axis_length) {
      return false;
    }
    if (this->semi_major_axis_orientation != other.semi_major_axis_orientation) {
      return false;
    }
    return true;
  }
  bool operator!=(const PositionConfidenceEllipse_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PositionConfidenceEllipse_

// alias to use template instance with default allocator
using PositionConfidenceEllipse =
  etsi_its_cam_ts_msgs::msg::PositionConfidenceEllipse_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__POSITION_CONFIDENCE_ELLIPSE__STRUCT_HPP_
