// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/PositionConfidenceEllipse.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__POSITION_CONFIDENCE_ELLIPSE__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__POSITION_CONFIDENCE_ELLIPSE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/position_confidence_ellipse__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'semi_major_axis_length'
// Member 'semi_minor_axis_length'
#include "etsi_its_cam_ts_msgs/msg/detail/semi_axis_length__traits.hpp"
// Member 'semi_major_axis_orientation'
#include "etsi_its_cam_ts_msgs/msg/detail/wgs84_angle_value__traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const PositionConfidenceEllipse & msg,
  std::ostream & out)
{
  out << "{";
  // member: semi_major_axis_length
  {
    out << "semi_major_axis_length: ";
    to_flow_style_yaml(msg.semi_major_axis_length, out);
    out << ", ";
  }

  // member: semi_minor_axis_length
  {
    out << "semi_minor_axis_length: ";
    to_flow_style_yaml(msg.semi_minor_axis_length, out);
    out << ", ";
  }

  // member: semi_major_axis_orientation
  {
    out << "semi_major_axis_orientation: ";
    to_flow_style_yaml(msg.semi_major_axis_orientation, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PositionConfidenceEllipse & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: semi_major_axis_length
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "semi_major_axis_length:\n";
    to_block_style_yaml(msg.semi_major_axis_length, out, indentation + 2);
  }

  // member: semi_minor_axis_length
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "semi_minor_axis_length:\n";
    to_block_style_yaml(msg.semi_minor_axis_length, out, indentation + 2);
  }

  // member: semi_major_axis_orientation
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "semi_major_axis_orientation:\n";
    to_block_style_yaml(msg.semi_major_axis_orientation, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PositionConfidenceEllipse & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::PositionConfidenceEllipse & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::PositionConfidenceEllipse & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::PositionConfidenceEllipse>()
{
  return "etsi_its_cam_ts_msgs::msg::PositionConfidenceEllipse";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::PositionConfidenceEllipse>()
{
  return "etsi_its_cam_ts_msgs/msg/PositionConfidenceEllipse";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::PositionConfidenceEllipse>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_ts_msgs::msg::SemiAxisLength>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::Wgs84AngleValue>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::PositionConfidenceEllipse>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_ts_msgs::msg::SemiAxisLength>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::Wgs84AngleValue>::value> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::PositionConfidenceEllipse>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__POSITION_CONFIDENCE_ELLIPSE__TRAITS_HPP_
