// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/PtActivation.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PT_ACTIVATION__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PT_ACTIVATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'pt_activation_type'
#include "etsi_its_cam_ts_msgs/msg/detail/pt_activation_type__struct.hpp"
// Member 'pt_activation_data'
#include "etsi_its_cam_ts_msgs/msg/detail/pt_activation_data__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__PtActivation __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__PtActivation __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PtActivation_
{
  using Type = PtActivation_<ContainerAllocator>;

  explicit PtActivation_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : pt_activation_type(_init),
    pt_activation_data(_init)
  {
    (void)_init;
  }

  explicit PtActivation_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : pt_activation_type(_alloc, _init),
    pt_activation_data(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _pt_activation_type_type =
    etsi_its_cam_ts_msgs::msg::PtActivationType_<ContainerAllocator>;
  _pt_activation_type_type pt_activation_type;
  using _pt_activation_data_type =
    etsi_its_cam_ts_msgs::msg::PtActivationData_<ContainerAllocator>;
  _pt_activation_data_type pt_activation_data;

  // setters for named parameter idiom
  Type & set__pt_activation_type(
    const etsi_its_cam_ts_msgs::msg::PtActivationType_<ContainerAllocator> & _arg)
  {
    this->pt_activation_type = _arg;
    return *this;
  }
  Type & set__pt_activation_data(
    const etsi_its_cam_ts_msgs::msg::PtActivationData_<ContainerAllocator> & _arg)
  {
    this->pt_activation_data = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::PtActivation_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::PtActivation_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::PtActivation_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::PtActivation_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::PtActivation_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::PtActivation_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::PtActivation_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::PtActivation_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::PtActivation_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::PtActivation_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__PtActivation
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::PtActivation_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__PtActivation
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::PtActivation_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PtActivation_ & other) const
  {
    if (this->pt_activation_type != other.pt_activation_type) {
      return false;
    }
    if (this->pt_activation_data != other.pt_activation_data) {
      return false;
    }
    return true;
  }
  bool operator!=(const PtActivation_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PtActivation_

// alias to use template instance with default allocator
using PtActivation =
  etsi_its_cam_ts_msgs::msg::PtActivation_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PT_ACTIVATION__STRUCT_HPP_
