// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/PublicTransportContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PUBLIC_TRANSPORT_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PUBLIC_TRANSPORT_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'embarkation_status'
#include "etsi_its_cam_ts_msgs/msg/detail/embarkation_status__struct.hpp"
// Member 'pt_activation'
#include "etsi_its_cam_ts_msgs/msg/detail/pt_activation__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__PublicTransportContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__PublicTransportContainer __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PublicTransportContainer_
{
  using Type = PublicTransportContainer_<ContainerAllocator>;

  explicit PublicTransportContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : embarkation_status(_init),
    pt_activation(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->pt_activation_is_present = false;
    }
  }

  explicit PublicTransportContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : embarkation_status(_alloc, _init),
    pt_activation(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->pt_activation_is_present = false;
    }
  }

  // field types and members
  using _embarkation_status_type =
    etsi_its_cam_ts_msgs::msg::EmbarkationStatus_<ContainerAllocator>;
  _embarkation_status_type embarkation_status;
  using _pt_activation_type =
    etsi_its_cam_ts_msgs::msg::PtActivation_<ContainerAllocator>;
  _pt_activation_type pt_activation;
  using _pt_activation_is_present_type =
    bool;
  _pt_activation_is_present_type pt_activation_is_present;

  // setters for named parameter idiom
  Type & set__embarkation_status(
    const etsi_its_cam_ts_msgs::msg::EmbarkationStatus_<ContainerAllocator> & _arg)
  {
    this->embarkation_status = _arg;
    return *this;
  }
  Type & set__pt_activation(
    const etsi_its_cam_ts_msgs::msg::PtActivation_<ContainerAllocator> & _arg)
  {
    this->pt_activation = _arg;
    return *this;
  }
  Type & set__pt_activation_is_present(
    const bool & _arg)
  {
    this->pt_activation_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::PublicTransportContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::PublicTransportContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::PublicTransportContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::PublicTransportContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::PublicTransportContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::PublicTransportContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::PublicTransportContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::PublicTransportContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::PublicTransportContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::PublicTransportContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__PublicTransportContainer
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::PublicTransportContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__PublicTransportContainer
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::PublicTransportContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PublicTransportContainer_ & other) const
  {
    if (this->embarkation_status != other.embarkation_status) {
      return false;
    }
    if (this->pt_activation != other.pt_activation) {
      return false;
    }
    if (this->pt_activation_is_present != other.pt_activation_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const PublicTransportContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PublicTransportContainer_

// alias to use template instance with default allocator
using PublicTransportContainer =
  etsi_its_cam_ts_msgs::msg::PublicTransportContainer_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PUBLIC_TRANSPORT_CONTAINER__STRUCT_HPP_
