// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/PublicTransportContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PUBLIC_TRANSPORT_CONTAINER__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PUBLIC_TRANSPORT_CONTAINER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/public_transport_container__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'embarkation_status'
#include "etsi_its_cam_ts_msgs/msg/detail/embarkation_status__traits.hpp"
// Member 'pt_activation'
#include "etsi_its_cam_ts_msgs/msg/detail/pt_activation__traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const PublicTransportContainer & msg,
  std::ostream & out)
{
  out << "{";
  // member: embarkation_status
  {
    out << "embarkation_status: ";
    to_flow_style_yaml(msg.embarkation_status, out);
    out << ", ";
  }

  // member: pt_activation
  {
    out << "pt_activation: ";
    to_flow_style_yaml(msg.pt_activation, out);
    out << ", ";
  }

  // member: pt_activation_is_present
  {
    out << "pt_activation_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.pt_activation_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PublicTransportContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: embarkation_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "embarkation_status:\n";
    to_block_style_yaml(msg.embarkation_status, out, indentation + 2);
  }

  // member: pt_activation
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pt_activation:\n";
    to_block_style_yaml(msg.pt_activation, out, indentation + 2);
  }

  // member: pt_activation_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pt_activation_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.pt_activation_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PublicTransportContainer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::PublicTransportContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::PublicTransportContainer & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::PublicTransportContainer>()
{
  return "etsi_its_cam_ts_msgs::msg::PublicTransportContainer";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::PublicTransportContainer>()
{
  return "etsi_its_cam_ts_msgs/msg/PublicTransportContainer";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::PublicTransportContainer>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_ts_msgs::msg::EmbarkationStatus>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::PtActivation>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::PublicTransportContainer>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_ts_msgs::msg::EmbarkationStatus>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::PtActivation>::value> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::PublicTransportContainer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PUBLIC_TRANSPORT_CONTAINER__TRAITS_HPP_
