// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/RailwayLevelCrossingSubCauseCode.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__RAILWAY_LEVEL_CROSSING_SUB_CAUSE_CODE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__RAILWAY_LEVEL_CROSSING_SUB_CAUSE_CODE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode__MAX = 255
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode__UNAVAILABLE = 0
};

/// Constant 'DO_NOT_CROSS_ABNORMAL_SITUATION'.
enum
{
  etsi_its_cam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode__DO_NOT_CROSS_ABNORMAL_SITUATION = 1
};

/// Constant 'CLOSED'.
enum
{
  etsi_its_cam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode__CLOSED = 2
};

/// Constant 'UNGUARDED'.
enum
{
  etsi_its_cam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode__UNGUARDED = 3
};

/// Constant 'NOMINAL'.
enum
{
  etsi_its_cam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode__NOMINAL = 4
};

/// Struct defined in msg/RailwayLevelCrossingSubCauseCode in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents the value of the sub cause codes of the @ref CauseCode `railwayLevelCrossing` .
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 `unavailable`                   - in case no further detailed information on the railway level crossing status is available,
  ///  * - 1 `doNotCrossAbnormalSituation`   - in case when something wrong is detected by equation or sensors of the railway level crossing,
  ///                                          including level crossing is closed for too long (e.g. more than 10 minutes long ; default value),
  ///  * - 2 `closed`                        - in case the crossing is closed (barriers down),
  ///  * - 3 `unguarded`                     - in case the level crossing is unguarded (i.e a Saint Andrew cross level crossing without detection of train),
  ///  * - 4 `nominal`                       - in case the barriers are up and lights are off.
  ///  * - 5-255: reserved for future usage.
  ///  *
  ///  * @category: Traffic information
  ///  * @revision: V1.3.1
  ///  */
  /// RailwayLevelCrossingSubCauseCode ::= INTEGER {
  ///     unavailable                 (0),
  ///     doNotCrossAbnormalSituation (1),
  ///     closed                      (2),
  ///     unguarded                   (3),
  ///     nominal                     (4)
  /// } (0..255)
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode.
typedef struct etsi_its_cam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode__Sequence
{
  etsi_its_cam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__RAILWAY_LEVEL_CROSSING_SUB_CAUSE_CODE__STRUCT_H_
