// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/RoadWorksContainerBasic.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ROAD_WORKS_CONTAINER_BASIC__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ROAD_WORKS_CONTAINER_BASIC__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/road_works_container_basic__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'roadworks_sub_cause_code'
#include "etsi_its_cam_ts_msgs/msg/detail/roadworks_sub_cause_code__traits.hpp"
// Member 'light_bar_siren_in_use'
#include "etsi_its_cam_ts_msgs/msg/detail/light_bar_siren_in_use__traits.hpp"
// Member 'closed_lanes'
#include "etsi_its_cam_ts_msgs/msg/detail/closed_lanes__traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const RoadWorksContainerBasic & msg,
  std::ostream & out)
{
  out << "{";
  // member: roadworks_sub_cause_code
  {
    out << "roadworks_sub_cause_code: ";
    to_flow_style_yaml(msg.roadworks_sub_cause_code, out);
    out << ", ";
  }

  // member: roadworks_sub_cause_code_is_present
  {
    out << "roadworks_sub_cause_code_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.roadworks_sub_cause_code_is_present, out);
    out << ", ";
  }

  // member: light_bar_siren_in_use
  {
    out << "light_bar_siren_in_use: ";
    to_flow_style_yaml(msg.light_bar_siren_in_use, out);
    out << ", ";
  }

  // member: closed_lanes
  {
    out << "closed_lanes: ";
    to_flow_style_yaml(msg.closed_lanes, out);
    out << ", ";
  }

  // member: closed_lanes_is_present
  {
    out << "closed_lanes_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.closed_lanes_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RoadWorksContainerBasic & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: roadworks_sub_cause_code
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "roadworks_sub_cause_code:\n";
    to_block_style_yaml(msg.roadworks_sub_cause_code, out, indentation + 2);
  }

  // member: roadworks_sub_cause_code_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "roadworks_sub_cause_code_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.roadworks_sub_cause_code_is_present, out);
    out << "\n";
  }

  // member: light_bar_siren_in_use
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "light_bar_siren_in_use:\n";
    to_block_style_yaml(msg.light_bar_siren_in_use, out, indentation + 2);
  }

  // member: closed_lanes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "closed_lanes:\n";
    to_block_style_yaml(msg.closed_lanes, out, indentation + 2);
  }

  // member: closed_lanes_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "closed_lanes_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.closed_lanes_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RoadWorksContainerBasic & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic>()
{
  return "etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic>()
{
  return "etsi_its_cam_ts_msgs/msg/RoadWorksContainerBasic";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_ts_msgs::msg::ClosedLanes>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::LightBarSirenInUse>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::RoadworksSubCauseCode>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_ts_msgs::msg::ClosedLanes>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::LightBarSirenInUse>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::RoadworksSubCauseCode>::value> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ROAD_WORKS_CONTAINER_BASIC__TRAITS_HPP_
