// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/RSUContainerHighFrequency.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__RSU_CONTAINER_HIGH_FREQUENCY__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__RSU_CONTAINER_HIGH_FREQUENCY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'protected_communication_zones_rsu'
#include "etsi_its_cam_ts_msgs/msg/detail/protected_communication_zones_rsu__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__RSUContainerHighFrequency __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__RSUContainerHighFrequency __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RSUContainerHighFrequency_
{
  using Type = RSUContainerHighFrequency_<ContainerAllocator>;

  explicit RSUContainerHighFrequency_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : protected_communication_zones_rsu(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->protected_communication_zones_rsu_is_present = false;
    }
  }

  explicit RSUContainerHighFrequency_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : protected_communication_zones_rsu(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->protected_communication_zones_rsu_is_present = false;
    }
  }

  // field types and members
  using _protected_communication_zones_rsu_type =
    etsi_its_cam_ts_msgs::msg::ProtectedCommunicationZonesRSU_<ContainerAllocator>;
  _protected_communication_zones_rsu_type protected_communication_zones_rsu;
  using _protected_communication_zones_rsu_is_present_type =
    bool;
  _protected_communication_zones_rsu_is_present_type protected_communication_zones_rsu_is_present;

  // setters for named parameter idiom
  Type & set__protected_communication_zones_rsu(
    const etsi_its_cam_ts_msgs::msg::ProtectedCommunicationZonesRSU_<ContainerAllocator> & _arg)
  {
    this->protected_communication_zones_rsu = _arg;
    return *this;
  }
  Type & set__protected_communication_zones_rsu_is_present(
    const bool & _arg)
  {
    this->protected_communication_zones_rsu_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::RSUContainerHighFrequency_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::RSUContainerHighFrequency_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::RSUContainerHighFrequency_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::RSUContainerHighFrequency_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::RSUContainerHighFrequency_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::RSUContainerHighFrequency_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::RSUContainerHighFrequency_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::RSUContainerHighFrequency_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::RSUContainerHighFrequency_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::RSUContainerHighFrequency_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__RSUContainerHighFrequency
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::RSUContainerHighFrequency_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__RSUContainerHighFrequency
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::RSUContainerHighFrequency_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RSUContainerHighFrequency_ & other) const
  {
    if (this->protected_communication_zones_rsu != other.protected_communication_zones_rsu) {
      return false;
    }
    if (this->protected_communication_zones_rsu_is_present != other.protected_communication_zones_rsu_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const RSUContainerHighFrequency_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RSUContainerHighFrequency_

// alias to use template instance with default allocator
using RSUContainerHighFrequency =
  etsi_its_cam_ts_msgs::msg::RSUContainerHighFrequency_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__RSU_CONTAINER_HIGH_FREQUENCY__STRUCT_HPP_
