// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/SafetyCarContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SAFETY_CAR_CONTAINER__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SAFETY_CAR_CONTAINER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/safety_car_container__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'light_bar_siren_in_use'
#include "etsi_its_cam_ts_msgs/msg/detail/light_bar_siren_in_use__traits.hpp"
// Member 'incident_indication'
#include "etsi_its_cam_ts_msgs/msg/detail/cause_code_v2__traits.hpp"
// Member 'traffic_rule'
#include "etsi_its_cam_ts_msgs/msg/detail/traffic_rule__traits.hpp"
// Member 'speed_limit'
#include "etsi_its_cam_ts_msgs/msg/detail/speed_limit__traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SafetyCarContainer & msg,
  std::ostream & out)
{
  out << "{";
  // member: light_bar_siren_in_use
  {
    out << "light_bar_siren_in_use: ";
    to_flow_style_yaml(msg.light_bar_siren_in_use, out);
    out << ", ";
  }

  // member: incident_indication
  {
    out << "incident_indication: ";
    to_flow_style_yaml(msg.incident_indication, out);
    out << ", ";
  }

  // member: incident_indication_is_present
  {
    out << "incident_indication_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.incident_indication_is_present, out);
    out << ", ";
  }

  // member: traffic_rule
  {
    out << "traffic_rule: ";
    to_flow_style_yaml(msg.traffic_rule, out);
    out << ", ";
  }

  // member: traffic_rule_is_present
  {
    out << "traffic_rule_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.traffic_rule_is_present, out);
    out << ", ";
  }

  // member: speed_limit
  {
    out << "speed_limit: ";
    to_flow_style_yaml(msg.speed_limit, out);
    out << ", ";
  }

  // member: speed_limit_is_present
  {
    out << "speed_limit_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.speed_limit_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SafetyCarContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: light_bar_siren_in_use
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "light_bar_siren_in_use:\n";
    to_block_style_yaml(msg.light_bar_siren_in_use, out, indentation + 2);
  }

  // member: incident_indication
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "incident_indication:\n";
    to_block_style_yaml(msg.incident_indication, out, indentation + 2);
  }

  // member: incident_indication_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "incident_indication_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.incident_indication_is_present, out);
    out << "\n";
  }

  // member: traffic_rule
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "traffic_rule:\n";
    to_block_style_yaml(msg.traffic_rule, out, indentation + 2);
  }

  // member: traffic_rule_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "traffic_rule_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.traffic_rule_is_present, out);
    out << "\n";
  }

  // member: speed_limit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speed_limit:\n";
    to_block_style_yaml(msg.speed_limit, out, indentation + 2);
  }

  // member: speed_limit_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speed_limit_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.speed_limit_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SafetyCarContainer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::SafetyCarContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::SafetyCarContainer & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::SafetyCarContainer>()
{
  return "etsi_its_cam_ts_msgs::msg::SafetyCarContainer";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::SafetyCarContainer>()
{
  return "etsi_its_cam_ts_msgs/msg/SafetyCarContainer";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::SafetyCarContainer>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_ts_msgs::msg::CauseCodeV2>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::LightBarSirenInUse>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::SpeedLimit>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::TrafficRule>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::SafetyCarContainer>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_ts_msgs::msg::CauseCodeV2>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::LightBarSirenInUse>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::SpeedLimit>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::TrafficRule>::value> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::SafetyCarContainer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SAFETY_CAR_CONTAINER__TRAITS_HPP_
