// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/SpecialVehicleContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SPECIAL_VEHICLE_CONTAINER__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SPECIAL_VEHICLE_CONTAINER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'CHOICE_PUBLIC_TRANSPORT_CONTAINER'.
enum
{
  etsi_its_cam_ts_msgs__msg__SpecialVehicleContainer__CHOICE_PUBLIC_TRANSPORT_CONTAINER = 0
};

/// Constant 'CHOICE_SPECIAL_TRANSPORT_CONTAINER'.
enum
{
  etsi_its_cam_ts_msgs__msg__SpecialVehicleContainer__CHOICE_SPECIAL_TRANSPORT_CONTAINER = 1
};

/// Constant 'CHOICE_DANGEROUS_GOODS_CONTAINER'.
enum
{
  etsi_its_cam_ts_msgs__msg__SpecialVehicleContainer__CHOICE_DANGEROUS_GOODS_CONTAINER = 2
};

/// Constant 'CHOICE_ROAD_WORKS_CONTAINER_BASIC'.
enum
{
  etsi_its_cam_ts_msgs__msg__SpecialVehicleContainer__CHOICE_ROAD_WORKS_CONTAINER_BASIC = 3
};

/// Constant 'CHOICE_RESCUE_CONTAINER'.
enum
{
  etsi_its_cam_ts_msgs__msg__SpecialVehicleContainer__CHOICE_RESCUE_CONTAINER = 4
};

/// Constant 'CHOICE_EMERGENCY_CONTAINER'.
enum
{
  etsi_its_cam_ts_msgs__msg__SpecialVehicleContainer__CHOICE_EMERGENCY_CONTAINER = 5
};

/// Constant 'CHOICE_SAFETY_CAR_CONTAINER'.
enum
{
  etsi_its_cam_ts_msgs__msg__SpecialVehicleContainer__CHOICE_SAFETY_CAR_CONTAINER = 6
};

// Include directives for member types
// Member 'public_transport_container'
#include "etsi_its_cam_ts_msgs/msg/detail/public_transport_container__struct.h"
// Member 'special_transport_container'
#include "etsi_its_cam_ts_msgs/msg/detail/special_transport_container__struct.h"
// Member 'dangerous_goods_container'
#include "etsi_its_cam_ts_msgs/msg/detail/dangerous_goods_container__struct.h"
// Member 'road_works_container_basic'
#include "etsi_its_cam_ts_msgs/msg/detail/road_works_container_basic__struct.h"
// Member 'rescue_container'
#include "etsi_its_cam_ts_msgs/msg/detail/rescue_container__struct.h"
// Member 'emergency_container'
#include "etsi_its_cam_ts_msgs/msg/detail/emergency_container__struct.h"
// Member 'safety_car_container'
#include "etsi_its_cam_ts_msgs/msg/detail/safety_car_container__struct.h"

/// Struct defined in msg/SpecialVehicleContainer in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__SpecialVehicleContainer
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
  ///   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  /// * This type represent the Special Vehicle Container.
  /// *
  /// * It shall include the following components:
  /// *
  /// * @field publicTransportContainer: If the vehicleRole component is set to publicTransport(1) this container shall be present.
  /// *
  /// * @field specialTransportContainer: If the vehicleRole component is set to specialTransport(2) this container shall be present.
  /// *
  /// * @field dangerousGoodsContainer: If the vehicleRole component is set to dangerousGoods(3) this container shall be present.
  /// *
  /// * @field roadWorksContainerBasic: If the vehicleRole component is set to roadWork(4) this container shall be present.
  /// *
  /// * @field rescueContainer: If the vehicleRole component is set to rescue(5) this container shall be present.
  /// *
  /// * @field emergencyContainer: If the vehicleRole component is set to emergency(6) this container shall be present.
  /// *
  /// * @field safetyCarContainer: If the vehicleRole component is set to safetyCar(7) this container shall be present.
  /// */
  /// SpecialVehicleContainer ::= CHOICE {
  ///  publicTransportContainer  PublicTransportContainer,
  ///  specialTransportContainer SpecialTransportContainer,
  ///  dangerousGoodsContainer   DangerousGoodsContainer,
  ///  roadWorksContainerBasic   RoadWorksContainerBasic,
  ///  rescueContainer           RescueContainer,
  ///  emergencyContainer        EmergencyContainer,
  ///  safetyCarContainer        SafetyCarContainer,
  ///  ...
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t choice;
  etsi_its_cam_ts_msgs__msg__PublicTransportContainer public_transport_container;
  etsi_its_cam_ts_msgs__msg__SpecialTransportContainer special_transport_container;
  etsi_its_cam_ts_msgs__msg__DangerousGoodsContainer dangerous_goods_container;
  etsi_its_cam_ts_msgs__msg__RoadWorksContainerBasic road_works_container_basic;
  etsi_its_cam_ts_msgs__msg__RescueContainer rescue_container;
  etsi_its_cam_ts_msgs__msg__EmergencyContainer emergency_container;
  etsi_its_cam_ts_msgs__msg__SafetyCarContainer safety_car_container;
} etsi_its_cam_ts_msgs__msg__SpecialVehicleContainer;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__SpecialVehicleContainer.
typedef struct etsi_its_cam_ts_msgs__msg__SpecialVehicleContainer__Sequence
{
  etsi_its_cam_ts_msgs__msg__SpecialVehicleContainer * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__SpecialVehicleContainer__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SPECIAL_VEHICLE_CONTAINER__STRUCT_H_
