// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/SpecialVehicleContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SPECIAL_VEHICLE_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SPECIAL_VEHICLE_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'public_transport_container'
#include "etsi_its_cam_ts_msgs/msg/detail/public_transport_container__struct.hpp"
// Member 'special_transport_container'
#include "etsi_its_cam_ts_msgs/msg/detail/special_transport_container__struct.hpp"
// Member 'dangerous_goods_container'
#include "etsi_its_cam_ts_msgs/msg/detail/dangerous_goods_container__struct.hpp"
// Member 'road_works_container_basic'
#include "etsi_its_cam_ts_msgs/msg/detail/road_works_container_basic__struct.hpp"
// Member 'rescue_container'
#include "etsi_its_cam_ts_msgs/msg/detail/rescue_container__struct.hpp"
// Member 'emergency_container'
#include "etsi_its_cam_ts_msgs/msg/detail/emergency_container__struct.hpp"
// Member 'safety_car_container'
#include "etsi_its_cam_ts_msgs/msg/detail/safety_car_container__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__SpecialVehicleContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__SpecialVehicleContainer __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SpecialVehicleContainer_
{
  using Type = SpecialVehicleContainer_<ContainerAllocator>;

  explicit SpecialVehicleContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : public_transport_container(_init),
    special_transport_container(_init),
    dangerous_goods_container(_init),
    road_works_container_basic(_init),
    rescue_container(_init),
    emergency_container(_init),
    safety_car_container(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->choice = 0;
    }
  }

  explicit SpecialVehicleContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : public_transport_container(_alloc, _init),
    special_transport_container(_alloc, _init),
    dangerous_goods_container(_alloc, _init),
    road_works_container_basic(_alloc, _init),
    rescue_container(_alloc, _init),
    emergency_container(_alloc, _init),
    safety_car_container(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->choice = 0;
    }
  }

  // field types and members
  using _choice_type =
    uint8_t;
  _choice_type choice;
  using _public_transport_container_type =
    etsi_its_cam_ts_msgs::msg::PublicTransportContainer_<ContainerAllocator>;
  _public_transport_container_type public_transport_container;
  using _special_transport_container_type =
    etsi_its_cam_ts_msgs::msg::SpecialTransportContainer_<ContainerAllocator>;
  _special_transport_container_type special_transport_container;
  using _dangerous_goods_container_type =
    etsi_its_cam_ts_msgs::msg::DangerousGoodsContainer_<ContainerAllocator>;
  _dangerous_goods_container_type dangerous_goods_container;
  using _road_works_container_basic_type =
    etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic_<ContainerAllocator>;
  _road_works_container_basic_type road_works_container_basic;
  using _rescue_container_type =
    etsi_its_cam_ts_msgs::msg::RescueContainer_<ContainerAllocator>;
  _rescue_container_type rescue_container;
  using _emergency_container_type =
    etsi_its_cam_ts_msgs::msg::EmergencyContainer_<ContainerAllocator>;
  _emergency_container_type emergency_container;
  using _safety_car_container_type =
    etsi_its_cam_ts_msgs::msg::SafetyCarContainer_<ContainerAllocator>;
  _safety_car_container_type safety_car_container;

  // setters for named parameter idiom
  Type & set__choice(
    const uint8_t & _arg)
  {
    this->choice = _arg;
    return *this;
  }
  Type & set__public_transport_container(
    const etsi_its_cam_ts_msgs::msg::PublicTransportContainer_<ContainerAllocator> & _arg)
  {
    this->public_transport_container = _arg;
    return *this;
  }
  Type & set__special_transport_container(
    const etsi_its_cam_ts_msgs::msg::SpecialTransportContainer_<ContainerAllocator> & _arg)
  {
    this->special_transport_container = _arg;
    return *this;
  }
  Type & set__dangerous_goods_container(
    const etsi_its_cam_ts_msgs::msg::DangerousGoodsContainer_<ContainerAllocator> & _arg)
  {
    this->dangerous_goods_container = _arg;
    return *this;
  }
  Type & set__road_works_container_basic(
    const etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic_<ContainerAllocator> & _arg)
  {
    this->road_works_container_basic = _arg;
    return *this;
  }
  Type & set__rescue_container(
    const etsi_its_cam_ts_msgs::msg::RescueContainer_<ContainerAllocator> & _arg)
  {
    this->rescue_container = _arg;
    return *this;
  }
  Type & set__emergency_container(
    const etsi_its_cam_ts_msgs::msg::EmergencyContainer_<ContainerAllocator> & _arg)
  {
    this->emergency_container = _arg;
    return *this;
  }
  Type & set__safety_car_container(
    const etsi_its_cam_ts_msgs::msg::SafetyCarContainer_<ContainerAllocator> & _arg)
  {
    this->safety_car_container = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t CHOICE_PUBLIC_TRANSPORT_CONTAINER =
    0u;
  static constexpr uint8_t CHOICE_SPECIAL_TRANSPORT_CONTAINER =
    1u;
  static constexpr uint8_t CHOICE_DANGEROUS_GOODS_CONTAINER =
    2u;
  static constexpr uint8_t CHOICE_ROAD_WORKS_CONTAINER_BASIC =
    3u;
  static constexpr uint8_t CHOICE_RESCUE_CONTAINER =
    4u;
  static constexpr uint8_t CHOICE_EMERGENCY_CONTAINER =
    5u;
  static constexpr uint8_t CHOICE_SAFETY_CAR_CONTAINER =
    6u;

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__SpecialVehicleContainer
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__SpecialVehicleContainer
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SpecialVehicleContainer_ & other) const
  {
    if (this->choice != other.choice) {
      return false;
    }
    if (this->public_transport_container != other.public_transport_container) {
      return false;
    }
    if (this->special_transport_container != other.special_transport_container) {
      return false;
    }
    if (this->dangerous_goods_container != other.dangerous_goods_container) {
      return false;
    }
    if (this->road_works_container_basic != other.road_works_container_basic) {
      return false;
    }
    if (this->rescue_container != other.rescue_container) {
      return false;
    }
    if (this->emergency_container != other.emergency_container) {
      return false;
    }
    if (this->safety_car_container != other.safety_car_container) {
      return false;
    }
    return true;
  }
  bool operator!=(const SpecialVehicleContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SpecialVehicleContainer_

// alias to use template instance with default allocator
using SpecialVehicleContainer =
  etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SpecialVehicleContainer_<ContainerAllocator>::CHOICE_PUBLIC_TRANSPORT_CONTAINER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SpecialVehicleContainer_<ContainerAllocator>::CHOICE_SPECIAL_TRANSPORT_CONTAINER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SpecialVehicleContainer_<ContainerAllocator>::CHOICE_DANGEROUS_GOODS_CONTAINER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SpecialVehicleContainer_<ContainerAllocator>::CHOICE_ROAD_WORKS_CONTAINER_BASIC;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SpecialVehicleContainer_<ContainerAllocator>::CHOICE_RESCUE_CONTAINER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SpecialVehicleContainer_<ContainerAllocator>::CHOICE_EMERGENCY_CONTAINER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SpecialVehicleContainer_<ContainerAllocator>::CHOICE_SAFETY_CAR_CONTAINER;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SPECIAL_VEHICLE_CONTAINER__STRUCT_HPP_
