// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/SpecialVehicleContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SPECIAL_VEHICLE_CONTAINER__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SPECIAL_VEHICLE_CONTAINER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/special_vehicle_container__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'public_transport_container'
#include "etsi_its_cam_ts_msgs/msg/detail/public_transport_container__traits.hpp"
// Member 'special_transport_container'
#include "etsi_its_cam_ts_msgs/msg/detail/special_transport_container__traits.hpp"
// Member 'dangerous_goods_container'
#include "etsi_its_cam_ts_msgs/msg/detail/dangerous_goods_container__traits.hpp"
// Member 'road_works_container_basic'
#include "etsi_its_cam_ts_msgs/msg/detail/road_works_container_basic__traits.hpp"
// Member 'rescue_container'
#include "etsi_its_cam_ts_msgs/msg/detail/rescue_container__traits.hpp"
// Member 'emergency_container'
#include "etsi_its_cam_ts_msgs/msg/detail/emergency_container__traits.hpp"
// Member 'safety_car_container'
#include "etsi_its_cam_ts_msgs/msg/detail/safety_car_container__traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SpecialVehicleContainer & msg,
  std::ostream & out)
{
  out << "{";
  // member: choice
  {
    out << "choice: ";
    rosidl_generator_traits::value_to_yaml(msg.choice, out);
    out << ", ";
  }

  // member: public_transport_container
  {
    out << "public_transport_container: ";
    to_flow_style_yaml(msg.public_transport_container, out);
    out << ", ";
  }

  // member: special_transport_container
  {
    out << "special_transport_container: ";
    to_flow_style_yaml(msg.special_transport_container, out);
    out << ", ";
  }

  // member: dangerous_goods_container
  {
    out << "dangerous_goods_container: ";
    to_flow_style_yaml(msg.dangerous_goods_container, out);
    out << ", ";
  }

  // member: road_works_container_basic
  {
    out << "road_works_container_basic: ";
    to_flow_style_yaml(msg.road_works_container_basic, out);
    out << ", ";
  }

  // member: rescue_container
  {
    out << "rescue_container: ";
    to_flow_style_yaml(msg.rescue_container, out);
    out << ", ";
  }

  // member: emergency_container
  {
    out << "emergency_container: ";
    to_flow_style_yaml(msg.emergency_container, out);
    out << ", ";
  }

  // member: safety_car_container
  {
    out << "safety_car_container: ";
    to_flow_style_yaml(msg.safety_car_container, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SpecialVehicleContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: choice
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "choice: ";
    rosidl_generator_traits::value_to_yaml(msg.choice, out);
    out << "\n";
  }

  // member: public_transport_container
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "public_transport_container:\n";
    to_block_style_yaml(msg.public_transport_container, out, indentation + 2);
  }

  // member: special_transport_container
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "special_transport_container:\n";
    to_block_style_yaml(msg.special_transport_container, out, indentation + 2);
  }

  // member: dangerous_goods_container
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dangerous_goods_container:\n";
    to_block_style_yaml(msg.dangerous_goods_container, out, indentation + 2);
  }

  // member: road_works_container_basic
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "road_works_container_basic:\n";
    to_block_style_yaml(msg.road_works_container_basic, out, indentation + 2);
  }

  // member: rescue_container
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rescue_container:\n";
    to_block_style_yaml(msg.rescue_container, out, indentation + 2);
  }

  // member: emergency_container
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "emergency_container:\n";
    to_block_style_yaml(msg.emergency_container, out, indentation + 2);
  }

  // member: safety_car_container
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "safety_car_container:\n";
    to_block_style_yaml(msg.safety_car_container, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SpecialVehicleContainer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer>()
{
  return "etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer>()
{
  return "etsi_its_cam_ts_msgs/msg/SpecialVehicleContainer";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_ts_msgs::msg::DangerousGoodsContainer>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::EmergencyContainer>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::PublicTransportContainer>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::RescueContainer>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::SafetyCarContainer>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::SpecialTransportContainer>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_ts_msgs::msg::DangerousGoodsContainer>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::EmergencyContainer>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::PublicTransportContainer>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::RescueContainer>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::RoadWorksContainerBasic>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::SafetyCarContainer>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::SpecialTransportContainer>::value> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::SpecialVehicleContainer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__SPECIAL_VEHICLE_CONTAINER__TRAITS_HPP_
