// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/SteeringWheelAngle.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__STEERING_WHEEL_ANGLE__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__STEERING_WHEEL_ANGLE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'steering_wheel_angle_value'
#include "etsi_its_cam_ts_msgs/msg/detail/steering_wheel_angle_value__struct.hpp"
// Member 'steering_wheel_angle_confidence'
#include "etsi_its_cam_ts_msgs/msg/detail/steering_wheel_angle_confidence__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__SteeringWheelAngle __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__SteeringWheelAngle __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SteeringWheelAngle_
{
  using Type = SteeringWheelAngle_<ContainerAllocator>;

  explicit SteeringWheelAngle_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : steering_wheel_angle_value(_init),
    steering_wheel_angle_confidence(_init)
  {
    (void)_init;
  }

  explicit SteeringWheelAngle_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : steering_wheel_angle_value(_alloc, _init),
    steering_wheel_angle_confidence(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _steering_wheel_angle_value_type =
    etsi_its_cam_ts_msgs::msg::SteeringWheelAngleValue_<ContainerAllocator>;
  _steering_wheel_angle_value_type steering_wheel_angle_value;
  using _steering_wheel_angle_confidence_type =
    etsi_its_cam_ts_msgs::msg::SteeringWheelAngleConfidence_<ContainerAllocator>;
  _steering_wheel_angle_confidence_type steering_wheel_angle_confidence;

  // setters for named parameter idiom
  Type & set__steering_wheel_angle_value(
    const etsi_its_cam_ts_msgs::msg::SteeringWheelAngleValue_<ContainerAllocator> & _arg)
  {
    this->steering_wheel_angle_value = _arg;
    return *this;
  }
  Type & set__steering_wheel_angle_confidence(
    const etsi_its_cam_ts_msgs::msg::SteeringWheelAngleConfidence_<ContainerAllocator> & _arg)
  {
    this->steering_wheel_angle_confidence = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::SteeringWheelAngle_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::SteeringWheelAngle_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::SteeringWheelAngle_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::SteeringWheelAngle_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::SteeringWheelAngle_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::SteeringWheelAngle_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::SteeringWheelAngle_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::SteeringWheelAngle_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::SteeringWheelAngle_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::SteeringWheelAngle_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__SteeringWheelAngle
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::SteeringWheelAngle_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__SteeringWheelAngle
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::SteeringWheelAngle_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SteeringWheelAngle_ & other) const
  {
    if (this->steering_wheel_angle_value != other.steering_wheel_angle_value) {
      return false;
    }
    if (this->steering_wheel_angle_confidence != other.steering_wheel_angle_confidence) {
      return false;
    }
    return true;
  }
  bool operator!=(const SteeringWheelAngle_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SteeringWheelAngle_

// alias to use template instance with default allocator
using SteeringWheelAngle =
  etsi_its_cam_ts_msgs::msg::SteeringWheelAngle_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__STEERING_WHEEL_ANGLE__STRUCT_HPP_
