// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/VehicleLength.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__VEHICLE_LENGTH__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__VEHICLE_LENGTH__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'vehicle_length_value'
#include "etsi_its_cam_ts_msgs/msg/detail/vehicle_length_value__struct.hpp"
// Member 'vehicle_length_confidence_indication'
#include "etsi_its_cam_ts_msgs/msg/detail/vehicle_length_confidence_indication__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__VehicleLength __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__VehicleLength __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VehicleLength_
{
  using Type = VehicleLength_<ContainerAllocator>;

  explicit VehicleLength_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : vehicle_length_value(_init),
    vehicle_length_confidence_indication(_init)
  {
    (void)_init;
  }

  explicit VehicleLength_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : vehicle_length_value(_alloc, _init),
    vehicle_length_confidence_indication(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _vehicle_length_value_type =
    etsi_its_cam_ts_msgs::msg::VehicleLengthValue_<ContainerAllocator>;
  _vehicle_length_value_type vehicle_length_value;
  using _vehicle_length_confidence_indication_type =
    etsi_its_cam_ts_msgs::msg::VehicleLengthConfidenceIndication_<ContainerAllocator>;
  _vehicle_length_confidence_indication_type vehicle_length_confidence_indication;

  // setters for named parameter idiom
  Type & set__vehicle_length_value(
    const etsi_its_cam_ts_msgs::msg::VehicleLengthValue_<ContainerAllocator> & _arg)
  {
    this->vehicle_length_value = _arg;
    return *this;
  }
  Type & set__vehicle_length_confidence_indication(
    const etsi_its_cam_ts_msgs::msg::VehicleLengthConfidenceIndication_<ContainerAllocator> & _arg)
  {
    this->vehicle_length_confidence_indication = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::VehicleLength_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::VehicleLength_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::VehicleLength_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::VehicleLength_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::VehicleLength_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::VehicleLength_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::VehicleLength_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::VehicleLength_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::VehicleLength_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::VehicleLength_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__VehicleLength
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::VehicleLength_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__VehicleLength
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::VehicleLength_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VehicleLength_ & other) const
  {
    if (this->vehicle_length_value != other.vehicle_length_value) {
      return false;
    }
    if (this->vehicle_length_confidence_indication != other.vehicle_length_confidence_indication) {
      return false;
    }
    return true;
  }
  bool operator!=(const VehicleLength_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VehicleLength_

// alias to use template instance with default allocator
using VehicleLength =
  etsi_its_cam_ts_msgs::msg::VehicleLength_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__VEHICLE_LENGTH__STRUCT_HPP_
