// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/VehicleLength.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__VEHICLE_LENGTH__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__VEHICLE_LENGTH__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/vehicle_length__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'vehicle_length_value'
#include "etsi_its_cam_ts_msgs/msg/detail/vehicle_length_value__traits.hpp"
// Member 'vehicle_length_confidence_indication'
#include "etsi_its_cam_ts_msgs/msg/detail/vehicle_length_confidence_indication__traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const VehicleLength & msg,
  std::ostream & out)
{
  out << "{";
  // member: vehicle_length_value
  {
    out << "vehicle_length_value: ";
    to_flow_style_yaml(msg.vehicle_length_value, out);
    out << ", ";
  }

  // member: vehicle_length_confidence_indication
  {
    out << "vehicle_length_confidence_indication: ";
    to_flow_style_yaml(msg.vehicle_length_confidence_indication, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const VehicleLength & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: vehicle_length_value
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vehicle_length_value:\n";
    to_block_style_yaml(msg.vehicle_length_value, out, indentation + 2);
  }

  // member: vehicle_length_confidence_indication
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vehicle_length_confidence_indication:\n";
    to_block_style_yaml(msg.vehicle_length_confidence_indication, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const VehicleLength & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::VehicleLength & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::VehicleLength & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::VehicleLength>()
{
  return "etsi_its_cam_ts_msgs::msg::VehicleLength";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::VehicleLength>()
{
  return "etsi_its_cam_ts_msgs/msg/VehicleLength";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::VehicleLength>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_ts_msgs::msg::VehicleLengthConfidenceIndication>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::VehicleLengthValue>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::VehicleLength>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_ts_msgs::msg::VehicleLengthConfidenceIndication>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::VehicleLengthValue>::value> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::VehicleLength>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__VEHICLE_LENGTH__TRAITS_HPP_
